
// ******************************************************************
//
// I. Matchikhilian, S. Shuvalov
//
// ******************************************************************

#ifndef _AC_ECAL_IFARM_H_
#define _AC_ECAL_IFARM_H_

extern "C" {

#include <stdio.h>
#include <math.h>
#include <string.h>

#include <sys/types.h>
#include <sys/stat.h> 
#include <errno.h> 
#include <unistd.h>
#include <sys/utsname.h>

#include "dq/DQ.h"
#include "rhp.h"
#include "component.h"

};

#include "arte/RSEG_cmp.hh"
#include "arte/arte.hh"
#include "farm/farm.hh"

#include <alca/AC_ecal_idefines.h>


#define AC_ECAL_ihists_hostname_prefix_default   "hb4lt"


typedef struct {
	  
  // 1. Physics:

  float                                           AC_ECAL_ihists_et_cut;
  float                                           AC_ECAL_ihists_ptrack_cut;
  float                                           AC_ECAL_ihists_ptrack_low;
  float                                           AC_ECAL_ihists_ncells_betw_tr_cl;
  float                                           AC_ECAL_ihists_isol_cut;
  float                                           AC_ECAL_ihists_ztrack_cut;

  // 2. Geometry:
  
  float                                           AC_ECAL_ihists_xmin;
  float                                           AC_ECAL_ihists_ymin;
  float                                           AC_ECAL_ihists_xcell;
  float                                           AC_ECAL_ihists_ycell;
  float                                           AC_ECAL_ihists_zcal;
  float                                           AC_ECAL_product;
  float                                           AC_ECAL_ihists_minx;
  float                                           AC_ECAL_ihists_miny;

  // 3. RHP Histogramms/ntuples:

  float                                           AC_ECAL_ihists_EPlow;
  float                                           AC_ECAL_ihists_EPup;
  float                                           AC_ECAL_ihists_MIPlow;
  float                                           AC_ECAL_ihists_MIPup;
  int                                             AC_ECAL_ihists_EP_NTUPLE_ID;
  int                                             AC_ECAL_ihists_MIP_NTUPLE_ID;
 
  // 4. Other:

  char                                            AC_ECAL_ihists_hostname_prefix[20];
  int                                             AC_ECAL_ihists_do;
  
} AC_ECAL_ihists_THINGS_TO_KNOW;                             


/*** 
 *    
 *    Function prototypes:
 *
 ***/


// 1. Should be called once at the begin:


void 
AC_ECAL_ihists_initialize(); 


// 2. Should be called once per each event:

void 
AC_ECAL_ihists_event();


// 3. Internal:
    	 
int AC_ECAL_ihists_get_neigb(float,
			     float,
			     short*,
			     short*,
			     short*);

int
CheckNeighbCells(float,
		 float,
		 short,
		 short,
		 short);
                     
#endif /*_AC_ECAL_IFARM_H_*/
