*-- Author :    Hartwig Albrecht   10/05/95

      SUBROUTINE MMRMIX (IOS)

************************************************************************
*
* Description: Mix several interactions into one event
*
* Called from: MMEVIN
*
* External references: MMRTAB, MMRDAT
*
* Argument in/out description
*   IOS    out    flag: -1: end of data
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "arte/ZIOCOM.fi"
#include "auto/MEMO.fi"
#include "auto/MEIO.fi"
#include "auto/MC.fi"

      INTEGER IOS, II, L, ILN, IHD,  LOCF, NI, NT, N, NN,
     +  KMTRA, KMVER,
     +  IEVHD, ITEMP, IMCIN, IMCME, IMTRA, IMVER, IMIMP, IMCAL, IEVFN,
     +  IMTCP, IRTRC, IRTMT, IRCMT, IRTRA, IRVER, IRCCL, IRREL, IRHIT
      CHARACTER C4*4, CNAME*80

#include "arte/Arte.ff"
#include "auto/MEMO.ff"
#include "auto/MEIO.ff"
#include "auto/MC.ff"
      IEVHD = LOCF(JEVHD) - LARLN1
      IEVFN = LOCF(JEVFN) - LARLN1
      ITEMP = LOCF(JTEMP) - LARLN1
      IMCIN = LOCF(JMCIN) - LARLN1
      IMCME = LOCF(JMCME) - LARLN1
      IMTRA = LOCF(JMTRA) - LARLN1
      IMVER = LOCF(JMVER) - LARLN1
      IMIMP = LOCF(JMIMP) - LARLN1
      IMCAL = LOCF(JMCAL) - LARLN1
      IMTCP = LOCF(JMTCP) - LARLN1
      IRTRC = LOCF(JRTRC) - LARLN1
      IRTMT = LOCF(JRTMT) - LARLN1
      IRCMT = LOCF(JRCMT) - LARLN1
      IRTRA = LOCF(JRTRA) - LARLN1
      IRVER = LOCF(JRVER) - LARLN1
      IRCCL = LOCF(JRCCL) - LARLN1
      IRREL = LOCF(JRREL) - LARLN1
      IRHIT = LOCF(JRHIT) - LARLN1

 10   IOS = 0
      NT = 0
      KMTRA = 0
      KMVER = 0

C loop over 4 event input files

      DO 400 L = 1, 4

C check that file mentioned on IOMIX card:

        IF (FIOMIX(L) .EQ. 0.)  THEN
          IF (IMEIO_FLAG(LEVIN(L)) .GT. 0)  GO TO 390
          GO TO 400
        END IF

C if mixing requested: the corresponding file name has to be given

        IF (IMEIO_FLAG(LEVIN(L)) .LE. 0)  GO TO 380

C Check that one did not ask to skip event records
      IF ( BITTEST(BMEMO_IOD(LOCF(JEVHD)-LARLN1), 1) .EQ. 0 .OR.
     +     BITTEST(BMEMO_IOD(LOCF(JEVHD)-LARLN1),
     +                          HMEIO_BIT(LEVIN(L))) .EQ. 0     ) THEN
        C78 = 'MMRMIX: EVHD not marked for input on'
        CALL CHHTOC (IQ(HQMEIO_STREAM(1,LEVIN(L))), CNAME)
        CALL CH78BC (CNAME)
        CALL CH78BC ('- an event input stream!')
        CALL ME78EC (534888)
        IOS = -1
        GO TO 900
      END IF

C Number of interactions - delta or Poisson distribution:

        IF (FIOMIX(L) .LT. 0.)  THEN
          NI = - NINT (FIOMIX(L))
        ELSE
          CALL POISSN (FIOMIX(L), NI, IHD)
        END IF

        IF (NI .LE. 0)  GO TO 370

C loop over events

        DO 300 II = 1, NI

C new record

 40       IHD = 0

C read

 50       CALL MMRTAB (LEVIN(L), IHD, ILN)

          IF (ILN) 60, 200, 70

C end of data

 60       IOS = -1
          GO TO 900

C header ?

 70       IF (IHD .EQ. 0)  THEN

C drop old table structure unless it is an event record

          IHD = ILN
          IF (IHD .NE. IEVHD .AND. JLINK(IHD) .NE. 0)
     +      CALL MMDROP (JLINK(IHD))
          END IF

C  drop empty tables

          IF (JLINK(ILN) .NE. 0 .AND.
     +      IQ(JLINK(ILN)+2) .EQ. 0)  CALL MMDROP (JLINK(ILN))

C read data into proper link if table empty or non-event record:

          IF (JLINK(ILN) .NE. 0 .AND. IHD .EQ. IEVHD)   GO TO 100

          CALL MMRDAT (LEVIN(L), IHD, ILN)
          GO TO 50

 100      CALL MMBWRK (JTEMP, 0, IMEMO_COL(ILN), 0)

C overwrite temporarily the name of table JTEMP
C with the name of table JLN; the same for output columns:
          
          IQ(IQMEMO_OCOL(ITEMP)) = IMEMO_OCOL(ILN)
          CALL CHHTOC (IQ(HQMEMO_NAME(1,ILN)), CNAME)
          CALL CHCTOH (CNAME, IQ(HQMEMO_NAME(1,ITEMP)), NAMELEN)
          CALL MMRDAT (LEVIN(L), IHD, ITEMP)
          CALL CHCTOH ('TEMP', IQ(HQMEMO_NAME(1,ITEMP)), NAMELEN)

          IF (ILN .EQ. IMIMP)  THEN

            IF (N_C(JMIMP) .NE. N_C(JTEMP))  GO TO 360
            NN = N_U(JMIMP)
            CALL MMBOOK (JMIMP, N_U(JTEMP))

            DO N = 1, N_U(JTEMP)
              IF (IQ(L_A(JMIMP_MTRA,N,JTEMP)) .NE. 0)
     +            IQ(L_A(JMIMP_MTRA,N,JTEMP)) =
     +            IQ(L_A(JMIMP_MTRA,N,JTEMP)) + KMTRA

            END DO
            DO N = 1, N_U(JTEMP) * N_C(JTEMP)
              IQ(JMIMP+IQ(JMIMP+1)*NN+2+N) = IQ(JTEMP+2+N)
            END DO

         ELSE IF (ILN .EQ. IMCAL)  THEN

           IF (N_C(JMCAL) .NE. N_C(JTEMP))  GO TO 360
           NN = N_U(JMCAL)
           CALL MMBOOK(JMCAL, N_U(JTEMP))

           DO N = 1 , N_U(JTEMP)
             IF (IQ(L_A(JMCAL_MTRA,N,JTEMP)) .NE. 0)
     +           IQ(L_A(JMCAL_MTRA,N,JTEMP)) =
     +           IQ(L_A(JMCAL_MTRA,N,JTEMP)) + KMTRA
           ENDDO

           DO N = 1 , N_U(JTEMP) * N_C(JTEMP)
             IQ(JMCAL+2+IQ(JMCAL+1)*NN+N)=IQ(JTEMP+2+N)
           ENDDO

           ELSE IF (ILN .EQ. IMTRA)  THEN

            IF (N_C(JMTRA) .NE. N_C(JTEMP))  GO TO 360
            NN = N_U(JMTRA)
            CALL MMBOOK (JMTRA, N_U(JTEMP))

            DO 130 N = 1, N_U(JTEMP)

              IF (IQ(L_A(JMTRA_ORIG,N,JTEMP)))  128, 130, 129

 128          IQ(L_A(JMTRA_ORIG,N,JTEMP)) =
     +        IQ(L_A(JMTRA_ORIG,N,JTEMP)) - KMTRA
              GO TO 130

 129          IQ(L_A(JMTRA_ORIG,N,JTEMP)) =
     +        IQ(L_A(JMTRA_ORIG,N,JTEMP)) + KMVER

 130        CONTINUE

            DO N = 1, N_U(JTEMP) * N_C(JTEMP)
              IQ(JMTRA+IQ(JMTRA+1)*NN+2+N) = IQ(JTEMP+2+N)
            END DO

          ELSE IF (ILN .EQ. IMVER)  THEN

            IF (N_C(JMVER) .NE. N_C(JTEMP))  GO TO 360

            NN = N_U(JMVER)
            CALL MMBOOK (JMVER, N_U(JTEMP))

            DO N = 1, N_U(JTEMP)
              IF (IQ(L_A(JMVER_BTRA,N,JTEMP)) .NE. 0)
     +            IQ(L_A(JMVER_BTRA,N,JTEMP)) =
     +            IQ(L_A(JMVER_BTRA,N,JTEMP)) + KMTRA
            END DO

            DO N = 1, N_U(JTEMP) * N_C(JTEMP)
              IQ(JMVER+IQ(JMVER+1)*NN+2+N) = IQ(JTEMP+2+N)
            END DO

          ELSE IF (ILN .EQ. IMTCP)  THEN

            IF (N_C(JMTCP) .NE. N_C(JTEMP))  GO TO 360

            NN = N_U(JMTCP)
            CALL MMBOOK (JMTCP, N_U(JTEMP))

            DO N = 1, N_U(JTEMP)
              IF (IQ(L_A(JMTCP_MTRA,N,JTEMP)) .NE. 0)
     +            IQ(L_A(JMTCP_MTRA,N,JTEMP)) =
     +            IQ(L_A(JMTCP_MTRA,N,JTEMP)) + KMTRA
            END DO

            DO N = 1, N_U(JTEMP) * N_C(JTEMP)
              IQ(JMTCP+IQ(JMTCP+1)*NN+2+N) = IQ(JTEMP+2+N)
            END DO

          ELSE IF (ILN .EQ. IMCME)  THEN

            IF (N_C(JMCME) .NE. N_C(JTEMP))  GO TO 360

            IF (N_U(JTEMP) .LT. 1)  CALL MEERRC (764525,
     +        'MMRMIX: attempt to mix non-MC events')

            IF (N_U(JTEMP) .GT. 1)  CALL MEERRC (935454,
     +        'MMRMIX: attempt to mix events twice')

            NN = N_U(JMCME)
            CALL MMBOOK (JMCME, N_U(JTEMP))

            DO N = 1, N_U(JTEMP)
              IF (IQ(L_A(JMCME_MVER,N,JTEMP)) .NE. 0)
     +            IQ(L_A(JMCME_MVER,N,JTEMP)) =
     +            IQ(L_A(JMCME_MVER,N,JTEMP)) + KMVER
            END DO

            DO N = 1, N_U(JTEMP) * N_C(JTEMP)
              IQ(JMCME+IQ(JMCME+1)*NN+2+N) = IQ(JTEMP+2+N)
            END DO

            IQ(L_L(JMCME_MVER,JMCME)) = KMVER + 1

          ELSE IF (ILN .EQ. IEVFN)  THEN

            IF (N_C(JEVFN) .NE. N_C(JTEMP))  GO TO 360

            NN = N_U(JEVFN)
            CALL MMBOOK (JEVFN, N_U(JTEMP))

            DO N = 1, N_U(JTEMP) * N_C(JTEMP)
              IQ(JEVFN+IQ(JEVFN+1)*NN+2+N) = IQ(JTEMP+2+N)
            END DO

          ELSE IF (ILN .EQ. IMCIN)  THEN

            NN = N_U(JMCIN)
            CALL MMBOOK (JMCIN, N_U(JTEMP))

            DO N = 1, N_U(JTEMP) * N_C(JTEMP)
              IQ(JMCIN+IQ(JMCIN+1)*NN+2+N) = IQ(JTEMP+2+N)
            END DO

          ELSE IF (ILN .EQ. IEVHD)  THEN

            IF (JEVHD .EQ. 0)  THEN
              NN = N_U(JEVHD)
              CALL MMBOOK (JEVHD, N_U(JTEMP))

              DO N = 1, N_U(JTEMP) * N_C(JTEMP)
                IQ(JEVHD+IQ(JEVHD+1)*NN+2+N) = IQ(JTEMP+2+N)
              END DO
            END IF

          ELSE IF (ILN .EQ. IRTRC)  THEN

c            IF (JRTRC .NE. 0)  GO TO 350
c            NN = N_U(JRTRC)
c            CALL MMBOOK (JRTRC, N_U(JTEMP))

c            DO N = 1, N_U(JTEMP) * N_C(JTEMP)
c              IQ(JRTRC+IQ(JRTRC+1)*NN+2+N) = IQ(JTEMP+2+N)
c            END DO

          ELSE IF (ILN .EQ. IRTMT)  THEN

c            IF (JRTMT .NE. 0)  GO TO 350
c            NN = N_U(JRTMT)
c            CALL MMBOOK (JRTMT, N_U(JTEMP))

c            DO N = 1, N_U(JTEMP) * N_C(JTEMP)
c              IQ(JRTMT+IQ(JRTMT+1)*NN+2+N) = IQ(JTEMP+2+N)
c            END DO

          ELSE IF (ILN .EQ. IRCMT)  THEN

c            IF (JRCMT .NE. 0)  GO TO 350
c            NN = N_U(JRCMT)
c            CALL MMBOOK (JRCMT, N_U(JTEMP))

c            DO N = 1, N_U(JTEMP) * N_C(JTEMP)
c              IQ(JRCMT+IQ(JRCMT+1)*NN+2+N) = IQ(JTEMP+2+N)
c            END DO

          ELSE IF (ILN .EQ. IRTRA .OR. ILN .EQ. IRVER .OR.
     +             ILN .EQ. IRCCL .OR. ILN .EQ. IRREL .OR.
     +             ILN .EQ. IRHIT)  THEN

             GO TO 350

          ELSE

C bank is not expected here

            C78 = 'MMRMIX: table'
            CALL CHHTOC (IQ(HQMEMO_NAME(1,ILN)), C4)
            CALL CH78BC (C4)
            CALL CH78BC ('is not expected on event mixing input')
            CALL ME78EC (13647)

          END IF

          GO TO 50

C special record ?

 200      IF (IHD .EQ. 0)  GO TO 50
          IF (IHD .NE. IEVHD)  THEN
            CALL USRSPC (LEVIN(L), JLINK(IHD))
            GO TO 40
          ELSE
            NT = NT + 1
          END IF

C next primary vertex (hopefully always the 1st one !)

          KMTRA = N_U(JMTRA)
          KMVER = N_U(JMVER)

 300    CONTINUE

        GO TO 400

 350    CALL MEERRC (135815,
     +  'MMRMIX: reconstructed events cannot be mixed')
        GO TO 900

 360    CALL MEERRC (135815,
     +  'MMRMIX: tables on different input files have different size')
        GO TO 900

 370    C78 = 'MMRMIX: no interaction selected from LEVI'
        CALL CH78AI (L)
        CALL ME78MC (832541, 10, ILARGEST)
        GO TO 400

 380    C78 = 'MMRMIX: no file given for LEVI'
        CALL CH78AI (L)
        CALL ME78EC (187264)
        GO TO 400

 390    C78 = 'MMRMIX: no mix information given for LEVI'
        CALL CH78AI (L)
        CALL ME78EC (27634)

 400  CONTINUE

      CALL MMBWRK (JTEMP, 0, 1, 0)
      CALL MMBOOK (JEVHD, 0)

      IF( JMIMP .GT. 0 .AND. NMIMP() .GT. 0 )
     & CALL SORTIQ(IQ(JMIMP+3),NCMIMP(),NMIMP(),JMIMP_GEDE)
      IF( JMCAL .GT. 0 .AND. NMCAL() .GT. 0 )
     & CALL SORTIQ(IQ(JMCAL+3),NCMCAL(),NMCAL(),JMCAL_GCAL)

      CALL MMRUPD (IEVHD)

      IF (NT .GT. 0)  GO TO 900

      CALL MEMESC (78534, 30, ILARGEST,
     +   'MMRMIX: event with 0 interactions')
      GO TO 10

 900  END

************************************************************************
* End of MMRMIX
************************************************************************
