*-- Author :    Hartwig Albrecht   14/07/95

      SUBROUTINE MMWTAB (LUN, IL, IFLAG)

************************************************************************
*
* Description: write one table
*
* Called from: MMWTMM
*
* External references: Zebra FZ
*
* Argument in/out description
*   LUN    in     logical unit
*   IL     in     pointer
*   IFLAG  out    0: ok; > 0: error; < 0: file is full
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "auto/MEMO.fi"
#include "auto/MEIO.fi"
#include "arte/ZQUEST.fi"

      INTEGER LUN, IL, INEW, IFLAG, IHEAD(2), I, J, K, IPACK
      CHARACTER C4*4

#include "arte/Arte.ff"
#include "auto/MEMO.ff"
#include "auto/MEIO.ff"

      IFLAG = 0
      IPACK = IMEIO_PACK(IMEIO_CURRENT(LUN))

      IHEAD(1) = HMEMO_NAME(1,IL)
      IHEAD(2) = HBLANKSP
      INEW = 0
      IF (IMEMO_SUP(1,IL) .EQ. 0)  INEW = 1

 10   IF (IPACK .EQ. 2) THEN
        CALL GARTWTAB (LUN, IL, INEW, IQUEST(1))
      ELSE
C                       Use temporary Zebra bank because of CM package
        IF (JZEBRA.NE.0)  CALL MZDROP (IMEMO_DIV(IL), JZEBRA, ' ')
        JZEBRA = 0
        IF (JLINK(IL) .EQ. 0)  CALL MMBOOK (JLINK(IL), 0)
        CALL MMFREE (JLINK(IL))
        CALL CHHTOC (IQ(HQMEMO_NAME(1,IL)), C4)

        CALL MZBOOK (IMEMO_DIV(IL), JZEBRA, 0, 2, C4, 0, 0,
     +               IQ(JLINK(IL)+1) * IQ(JLINK(IL)+2) + 2,
     +               IMEMO_FMT(IL), 0)

        IQ(JZEBRA+1) = IMEMO_OCOL(IL)
        IQ(JZEBRA+2) = IQ(JLINK(IL)+2)
        K = 3
        DO I = 1, N_U(JLINK(IL))
          DO J = 1, IMEMO_OCOL(IL)
            IQ(JZEBRA+K) = I_V(J, I, JLINK(IL))
            K = K + 1
          END DO
        END DO
        
        CALL FZOUT
     +      (LUN, IMEMO_DIV(IL), JZEBRA, INEW, 'S', 5, 2, IHEAD)
                
        I = IQUEST(1)
        CALL MZDROP (IMEMO_DIV(IL), JZEBRA, ' ')
        JZEBRA = 0
        IQUEST(1) = I
      ENDIF

      IF (IQUEST(1) .LT. 0)  THEN
        C78 = 'MMWTAB: write error on lun'
        CALL CH78BI (LUN)
        CALL CH78BC ('for table')
        CALL CHHTOC (IQ(HQMEMO_NAME(1,IL)), C4)
        CALL CH78BC (C4)
        CALL ME78EC (5135734)
        IFLAG = 1
        GO TO 90

      ELSE IF (IQUEST(1) .GT. 0)  THEN
        IF (IPACK .EQ. 2) THEN
          CALL GARTLIMI (LUN, 0.)
        ELSE
          CALL FZLIMI (LUN, 0.)
        ENDIF
        IFLAG = -1
      END IF

      IQ(IQMEMO_NOUT(IL)) = IQ(IQMEMO_NOUT(IL)) + 1

 90   END

************************************************************************
* End of MMWTAB
************************************************************************
