//                              -*- Mode: C++ -*-
//: CmdCareLightYield.hh
//
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 1/12/99
// Last Update ........
//

#ifndef CMDCARELIGHTYIELD_HH_
#define CMDCARELIGHTYIELD_HH_

#include "care/CmdBase.hh" 

/*
CLASS
  LightYield
  Class to deal with the care/LightYield kuip command
  Define the correction functions to apply to the energy for
  th light yield non-uniformity.

*/

class CmdCareLightYield : public CmdBase {
public:

  //-- Constructors
  CmdCareLightYield();
  //-- Destructor
  // Destructor: currently void
  virtual ~CmdCareLightYield();
  
  //-- Behavioural operations
  //   Reset stored data to default values
  virtual void defValues();
  //--g
  //   Execute stored command
  virtual void execute();

# ifdef USEKUIP
  //--
  //   Read acommand from external
  virtual void read();
# endif
  //--
  //   Dump internal data
  virtual void dump();

private:
  
  ///////////////////// Data Part /////////////////////////////////
  //--
  int cal;
  int type;
  int degree;
  enum {maxcoeff=11};
  float coeff[maxcoeff];
};


#endif  //   CMDCARELIGHTYIELD_HH_

