// CmdCarePid04.hh
//
// ECAL group 
// HERA-B experiment, Desy
// e-mail: spighi@bo.infn.it
//
// Created 1/9/97
// Last Update ........
//

#ifndef CMDCAREPID04_HH_
#define CMDCAREPID04_HH_

#include "care/CmdBase.hh" 


/**
class  CmdCarePid04par
  Class to deal with the CAREPID04PAR kuip command
*/

class CmdCarePid04par : public CmdBase {
public:
  /// Constructor
  CmdCarePid04par();
  /// Destructor
  virtual ~CmdCarePid04par();
  
  //-- Behavioural operations
  ///   Reset stored data to default values
  virtual void defValues();
  //--
  ///   Execute stored command
  virtual void execute();
# ifdef USEKUIP
  //--
  ///   Read a command from external source
  virtual void read();
# endif
  //--
  ///   Dump internal data
  virtual void dump();

private:
 
  //--
  int  cal;
  int particle;
  float like04[9];
};

#endif  //  CMDCAREPID04_HH_












