//                              -*- Mode: C++ -*-
//: ESCTCDisStrat.hh
//
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 12/6/97
// Last Update ........
//

#ifndef ESCTCDISSTRAT_HH_
#define ESCTCDISSTRAT_HH_

#include "care/ECALtypes.hh"

class EMCluster;

/**
class  ESCTCDisStrat.
  Abstract class to define the base interface for the Cluster-To-Cluster
  distance measuring strategy.
*/

class ESCTCDisStrat  {
public:
 
  /// Constructor
  ESCTCDisStrat();
  //-- 
  /// Destructor: currently void but needs to be virtual
  virtual ~ESCTCDisStrat();
  
  //-- Behavioural operations
 
  /**@name Beheavioral methods */
  //@{ 
  ///   set the reference cluster to which distances must be evaluated.
  virtual void refCluster(EMCluster* clus) = 0;
  //--
  ///   evaluate the position for a cluster.

  virtual ChiSquare_t evaluateDis(EMCluster* clus) = 0;
  //@}
 
  //   Access functions 
  //--
  ///   Inquire for the distance stored (in terms of chisquare).
  inline ChiSquare_t getDist() const{ return  dist;};
  //--
  /// test if the clusters areDifferent
  virtual bool areDifferent() const = 0;

protected:
  //                    Data Part                     //
  //--
  ///  distance stored in terms of a chisquare
  ChiSquare_t  dist;
  //
};

#endif  //   ESCTCDISSTRAT_HH_
