//                              -*- Mode: C++ -*-
//:MMBanks.hh
//
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 9/4/97
// Last Update ........
//
#ifndef MMBanks_HH_
#define MMBanks_HH_

/**
  Interfaces with the MM package
  */
#ifndef ONLINE
extern "C" {
  void mmbook_( int& link, const int &number );
  void mmdrop_( int& link );
}
#endif

template <class T> 
class MMBank {
public:
  /// empty constructor
  MMBank(){};
  /// empty destructor
  ~MMBank(){};

  /// Book a bank with number entries
  static inline void Book( int number );

  /// Drop the bank
  static inline void Drop();

};
/// Book a bank with number entries

#ifndef ONLINE
  template <class T>  
  void MMBank<T>::Book( int number ){
    mmbook_(ArtePointer<T>::getLink().getRef(), number);
  };

  template <class T>  
  void MMBank<T>::Drop(){
    mmdrop_(ArtePointer<T>::getLink().getRef());
  };

#else

  template <class T>  
  void MMBank<T>::Book( int number ){
    T x;
    for( int i=0; i<number; i++){
      ArtePointer<T>::append(x);
    }
  };

  /// Drop the bank
  template <class T>  
  void MMBank<T>::Drop(){
    ArtePointer<T>::removeAll();
  };

#endif // ONLINE
#endif // MMBanks_HH_


