#ifndef __OTR_CATS_HH__
#define __OTR_CATS_HH__

#include <arte/arte.hh>
#include <arte/artefunc.h>
#include <vector>
#include <map>
#include <algorithm>
#include "cats/OtrCluster.hh"
#include "cats/OtrSPoint.hh"

typedef struct{
  float zf, xf, yf, txf, tyf;
  float ze, xe, ye, txe, tye;
  float cvf[4][4], cve[4][4];
  float pf, pe;
  float chi2, prob;
  int   good, nonmask, nsp, nclu;
  map<ArtePointer<GESL>, pSPACEPOINT> pspointmap; 
  vector<pCLUSTER >          vpcluster; // sorted 
  vector<pHIT>               vphit;     // sorted 
  vector<EST>                vest;
} TRACK, *pTRACK;

extern void OtrCatsEvent(void);

#endif
