// ********************************************************************
//
// source:
//
// type:      source code
//
// created:   23. Jul 1999
//
// author:    Thorsten Glebe
//            HERA-B Collaboration
//            Max-Planck-Institut fuer Kernphysik
//            Saupfercheckweg 1
//            69117 Heidelberg
//            Germany
//            E-mail: T.Glebe@mpi-hd.mpg.de
//
// Description: ARTE constructor for MC_Vertex
//
// changes:
// 23 Jul 1999 creation by C. Borgmeier
// 22 Nov 2000 (TG) added namespace CLUE
// 12 Jan 2001 (TG) changed constructor
// 14 Aug 2001 (TG) added out, Mother
//
// ********************************************************************

#include "clue/cluearte.hh"
#include "clue/MC_Vertex.hh"

#ifdef NAMESPACE
namespace CLUE {
#endif

  MC_Vertex::MC_Vertex( const ArtePointer<MVER>& mv ) :
    out   (),
    X     ( mv->x ),
    Y     ( mv->y ),
    Z     ( mv->z ),
    Mother( getIDX<MTRA>(mv->btra) ) {}

#ifdef NAMESPACE
} // namespace CLUE
#endif
