// *****************************************************************************
//
// source:    daq_rich_if.C
//
// type:      source code
//
// created:   13 Mar 2001
//
// author:    Lars Soezueer
//            email: soezueer@mail.desy.de
//
// purpose:   functions to deliver FED IDs and contents to the class
//            DAQ_RICH_IF
//            called by DAQ_MC_IF::buildFED and DAQ_UNSPARSE_IF::setSLBs
//
// changes:   
//
// *****************************************************************************
#include "daqif/daq_rich_if.hh"
#include "rich/RICHDAQ.h"

extern "C" {
#include "esp.h"
	   }

int get_Num_RICH_FED();
int get_RICH_FED(short fedid, FED_HDR  *rich_fed_hdr);

unsigned int DAQ_RICH_IF::getFED_IDs(unsigned short *buf, unsigned int maxIDs)
{
  unsigned int nFEDs = get_Num_RICH_FED();

  unsigned int upLim = (nFEDs > maxIDs) ? maxIDs : nFEDs;

  // The RICH FED ids are numbered consecutively from zero. (D. Dujmic priv. comm.)

  for(unsigned short i = 0; i < upLim; i++)
    buf[i] = i;

  return upLim;
}

int DAQ_RICH_IF::getFED(unsigned short fedid, FED_HDR *buf, unsigned int maxSize)
{
  int nBytes = get_RICH_FED(fedid, buf);

  return nBytes;
}
