// *****************************************************************************
//
// source:    daq_unsparse_if.hh
//
// type:      header file
//
// created:   13 Mar 2001
//
// author:    Lars Soezueer
//            email: soezueer@mail.desy.de
//
// purpose:   intermediate class declaration for unsparsified components
//
// changes:   
//
// *****************************************************************************
#ifndef _DAQ_UNSPARSE_IF_
#define _DAQ_UNSPARSE_IF_

#include "daqif/daq_mc_if.hh"

class DAQ_UNSPARSE_IF : public DAQ_MC_IF {

public:

  virtual unsigned int getFED_IDs(unsigned short *buf, unsigned int maxIDs) = 0;
  virtual int getFED(unsigned short fedid, FED_HDR *buf, unsigned int maxSize) = 0;

  // return total number of SLBs for this component (default=1)
  unsigned int getN_SLBs(void);

  int prepare(void); // status return

  void setSLBs(void); // called on first call to getN_SLBs

protected:

  DAQ_UNSPARSE_IF(int component_id = -1);

private:

};

#endif
