
// ******************************************************************
//
// D. Samtleben 10 Aug 1999
//
// Filling of histograms
//
// changes:
// 28 Oct 1999 (AG)  use defines from DQ.h
// 06 Dec 1999 (CP)  add trigger codes 9
// 24 Oct 2001 (JH)  remove some printouts
// 18 Feb 2002 (WG)  add ITR to correlation histograms
// 08 Jun 2002 (MBr) change BX histos for 2002 trig-codes
// ******************************************************************

// standard includes
#include <stdlib.h>
#include <stdio.h>

// ONLINE includes
#include "rhp.h"
#include "event.h"

// Arte includes
#include "arte/arte.hh"
#include "farm/farm.hh"
#include "dq/DQ.h"
#include "dq/DQ_CORR.h"

//
// function code
//
int
DQ_CORR_hit_evnt()
{
  float NrSVDHits=0;
  float NrOTRHits=0;
  float NrITRHits=0;
  float NrTRDHits=0;
  float NrSTRAWHits=0;
  float NrRICHHits=0;
  float NrHighPtHits=0;
  float NrMUONTubeHits=0;
  float NrMUONPixelHits=0;
  float NrMUONHits=0;
  float NrECALHits=ArtePointer<HITC>::nrow();
//====================================================================
//     loop over HITB to count the hits in the different subdetectors
//====================================================================
 
for( ArteTableIterator<HITB> hitb; hitb.valid(); hitb.next() ){
 
      ArtePointer<GEDE> gede(hitb->gede); 
 
//------------------------------------------------------------------------    
//      VDS 
//------------------------------------------------------------------------
      if(gede->cmp==1) {
          NrSVDHits++;
        }
//------------------------------------------------------------------------
//      OTR 
//------------------------------------------------------------------------
      if(gede->cmp==2) {
           NrOTRHits++;
      }

//------------------------------------------------------------------------
//      ITR 
//------------------------------------------------------------------------
      if(gede->cmp==3) {
           NrITRHits++;
      }
       
//------------------------------------------------------------------------
//      HPT 
//------------------------------------------------------------------------
      if(gede->cmp==4) {
          NrHighPtHits++;
        }
//------------------------------------------------------------------------
//      RICH 
//------------------------------------------------------------------------
      if(gede->cmp==5) {
          NrRICHHits++;
      }
//------------------------------------------------------------------------
//      TRD 
//------------------------------------------------------------------------
      if(gede->cmp==6){
          if(strncmp(gede->gesl->name,"TR02",4)==0){
              if(gede->sec==10) {// straw
                NrSTRAWHits++;
	      } else {
		NrTRDHits++;
	      }
	  }
          if(strncmp(gede->gesl->name,"TR01",4)==0) {
	    NrTRDHits++;
	  }
}
//------------------------------------------------------------------------
//      MUON 
//------------------------------------------------------------------------
      if(gede->cmp==8) { // tube chambers
	NrMUONTubeHits++;
      }
      if(gede->cmp==9) { // pixel chambers
        NrMUONPixelHits++;
      }
      // NrMUONHits=NrMUONTubeHits+NrMUONPixelHits;
} // loop over hitb
 
//====================================================================
//       Synchronization histograms
//====================================================================
  rhp_hfill(DQ_ID(COMP_CORR,LVL_HIT,12),NrSVDHits,NrOTRHits,1);
  rhp_hfill(DQ_ID(COMP_CORR,LVL_HIT,13),NrSVDHits,NrITRHits,1);
  rhp_hfill(DQ_ID(COMP_CORR,LVL_HIT,14),NrSVDHits,NrHighPtHits,1);
  rhp_hfill(DQ_ID(COMP_CORR,LVL_HIT,15),NrSVDHits,NrRICHHits,1);
  rhp_hfill(DQ_ID(COMP_CORR,LVL_HIT,16),NrSVDHits,NrTRDHits,1);
  rhp_hfill(DQ_ID(COMP_CORR,LVL_HIT,17),NrSVDHits,NrECALHits,1);
  //rhp_hfill(DQ_ID(COMP_CORR,LVL_HIT,18),NrSVDHits,NrMUONHits,1);
 
  rhp_hfill(DQ_ID(COMP_CORR,LVL_HIT,23),NrOTRHits,NrITRHits,1);
  rhp_hfill(DQ_ID(COMP_CORR,LVL_HIT,24),NrOTRHits,NrHighPtHits,1);
  rhp_hfill(DQ_ID(COMP_CORR,LVL_HIT,25),NrOTRHits,NrRICHHits,1);
  rhp_hfill(DQ_ID(COMP_CORR,LVL_HIT,26),NrOTRHits,NrTRDHits,1);
  rhp_hfill(DQ_ID(COMP_CORR,LVL_HIT,27),NrOTRHits,NrECALHits,1);
  //rhp_hfill(DQ_ID(COMP_CORR,LVL_HIT,28),NrOTRHits,NrMUONHits,1);
  
  rhp_hfill(DQ_ID(COMP_CORR,LVL_HIT,34),NrITRHits,NrHighPtHits,1);
  rhp_hfill(DQ_ID(COMP_CORR,LVL_HIT,35),NrITRHits,NrRICHHits,1);

  rhp_hfill(DQ_ID(COMP_CORR,LVL_HIT,45),NrHighPtHits,NrRICHHits,1);
  rhp_hfill(DQ_ID(COMP_CORR,LVL_HIT,46),NrHighPtHits,NrTRDHits,1);
  rhp_hfill(DQ_ID(COMP_CORR,LVL_HIT,47),NrHighPtHits,NrECALHits,1);
  //rhp_hfill(DQ_ID(COMP_CORR,LVL_HIT,48),NrHighPtHits,NrMUONHits,1);
  
  rhp_hfill(DQ_ID(COMP_CORR,LVL_HIT,56),NrRICHHits,NrTRDHits,1);
  rhp_hfill(DQ_ID(COMP_CORR,LVL_HIT,57),NrRICHHits,NrECALHits,1);
  rhp_hfill(DQ_ID(COMP_CORR,LVL_HIT,58),NrRICHHits,NrMUONTubeHits, 1);
  rhp_hfill(DQ_ID(COMP_CORR,LVL_HIT,59),NrRICHHits,NrMUONPixelHits,1);
  
  rhp_hfill(DQ_ID(COMP_CORR,LVL_HIT,67),NrTRDHits,NrECALHits,1);
  //rhp_hfill(DQ_ID(COMP_CORR,LVL_HIT,68),NrTRDHits,NrMUONHits,1);
  
  rhp_hfill(DQ_ID(COMP_CORR,LVL_HIT,78),NrECALHits,NrMUONTubeHits, 1);
  rhp_hfill(DQ_ID(COMP_CORR,LVL_HIT,79),NrECALHits,NrMUONPixelHits,1);
 
//------------------------------------------------------------------------
//       BX histograms
//------------------------------------------------------------------------
  ArtePointer<DIHD>dihd(1);
  int BX_number = dihd->bx;

  float ia = faDTARia();

  int tcode = faDDAQFCS_tcode();

  // change (MBr): for 2002 trig-code = 32 (bit 5) for MinBias
  //  MinBias      : separated,
  //  all triggers : id+50
  int trigflag = 0; // MinBias
  if( (tcode & 32) == 0 ) trigflag = 50; // all non-MinBias triggers

  if( ia!=0.0f ) { // Interaction rate != 0
    rhp_hf1(DQ_ID(COMP_CORR,LVL_HIT,100+trigflag),BX_number,1);
    rhp_hf1(DQ_ID(COMP_CORR,LVL_HIT,101+trigflag),BX_number,NrSVDHits);
    rhp_hf1(DQ_ID(COMP_CORR,LVL_HIT,102+trigflag),BX_number,NrOTRHits);
    rhp_hf1(DQ_ID(COMP_CORR,LVL_HIT,103+trigflag),BX_number,NrITRHits);
    rhp_hf1(DQ_ID(COMP_CORR,LVL_HIT,104+trigflag),BX_number,NrHighPtHits);
    rhp_hf1(DQ_ID(COMP_CORR,LVL_HIT,105+trigflag),BX_number,NrRICHHits);
    rhp_hf1(DQ_ID(COMP_CORR,LVL_HIT,106+trigflag),BX_number,NrTRDHits);
    rhp_hf1(DQ_ID(COMP_CORR,LVL_HIT,107+trigflag),BX_number,NrECALHits);
    rhp_hf1(DQ_ID(COMP_CORR,LVL_HIT,108+trigflag),BX_number,NrMUONHits);
    //-------------------------------------------------------------
    //       Normalization factor
    //-------------------------------------------------------------
    rhp_hf1(DQ_ID(COMP_CORR,LVL_HIT,101+trigflag),221.,1.);
    rhp_hf1(DQ_ID(COMP_CORR,LVL_HIT,102+trigflag),221.,1.);
    rhp_hf1(DQ_ID(COMP_CORR,LVL_HIT,103+trigflag),221.,1.);
    rhp_hf1(DQ_ID(COMP_CORR,LVL_HIT,104+trigflag),221.,1.);
    rhp_hf1(DQ_ID(COMP_CORR,LVL_HIT,105+trigflag),221.,1.);
    rhp_hf1(DQ_ID(COMP_CORR,LVL_HIT,106+trigflag),221.,1.);
    rhp_hf1(DQ_ID(COMP_CORR,LVL_HIT,107+trigflag),221.,1.);
    rhp_hf1(DQ_ID(COMP_CORR,LVL_HIT,108+trigflag),221.,1.);
  } // if rate != 0
 
//-------------------------------------------------------------------------
//       get the run-number
//-------------------------------------------------------------------------
  ArtePointer<EVHD> evhd(1);
 
  rhp_hf1(DQ_ID(COMP_CORR,LVL_HIT,201),evhd->run,1);

  return 0; // return error code (0 = okay)
}
