
// ******************************************************************
//
// D. Samtleben 10 Aug 1999
//
// Declaration of Histograms and Initialization
//
// changes:
// 28 Oct 1999 (AG)  use defines from DQ.h
// 06 Dec 1999 (CP)  add trigger codes 9
// 18 Feb 2002 (WG)  add ITR to correlation histograms
// 08 Jun 2002 (MBr) change BX histos for 2002 trig-codes
// 18 Jun 2002 (MBr) adaption of correlation histos, my -> tube+pad
//
// ******************************************************************

// standard includes
#include <stdlib.h>
#include <stdio.h>

// ONLINE includes
#include "rhp.h"

// Arte includes
#include "arte/arte.hh"
#include "dq/DQ.h"
#include "dq/DQ_CORR.h"

//
// function code
//
int
DQ_CORR_hit_init()
{
//======================================================================
//          Synchronization histograms
//======================================================================

  int iVDSc  =  50;float fVDSs  = 0.01;float fVDSb  =   999.99;
  int iOTRc  =  65;float fOTRs  = 0.01;float fOTRb  = 12999.99;
  int iITRc  =  45;float fITRs  = 0.01;float fITRb  =  2999.99;
  int iHIPTc =  50;float fHIPTs = 0.01;float fHIPTb =   999.99;
  int iRICHc =  70;float fRICHs = 0.01;float fRICHb =  3499.99;
  int iTRDc  =  25;float fTRDs  = 0.01;float fTRDb  =   249.99;
  int iECALc =  50;float fECALs = 0.01;float fECALb =   999.99;
  int iMUTUc =  50;float fMUTUs = 0.01;float fMUTUb =   499.99;
  int iMUPIc =  50;float fMUPIs = 0.01;float fMUPIb =   499.99;

  rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,12),"CORR: Hits in OTR vs Hits in SVD",    
	     iVDSc, fVDSs, fVDSb,  iOTRc,fOTRs, fOTRb);
  rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,13),"CORR: Hits in ITR vs Hits in SVD",    
	     iVDSc, fVDSs, fVDSb,  iITRc, fITRs, fITRb );
  rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,14),"CORR: Hits in HIPT vs Hits in SVD",   
	     iVDSc, fVDSs, fVDSb,  iHIPTc, fHIPTs, fHIPTb);
  rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,15),"CORR: Hits in RICH vs Hits in SVD",   
	     iVDSc, fVDSs, fVDSb,  iRICHc, fRICHs, fRICHb);
  rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,16),"CORR: Hits in TRD vs Hits in SVD",    
	     iVDSc, fVDSs, fVDSb,  iTRDc, fTRDs, fTRDb);
  rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,17),"CORR: Hits in ECAL vs Hits in SVD",   
	     iVDSc, fVDSs, fVDSb,  iECALc, fECALs, fECALb);
  //rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,18),"CORR: Hits in MUON vs Hits in SVD",   
  //           );
 
  rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,23),"CORR: Hits in ITR vs Hits in OTR",
	     iOTRc, fOTRs, fOTRb,  iITRc, fITRs, fITRb);
  rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,24),"CORR: Hits in HIPT vs Hits in OTR",
	     iOTRc, fOTRs, fOTRb,  iHIPTc, fHIPTs, fHIPTb);
  rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,25),"CORR: Hits in RICH vs Hits in OTR",
	     iOTRc, fOTRs, fOTRb,  iRICHc, fRICHs, fRICHb);
  rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,26),"CORR: Hits in TRD vs Hits in OTR",
	     iOTRc, fOTRs, fOTRb,  iTRDc, fTRDs, fTRDb);
  rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,27),"CORR: Hits in ECAL vs Hits in OTR",
	     iOTRc, fOTRs, fOTRb,  iECALc, fECALs, fECALb);
  //rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,28),"CORR: Hits in MUON vs Hits in OTR",
  //             );
 
  rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,34),"CORR: Hits in HIPT vs Hits in ITR",
	     iITRc, fITRs, fITRb,  iHIPTc, fHIPTs, fHIPTb);
  rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,35),"CORR: Hits in RICH vs Hits in ITR",
	     iITRc, fITRs, fITRb,  iRICHc, fRICHs, fRICHb);

  rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,45),"CORR: Hits in RICH vs Hits in HIPT",
	     iRICHc, fRICHs, fRICHb,  iRICHc, fRICHs, fRICHb);
  rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,46),"CORR: Hits in TRD vs Hits in HIPT",
	     iRICHc, fRICHs, fRICHb,  iTRDc, fTRDs, fTRDb);
  rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,47),"CORR: Hits in ECAL vs Hits in HIPT",
	     iRICHc, fRICHs, fRICHb,  iECALc, fECALs, fECALb);
  //rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,48),"CORR: Hits in MUON vs Hits in HIPT",
  //             150,0, 300, 50,0,4000);
 
  rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,56),"CORR: Hits in TRD vs Hits in RICH",   
	     iRICHc, fRICHs, fRICHb,  iTRDc, fTRDs, fTRDb);
  rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,57),"CORR: Hits in ECAL vs Hits in RICH",  
	     iRICHc, fRICHs, fRICHb,  iECALc, fECALs, fECALb);
  rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,58),"CORR: Hits in MUONtube  vs Hits in RICH",  
	     iRICHc, fRICHs, fRICHb,  iMUTUc, fMUTUs, fMUTUb);
  rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,59),"CORR: Hits in MUONpixel vs Hits in RICH",
	     iRICHc, fRICHs, fRICHb,  iMUPIc, fMUPIs, fMUPIb);
 
  rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,67),"CORR: Hits in ECAL vs Hits in TRD",
	     iECALc, fECALs, fECALb,  iTRDc, fTRDs, fTRDb);
  //rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,68),"CORR: Hits in MUON vs Hits in TRD",
  //             20,0,  20, 50,0,4000);
 
  rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,78),"CORR: Hits in MUONtube  vs Hits in ECAL",
	     iECALc, fECALs, fECALb,  iMUTUc, fMUTUs, fMUTUb);
  rhp_hbook2(DQ_ID(COMP_CORR,LVL_HIT,79),"CORR: Hits in MUONpixel vs Hits in ECAL",  
	     iECALc, fECALs, fECALb,  iMUPIc, fMUPIs, fMUPIb);
 
//======================================================================
//          BX histograms
//======================================================================
 rhp_hbook1(DQ_ID(COMP_CORR,LVL_HIT,100),"CORR: MinBias BX number distribution",222,-0.5,221.5);
 rhp_hbook1(DQ_ID(COMP_CORR,LVL_HIT,101),"CORR: MinBias SVD hits in BX",        222,-0.5,221.5);
 rhp_hbook1(DQ_ID(COMP_CORR,LVL_HIT,102),"CORR: MinBias OTR hits in BX",        222,-0.5,221.5);
 rhp_hbook1(DQ_ID(COMP_CORR,LVL_HIT,103),"CORR: MinBias ITR hits in BX",        222,-0.5,221.5);
 rhp_hbook1(DQ_ID(COMP_CORR,LVL_HIT,104),"CORR: MinBias HIPT hits in BX",       222,-0.5,221.5);
 rhp_hbook1(DQ_ID(COMP_CORR,LVL_HIT,105),"CORR: MinBias RICH hits in BX",       222,-0.5,221.5);
 rhp_hbook1(DQ_ID(COMP_CORR,LVL_HIT,106),"CORR: MinBias TRD hits in BX",        222,-0.5,221.5);
 rhp_hbook1(DQ_ID(COMP_CORR,LVL_HIT,107),"CORR: MinBias ECAL hits in BX",       222,-0.5,221.5);
 rhp_hbook1(DQ_ID(COMP_CORR,LVL_HIT,108),"CORR: MinBias MUON hits in BX",       222,-0.5,221.5);

 rhp_hbook1(DQ_ID(COMP_CORR,LVL_HIT,150),"CORR: allTrig BX number distribution",222,-0.5,221.5);
 rhp_hbook1(DQ_ID(COMP_CORR,LVL_HIT,151),"CORR: allTrig SVD hits in BX",        222,-0.5,221.5);
 rhp_hbook1(DQ_ID(COMP_CORR,LVL_HIT,152),"CORR: allTrig OTR hits in BX",        222,-0.5,221.5);
 rhp_hbook1(DQ_ID(COMP_CORR,LVL_HIT,153),"CORR: allTrig ITR hits in BX",        222,-0.5,221.5);
 rhp_hbook1(DQ_ID(COMP_CORR,LVL_HIT,154),"CORR: allTrig HIPT hits in BX",       222,-0.5,221.5);
 rhp_hbook1(DQ_ID(COMP_CORR,LVL_HIT,155),"CORR: allTrig RICH hits in BX",       222,-0.5,221.5);
 rhp_hbook1(DQ_ID(COMP_CORR,LVL_HIT,156),"CORR: allTrig TRD hits in BX",        222,-0.5,221.5);
 rhp_hbook1(DQ_ID(COMP_CORR,LVL_HIT,157),"CORR: allTrig ECAL hits in BX",       222,-0.5,221.5);
 rhp_hbook1(DQ_ID(COMP_CORR,LVL_HIT,158),"CORR: allTrig MUON hits in BX",       222,-0.5,221.5);

//-------------------------------------------------------------------------
//  run-number
//-------------------------------------------------------------------------

 rhp_hbook1(DQ_ID(COMP_CORR,LVL_HIT,201),"CORR: run number",30000,1000.5,31000.5); 
 
  return 0; // return error code (0 = okay)
}
