
// ******************************************************************
//
// D. Samtleben 10 Aug 1999
// A. Gellrich
//
// hints:
//        components: COMP_SVD
//                    COMP_ITR
//                    COMP_HIPT
//                    COMP_OTR
//                    COMP_RICH
//                    COMP_TRD
//                    COMP_ECAL
//                    COMP_MUON
//                    COMP_FLT
//                    COMP_SLT
//                    COMP_TLT
//                    COMP_FARM
//
//         levels:    LVL_RAW
//                    LVL_HIT
//                    LVL_REC
//         histogram id: 1 - 65535
//
// changes:
// 22 Oct 1999 (AG) removed print-out "here is histogram ..."
// 27 Oct 1999 (AG) use defines from DQ.h
//  1 Nov 1999 (AG) get rid of dq_hid.h
// 19 Nov 1999 (AG) show up
//  6 Jul 2000 (AG) polished printout
//  2 Oct 2001 (UH) 
//  3 Apr 2002 (UH) new names for top level histograms
// 31 May 2002 (UH) optimization of binning
//
// ******************************************************************

// standard includes
#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>

// ONLINE includes
#include "rhp.h"

// Arte includes
#include "arte/arte.hh"
#include "farm/farm.hh"
#include "dq/DQ.h"
#include "dq/DQ_MUON.h"

//
// function code
//
int
DQ_MUON_hit_init()
{
  // show up
  ARTE_mark( "DQ_MUON_hit_init 0", 0 ); 

  //=============================
  //  Hits per Event Plots
  //=============================
  
  DQ_MUON_hbook1(MT1_HITS,LVL_HIT,"MUON: Hits/event in Mt1",801,-0.5,800.5);
  DQ_MUON_hbook1(MT2_HITS,LVL_HIT,"MUON: Hits/event in Mt2",801,-0.5,800.5);
  DQ_MUON_hbook1(MT3_HITS,LVL_HIT,"MUON: Hits/event in Mt3",401,-0.5,400.5);
  DQ_MUON_hbook1(MT4_HITS,LVL_HIT,"MUON: Hits/event in Mt4",401,-0.5,400.5);
  
  DQ_MUON_hbook1(MP3_HITS,LVL_HIT,"MUON: Hits/event in Mp3",601,-0.5,600.5);
  DQ_MUON_hbook1(MP4_HITS,LVL_HIT,"MUON: Hits/event in Mp4",601,-0.5,600.5);
  
  DQ_MUON_hbook1(MX1_HITS,LVL_HIT,"MUON: Hits/event in Mx1",201,-0.5,200.5);
  DQ_MUON_hbook1(MX2_HITS,LVL_HIT,"MUON: Hits/event in Mx2",201,-0.5,200.5);
  DQ_MUON_hbook1(MX3_HITS,LVL_HIT,"MUON: Hits/event in Mx3",201,-0.5,200.5);
  DQ_MUON_hbook1(MX4_HITS,LVL_HIT,"MUON: Hits/event in Mx4",201,-0.5,200.5);
  
  //================================
  //  Occupancy Plots
  //================================
    
  DQ_MUON_hbook1(MT11_OCC, LVL_HIT, "MUON: Occupancy of Mt1.1", 
		 1088, -444.21, 444.21);
  DQ_MUON_hbook1(MT12_OCC, LVL_HIT, "MUON: Occupancy of Mt1.2", 
		 1088, -444.21, 444.21);
  DQ_MUON_hbook1(MT13_OCC, LVL_HIT, "MUON: Occupancy of Mt1.3", 
		 1088, -444.21, 444.21);
  DQ_MUON_hbook1(MT14_OCC, LVL_HIT, "MUON: Occupancy of Mt1.4", 
		 1088, -444.21, 444.21);
  DQ_MUON_hbook1(MT15_OCC, LVL_HIT, "MUON: Occupancy of Mt1.5", 
		 1088, -444.21, 444.21);
  DQ_MUON_hbook1(MT16_OCC, LVL_HIT, "MUON: Occupancy of Mt1.6", 
		 1088, -444.21, 444.21);
    
  DQ_MUON_hbook1(MT21_OCC, LVL_HIT, "MUON: Occupancy of Mt2.1", 
		 1088, -444.21, 444.21);
  DQ_MUON_hbook1(MT22_OCC, LVL_HIT, "MUON: Occupancy of Mt2.2", 
		 1088, -444.21, 444.21);
  DQ_MUON_hbook1(MT23_OCC, LVL_HIT, "MUON: Occupancy of Mt2.3", 
		 1088, -444.21, 444.21);
  DQ_MUON_hbook1(MT24_OCC, LVL_HIT, "MUON: Occupancy of Mt2.4", 
		 1088, -444.21, 444.21);
  DQ_MUON_hbook1(MT25_OCC, LVL_HIT, "MUON: Occupancy of Mt2.5", 
		 1088, -444.21, 444.21);
  DQ_MUON_hbook1(MT26_OCC, LVL_HIT, "MUON: Occupancy of Mt2.6", 
		 1088, -444.21, 444.21);
    
  DQ_MUON_hbook1(MT31_OCC, LVL_HIT, "MUON: Occupancy of Mt3.1", 
		 1088, -444.21, 444.21);
  DQ_MUON_hbook1(MT32_OCC, LVL_HIT, "MUON: Occupancy of Mt3.2", 
		 1088, -444.21, 444.21);
  DQ_MUON_hbook1(MT41_OCC, LVL_HIT, "MUON: Occupancy of Mt4.1", 
		 1088, -444.21, 444.21);
  DQ_MUON_hbook1(MT42_OCC, LVL_HIT, "MUON: Occupancy of Mt4.2", 
		 1088, -444.21, 444.21);
    
  DQ_MUON_hbook2(MT_OCC, LVL_HIT, "MUON: Tube Occupancies*", 
		 16, 0.5, 16.5, 136, -444.21, 444.21);
    
  DQ_MUON_hbook2(MP3_OCC, LVL_HIT, "MUON: Occupancy of Mp3*", 
		 66, -432.55, 432.55, 59, -300.1, 300.1 );
  DQ_MUON_hbook2(MP4_OCC, LVL_HIT, "MUON: Occupancy of Mp4*", 
		 66, -432.55, 432.55, 58, -310.38, 310.338 );
    
  DQ_MUON_hbook2(MX1_OCC, LVL_HIT, "MUON: Occupancy of Mx1*", 
		 44, -39.6, 39.6, 33, -29.7, 29.7 );
  DQ_MUON_hbook2(MX2_OCC,LVL_HIT,"MUON: Occupancy of Mx2*",
		 44, -39.6, 39.6, 33, -29.7, 29.7 );
  DQ_MUON_hbook2(MX3_OCC,LVL_HIT,"MUON: Occupancy of Mx3*",
		 88, -40.0, 40.0, 16, -30.4, 30.4 );
  DQ_MUON_hbook2(MX4_OCC,LVL_HIT,"MUON: Occupancy of Mx4*",
		 94, -44.22, 44.22, 18, -32.78, 32.78 );

  ARTE_mark( "DQ_MUON_hit_init 1", 0 ); 
  
  return 0; // return error code (0 = okay)
}
