
/******************************************************************* 
 *
 * D. Samtleben 10 Aug 1999
 * A. Gellrich
 *
 * Declaration of Histograms and Initialization
 *
 * hints:
 *        components: COMP_SVD
 *                    COMP_ITR
 *                    COMP_HIPT
 *                    COMP_OTR
 *                    COMP_RICH
 *                    COMP_TRD
 *                    COMP_ECAL
 *                    COMP_MUON
 *                    COMP_FLT
 *                    COMP_SLT
 *                    COMP_TLT
 *                    COMP_FARM
 *
 *         levels:    LVL_RAW
 *                    LVL_HIT
 *                    LVL_REC
 *
 * changes:
 * 22 Oct 1999 (AG) code polishing
 * 27 Oct 1999 (AG) use defines from DQ.h
 *  1 Nov 1999 (AG) get rid of dq_hid.h
 * 19 Nov 1999 (AG) show up
 * 12 Dec 2000 (AG) polished printout
 * 14 Feb 2002 (UH) add new FED-based occupancies
 *
 *******************************************************************/ 

/* standard includes */
#include <stdlib.h>
#include <stdio.h>

/* ONLINE includes */
#include "rhp.h"

/* Arte includes */
#include "dq/DQ.h"
#include "dq/DQ_MUON.h"

/*               */
/* function code */
/*               */
int
DQ_MUON_raw_init()
{

  /* book Bad FED histogram */
  DQ_MUON_hbook1(BADFED,LVL_RAW,
		 "MUON: Bad FEDs",5,-0.5,4.5);

  DQ_MUON_hbook1(TUBE_BADFED,LVL_RAW,
		 "MUON: Tube FEDs with bad FED ID",18,0.5,18.5);
  DQ_MUON_hbook1(TUBE_BADREC,LVL_RAW,
		 "MUON: Tube FEDs with bad Record ID",18,0.5,18.5);
  DQ_MUON_hbook1(TUBE_BADBX,LVL_RAW,
		 "MUON: Tube FEDs with bad BX ID",18,0.5,18.5);
  DQ_MUON_hbook1(TUBE_BADLEN,LVL_RAW,
		 "MUON: Tube FEDs with wrong length",18,0.5,18.5);

  DQ_MUON_hbook1(PAD_BADFED,LVL_RAW,
		 "MUON: Pad FEDs with bad FED ID",10,0.5,10.5);
  DQ_MUON_hbook1(PAD_BADREC,LVL_RAW,
		 "MUON: Pad FEDs with bad Record ID",10,0.5,10.5);
  DQ_MUON_hbook1(PAD_BADBX,LVL_RAW,
		 "MUON: Pad FEDs with bad BX ID",10,0.5,10.5);
  DQ_MUON_hbook1(PAD_BADLEN,LVL_RAW,
		 "MUON: Pad FEDs with wrong length",10,0.5,10.5);

  DQ_MUON_hbook1(PIXEL_BADFED,LVL_RAW,
		 "MUON: Pixel FEDs with bad FED ID",8,0.5,8.5);
  DQ_MUON_hbook1(PIXEL_BADREC,LVL_RAW,
		 "MUON: Pixel FEDs with bad Record ID",8,0.5,8.5);
  DQ_MUON_hbook1(PIXEL_BADBX,LVL_RAW,
		 "MUON: Pixel FEDs with bad BX ID",8,0.5,8.5);
  DQ_MUON_hbook1(PIXEL_BADLEN,LVL_RAW,
		 "MUON: Pixel FEDs with wrong length",8,0.5,8.5);

  DQ_MUON_hbook2(FED_OCCBX,LVL_RAW,
		 "MUON: FED-wise occupancy vs. BX",
		 36, 0.5, 36.5, 220, -0.5, 219.5 );

  DQ_MUON_hbook2(CABLE_OCC,LVL_RAW,
		 "MUON: Occupancy by readout cable",
		 1152, 0.5, 1152.2, 32, 0.5, 32.5 );

  return 0; /* return error code (0 = okay) */
}


