  
// ******************************************************************
//
// D. Samtleben 10 Aug 1999
//
// Filling of histograms
//
// changes:
// 28 Oct 1999 (AG) use defines from DQ.h
//  1 Nov 1999 (AG) get rid of dq_hid.h
// 13 Nov 2001 (JH) Modifications by Mike Walter
// 26 May 2002 (IV) addition of two histograms for corrected TDC spectrums
// 04 Jul 2002 (IV) addition of occupancy plots (MW code)
//
// ******************************************************************

// standard includes
#include <stdlib.h>
#include <stdio.h>
#include <iostream.h>

// ONLINE includes
#include "rhp.h"
#include "event.h"
#include "etb.h"
#include "grr.h"
#include "table.h"

// Arte includes
#include "arte/arte.hh"
#include "dq/DQ.h"
#include "dq/DQ_OTR.h"
#include "farm/farm.hh"
#include "Otr/OtrEvent.h"
#include "Otr/OtrI.h"

//
// function code
//

int
DQ_OTR_hit_evnt()
{
 rhp_hf1(DQ_ID(COMP_OTR,LVL_RAW,305),faDDAQphysBX(),OtrEventHitNumberOf());
 	
 for(int i=0;i<OtrEventHitNumberOf();i++){
                   int ci = OtrEventHitChannelIndex(i);
                   int dtime = OtrEventHitTdcValue(i);
                   float diamch=OtrIWirePitch(ci);
		   int crate=OtrITdcCrate(ci); 
		   int supl  = OtrISuperLayer(ci);
		   	   
		   if (supl==17)
			rhp_hfill(DQ_ID(COMP_OTR,LVL_RAW,306),2,dtime,1);  
		   if (supl==1) 
		        rhp_hfill(DQ_ID(COMP_OTR,LVL_RAW,306),1,dtime,1);
		   if (supl!=1&&supl!=17)
			if (supl<17)
			rhp_hfill(DQ_ID(COMP_OTR,LVL_RAW,306),crate+(supl-8)*7,dtime,1);
		        else 
			rhp_hfill(DQ_ID(COMP_OTR,LVL_RAW,306),crate+(supl-18)*7,dtime,1);
				
                   if (diamch<1){
                        rhp_hf1(DQ_ID(COMP_OTR,LVL_RAW,302),dtime,1);
                        }
                        else{
                        rhp_hf1(DQ_ID(COMP_OTR,LVL_RAW,303),dtime,1);
                        }
                   }
		   
		   
		   
  static float event=0 ;
  event++ ;
// =================OCCUPANCY PLOTS===========================
  int goodhits=0;
  for( ArteTable<HITB>::iterator hitb=ArteTable<HITB>::begin();
       hitb!=ArteTable<HITB>::end(); ++hitb) {
    ArtePointer<GEDE>gede = hitb->gede;
    if (gede->cmp != 2) continue; 
    
    int ci  = OtrIFromId(hitb->chid);
    if (ci==-1) continue;
    
                //  **********  filing t0 corrected spectra for good wires ***** 
    		if (OtrIIsOk(ci)){ 
			goodhits++;
		float diamch=OtrIWirePitch(ci);
                float drifttime=hitb->y-OtrITdcT0(ci);
		int crate=OtrITdcCrate(ci); 
		int supl  = OtrISuperLayer(ci);	   
		   if (supl==17)
			rhp_hfill(DQ_ID(COMP_OTR,LVL_HIT,307),2,drifttime,1);  
		   if (supl==1) 
		        rhp_hfill(DQ_ID(COMP_OTR,LVL_HIT,307),1,drifttime,1);
		   if (supl!=1&&supl!=17)
			if (supl<17)
			rhp_hfill(DQ_ID(COMP_OTR,LVL_HIT,307),crate+(supl-8)*7,drifttime,1);
		        else 
			rhp_hfill(DQ_ID(COMP_OTR,LVL_HIT,307),crate+(supl-18)*7,drifttime,1);

                if (diamch<1){
                        rhp_hf1(DQ_ID(COMP_OTR,LVL_HIT,300),drifttime,1);
                        }
                        else{
                        rhp_hf1(DQ_ID(COMP_OTR,LVL_HIT,301),drifttime,1);
                        }
		}
		//  ************************************************************
				
    int sl  = OtrISuperLayer(ci);
    int lay = OtrILayer(ci);
    int sec = OtrISector(ci);
    int npc;
    int asd = OtrIAsd(ci);

    npc = -1;
    switch (sl){
	    case 1:case 17:case 9:case 25:case 11:case 27:case 13:case 29:
		    	 npc = 0; break;
	    case 10:case 26:case 12:case 28:
			 npc = 80;break;
	    case 14:case 30:
			 npc = 40;break;
	    }
    
    if(npc < 0) continue ;

    float chpos = 12*(lay - 1) + sec + npc ;

switch (sl){
	case 1:case 17:
		rhp_hfill(DQ_ID(COMP_OTR,LVL_HIT,200),chpos,asd,1./event);break;
	case 9:case 25:case 10:case 26:
		rhp_hfill(DQ_ID(COMP_OTR,LVL_HIT,201),chpos,asd,1./event);break;
	case 11:case 27:case 12:case 28:
		rhp_hfill(DQ_ID(COMP_OTR,LVL_HIT,202),chpos,asd,1./event);break;
	case 13:case 29:case 14:case 30:
		rhp_hfill(DQ_ID(COMP_OTR,LVL_HIT,203),chpos,asd,1./event);break;			
	}

  }
  // =================END OCCUPANCY PLOTS=======================
  if (goodhits>400)
  rhp_hf1(DQ_ID(COMP_OTR,LVL_HIT,304),faDDAQphysBX(),goodhits);
  
  return 0; // return error code (0 = okay)
}
