
// ******************************************************************
//
// D. Samtleben 10 Aug 1999
//
// Declaration of Histograms and Initialization
//
// changes:
// 28 Oct 1999 (AG) use defines from DQ.h
// 01 Nov 1999 (AG) get rid of dq_hid.h
// 01 Nov 1999 (AG) commented out TDC spectra histograms
// 19 Nov 1999 (AG) show up
//  6 Jul 2000 (AG) polished printout
// 13 Nov 2001 (JH) Modifications by Mike Walter
// 26 May 2002 (IV) Modifications by Ilija Vukotic
// 04 Jun 2002 (IV) introduce occupancy plots
// ******************************************************************

// standard includes
#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>

// ONLINE includes
#include "rhp.h"

// Arte includes
#include "arte/arte.hh"
#include "farm/farm.hh"
#include "dq/DQ.h"
#include "dq/DQ_OTR.h"

//
// function code
//
int
DQ_OTR_hit_init()
{
  // show up
  ARTE_mark( "DQ_OTR_hit_init 0", 0 ); 
  cout << "DQ_OTR_hit_init" << endl;
    
  rhp_hbook1(DQ_ID(COMP_OTR,LVL_RAW,302),"OTR: Raw TDC spectra of 5mm cells",256,0,256);
  rhp_hbook1(DQ_ID(COMP_OTR,LVL_RAW,303),"OTR: Raw TDC spectra of 10mm cells",256,0,256);
 
  rhp_hbook1(DQ_ID(COMP_OTR,LVL_RAW,305),"OTR: BX structure",220,0,220);
  rhp_hbook2(DQ_ID(COMP_OTR,LVL_RAW,306),"OTR: Position of crates RAW",91,0,91,128,0,256);   
  
  rhp_hbook2(DQ_ID(COMP_OTR,LVL_HIT,200),"OTR: Occ. MC1 vs. ASD",40,-0.5,39.5,15,-0.5,14.5);
  rhp_hbook2(DQ_ID(COMP_OTR,LVL_HIT,201),"OTR: Occ. PC1&PC2 vs. ASD",160,-5.5,154.5,62,-0.5,61.5);
  rhp_hbook2(DQ_ID(COMP_OTR,LVL_HIT,202),"OTR: Occ. PC3&PC4 vs. ASD",160,-5.5,154.5,62,-0.5,61.5);
  rhp_hbook2(DQ_ID(COMP_OTR,LVL_HIT,203),"OTR: Occ. TC1&TC2 vs. ASD",80,-5.5,74.5,85,-0.5,84.5);
  
  rhp_hbook1(DQ_ID(COMP_OTR,LVL_HIT,304),"OTR: BX structure (no bad wires)",220,0,220);
  rhp_hbook1(DQ_ID(COMP_OTR,LVL_HIT,300),"OTR: Spectra of 5mm cells corrected",256,0,256);
  rhp_hbook1(DQ_ID(COMP_OTR,LVL_HIT,301),"OTR: Spectra of 10mm cells corrected",256,0,256);
  rhp_hbook2(DQ_ID(COMP_OTR,LVL_HIT,307),"OTR: Position of crates CORR",91,0,91,128,0,256);
  
  // show up
  ARTE_mark( "DQ_OTR_hit_init 1", 0 ); 
  
  return 0; // return error code (0 = okay)
}
