
// ******************************************************************
//
// D. Samtleben 10 Aug 1999
//
// Filling of histograms
//
// changes:
// 28 Oct 1999 (AG) use defines from DQ.h
//  1 Nov 1999 (AG) get rid of dq_hid.h
// 13 Nov 2001 (JH) Modifications by Mike Walter
//  8 Feb 2002 (MW) remove MC
// 16 May 2002 (MW) remove: rtra, vds, itr
// 26 May 2002 (IV) removal of unnecessary includes 
// ******************************************************************

// standard includes
#include <math.h>
#include <stdlib.h>
#include <stdio.h>

// ONLINE includes
#include "rhp.h"
#include "event.h"

// Arte includes
#include "arte/arte.hh"
#include "dq/DQ.h"
#include "dq/DQ_OTR.h"
#include "arte/ArteMessage.hh"
#include "arte/RSEG_cmp.hh"
#include "OtrI.h"

//
// function code
//

struct residual{ 
 float mean;
 float rms;
 int nrhit;
};

residual o[32][2];


int
DQ_OTR_rec_evnt()
{
  static int events=0;
  events++;
  
  // =================ANALYSIS OF SINGLE SEGM===================
  float NSegmPC=0 ;
  float NSegmTC=0 ;
  for( ArteTable<RSEG>::iterator rseg=ArteTable<RSEG>::begin(); 
       rseg!=ArteTable<RSEG>::end(); ++rseg) 
  { // ----------selection of segments-------------------------2 
    if((*rseg)->cmp & Rsegc::bitsign) continue ;
    if((*rseg)->fit) continue ;
    if(((*rseg)->cmp & Rsegc::msg) ) continue ;
    if(((*rseg)->cmp & Rsegc::patt) )
    { // --------- selection pc segments --------------------3
      NSegmPC++ ;
      float zfirst  = (*rseg)->zf ;
      float zend    = (*rseg)->ze ;
      if(zfirst>700 && zend<1000) { // PC alone ---
      float NHpSpc = (*rseg)->nhit ; 
      rhp_hf1(DQ_ID(COMP_OTR,LVL_REC,210),NHpSpc,1);
      }
    } // ------end selection pc segments --------------------3

    if(((*rseg)->cmp & Rsegc::trit) !=0 )
    { // --------- selection tc segments --------------------3
      NSegmTC++ ;
      float NHpStc = (*rseg)->nhit ; 
      rhp_hf1(DQ_ID(COMP_OTR,LVL_REC,211),NHpStc,1);
    } // -----end  selection tc segments --------------------3
  } // ------end selection of segments-------------------------2 
  if(NSegmPC > 0) rhp_hf1(DQ_ID(COMP_OTR,LVL_REC,205),NSegmPC,1) ;
  if(NSegmTC > 0) rhp_hf1(DQ_ID(COMP_OTR,LVL_REC,206),NSegmTC,1) ;

  
 // --------- residuals -------------------- 
  
bool dim;

  for(ArteTable<RTRA>::iterator rtraIt=ArteTable<RTRA>::begin();
      rtraIt!=ArteTable<RTRA>::end();++rtraIt){
	      if((*rtraIt)->hou<25 && (*rtraIt)->hsi<5) continue;
    	      if(fabs(1/(*rtraIt)->pf)<3) continue;
    
	for(ArteRelationIterator<RSEG> rsegIt=(*rtraIt)->rseg.begin();
	rsegIt!=(*rtraIt)->rseg.end();++rsegIt)
      
     

      if(((*rsegIt)->fit == 0)
	 && (((*rsegIt)->cmp & Rsegc::patt) | ((*rsegIt)->cmp & Rsegc::trit))
	 && !((*rsegIt)->cmp & Rsegc::bitsign))
	      
	for(ArteRelationIterator<RHIT> rhitIt=(*rsegIt)->rhit.begin();
	    rhitIt!=(*rsegIt)->rhit.end();++rhitIt){
		    
	  if((*rhitIt)->hitb->gede->gesl->cmp!=2) continue;
	        
	  float cos = (*rhitIt)->hitb->gede->cos*(*rhitIt)->hitb->gede->rot[0] - 
	    (*rhitIt)->hitb->gede->sin*(*rhitIt)->hitb->gede->rot[1];
	  
	  float sin = (*rhitIt)->hitb->gede->sin*(*rhitIt)->hitb->gede->rot[4] - 
	    (*rhitIt)->hitb->gede->cos*(*rhitIt)->hitb->gede->rot[3];
	  
	  float resTmp=((*rhitIt)->x*cos-(*rhitIt)->y*sin-(*rhitIt)->hitb->x)/
	    sqrt(1+((*rhitIt)->tx*cos-(*rhitIt)->ty*sin)*
			 ((*rhitIt)->tx*cos-(*rhitIt)->ty*sin));
	  
	  float Selected=resTmp-(*rhitIt)->q;

	    
	    int superlayer=OtrISuperLayerFromId((*rhitIt)->hitb->chid);
	    float diameter=OtrIWirePitch(OtrIFromId((*rhitIt)->hitb->chid)); 
	    if (diameter<1) dim=0; else dim=1;
	    
	    o[superlayer][dim].mean=o[superlayer][dim].mean+Selected;
	    o[superlayer][dim].nrhit++;
	    o[superlayer][dim].rms=o[superlayer][dim].rms+Selected*Selected;
	    int nrhist=400+superlayer*2+dim;
	    rhp_hf1(DQ_ID(COMP_OTR,LVL_REC,nrhist),Selected,1) ;
	}
  }
  
  if (!(events%50)) {
	  for (int sl=1;sl<31;sl++){
		  if(o[sl][0].nrhit==0 || o[sl][1].nrhit==0) continue;
		  
		  int bin=0;
		  if (sl==1) bin=1;
		  else if (sl>2&&sl<17) bin=sl-7;
		  else if (sl==17) bin=8;
		  else bin=sl-16;
		  
		  rhp_hfill(DQ_ID(COMP_OTR,LVL_REC,490),bin,o[sl][0].mean/o[sl][0].nrhit,1);
		  rhp_hfill(DQ_ID(COMP_OTR,LVL_REC,491),bin,o[sl][1].mean/o[sl][1].nrhit,1);
		
		   float width_0=sqrt(o[sl][0].rms/o[sl][0].nrhit-pow(o[sl][0].mean/o[sl][0].nrhit,2));
		   float width_1=sqrt(o[sl][1].rms/o[sl][1].nrhit-pow(o[sl][1].mean/o[sl][1].nrhit,2));
		 
		  rhp_hfill(DQ_ID(COMP_OTR,LVL_REC,492),bin,width_0,1);
		  rhp_hfill(DQ_ID(COMP_OTR,LVL_REC,493),bin,width_1,1); 
	  	}
	  }
  return 0; // return error code (0 = okay)
}
