
// ******************************************************************
//
// D. Samtleben 10 Aug 1999
//
// Declaration of Histograms and Initialization
//
// changes:
// 28 Oct 1999 (AG) use defines from DQ.h
//  1 Nov 1999 (AG) get rid of dq_hid.h
// 19 Nov 1999 (AG) show up
//  6 Jul 2000 (AG) polished printout
// 26 Nov 2001 (MW) new histograms
//  8 Feb 2002 (MW) remove MC
// 16 May 2002 (MW) remove: rtra, vds, itr
// 06 Jun 2002 (IV&&KS) add residual histos
//
// ******************************************************************

// standard includes
#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>

// ONLINE includes
#include "rhp.h"

// Arte includes
#include "arte/arte.hh"
#include "farm/farm.hh"
#include "dq/DQ.h"
#include "dq/DQ_OTR.h"

//
// function code
//
int
DQ_OTR_rec_init()
{
  // show up
  ARTE_mark( "DQ_OTR_rec_init 0", 0 ); 
  cout << "DQ_OTR_rec_init" << endl;
  
  rhp_hbook1(DQ_ID(COMP_OTR,LVL_REC,205),"OTR: No. segm PC  /ev",100,0.,100.);
  rhp_hbook1(DQ_ID(COMP_OTR,LVL_REC,206),"OTR: No. segm TC  /ev",100,0.,100.);
  rhp_hbook1(DQ_ID(COMP_OTR,LVL_REC,210),"OTR: No. hits/segm PC",60,0.,60.);
  rhp_hbook1(DQ_ID(COMP_OTR,LVL_REC,211),"OTR: No. hits/segm TC",60,0.,60.);

  
// residual histos  
  rhp_hbook1(DQ_ID(COMP_OTR,LVL_REC,434),"OTR: +m1, 5 mm",100,-0.5,0.5);
  rhp_hbook1(DQ_ID(COMP_OTR,LVL_REC,435),"OTR: +m1, 10 mm",100,-0.5,0.5);
  rhp_hbook1(DQ_ID(COMP_OTR,LVL_REC,450),"OTR: +p1, 5 mm",100,-0.5,0.5);
  rhp_hbook1(DQ_ID(COMP_OTR,LVL_REC,451),"OTR: +p1, 10 mm",100,-0.5,0.5);
  rhp_hbook1(DQ_ID(COMP_OTR,LVL_REC,452),"OTR: +p2, 5 mm",100,-0.5,0.5);
  rhp_hbook1(DQ_ID(COMP_OTR,LVL_REC,453),"OTR: +p2, 10 mm",100,-0.5,0.5);
  rhp_hbook1(DQ_ID(COMP_OTR,LVL_REC,454),"OTR: +p3, 5 mm",100,-0.5,0.5);
  rhp_hbook1(DQ_ID(COMP_OTR,LVL_REC,455),"OTR: +p3, 10 mm",100,-0.5,0.5);
  rhp_hbook1(DQ_ID(COMP_OTR,LVL_REC,456),"OTR: +p4, 5 mm",100,-0.5,0.5);
  rhp_hbook1(DQ_ID(COMP_OTR,LVL_REC,457),"OTR: +p4, 10 mm",100,-0.5,0.5);
  rhp_hbook1(DQ_ID(COMP_OTR,LVL_REC,458),"OTR: +t1, 5 mm",100,-0.5,0.5);
  rhp_hbook1(DQ_ID(COMP_OTR,LVL_REC,459),"OTR: +t1, 10 mm",100,-0.5,0.5);
  rhp_hbook1(DQ_ID(COMP_OTR,LVL_REC,460),"OTR: +t2, 5 mm",100,-0.5,0.5);
  rhp_hbook1(DQ_ID(COMP_OTR,LVL_REC,461),"OTR: +t2, 10 mm",100,-0.5,0.5);

  rhp_hbook1(DQ_ID(COMP_OTR,LVL_REC,402),"OTR: -m1, 5 mm",100,-0.5,0.5);
  rhp_hbook1(DQ_ID(COMP_OTR,LVL_REC,403),"OTR: -m1, 10 mm",100,-0.5,0.5);
  rhp_hbook1(DQ_ID(COMP_OTR,LVL_REC,418),"OTR: -p1, 5 mm",100,-0.5,0.5);
  rhp_hbook1(DQ_ID(COMP_OTR,LVL_REC,419),"OTR: -p1, 10 mm",100,-0.5,0.5);
  rhp_hbook1(DQ_ID(COMP_OTR,LVL_REC,420),"OTR: -p2, 5 mm",100,-0.5,0.5);
  rhp_hbook1(DQ_ID(COMP_OTR,LVL_REC,421),"OTR: -p2, 10 mm",100,-0.5,0.5);
  rhp_hbook1(DQ_ID(COMP_OTR,LVL_REC,422),"OTR: -p3, 5 mm",100,-0.5,0.5);
  rhp_hbook1(DQ_ID(COMP_OTR,LVL_REC,423),"OTR: -p3, 10 mm",100,-0.5,0.5);
  rhp_hbook1(DQ_ID(COMP_OTR,LVL_REC,424),"OTR: -p4, 5 mm",100,-0.5,0.5);
  rhp_hbook1(DQ_ID(COMP_OTR,LVL_REC,425),"OTR: -p4, 10 mm",100,-0.5,0.5);
  rhp_hbook1(DQ_ID(COMP_OTR,LVL_REC,426),"OTR: -t1, 5 mm",100,-0.5,0.5);
  rhp_hbook1(DQ_ID(COMP_OTR,LVL_REC,427),"OTR: -t1, 10 mm",100,-0.5,0.5);
  rhp_hbook1(DQ_ID(COMP_OTR,LVL_REC,428),"OTR: -t2, 5 mm",100,-0.5,0.5);
  rhp_hbook1(DQ_ID(COMP_OTR,LVL_REC,429),"OTR: -t2, 10 mm",100,-0.5,0.5);

  rhp_hbook2(DQ_ID(COMP_OTR,LVL_REC,490),"OTR: residual mean, 5 mm",16 ,0.,16.,100,-0.02,0.02);
  rhp_hbook2(DQ_ID(COMP_OTR,LVL_REC,491),"OTR: residual mean, 10 mm",16 ,0.,16.,100,-0.02,0.02);

  rhp_hbook2(DQ_ID(COMP_OTR,LVL_REC,492),"OTR: residual width, 5 mm",16 ,0.,16.,100,0.,0.075);
  rhp_hbook2(DQ_ID(COMP_OTR,LVL_REC,493),"OTR: residual width, 10 mm",16 ,0.,16.,100,0.,0.075);

  // show up
  ARTE_mark( "DQ_OTR_rec_init 1", 0 ); 

  return 0; // return error code (0 = okay)
}
