
// ******************************************************************
//
// D. Samtleben 10 Aug 1999
//
// Filling of histograms
//
// changes:
// 27 Oct 1999 (AG) use defines from DQ.h
//  1 Nov 1999 (AG) get rid of dq_hid.h
//  3 Feb 2000 (DD) avoid looping over all HITB's
// 17 Feb 2000 (DD) FED occupancy 
// 27 Jul 2000 (AG) added dric2hitb_() to build hits when reco is off
//  5 Apr 2002 (MS) "Occupancy per FED": hfill removed
//                  "Channel occupancy": hfill removed
//                  "Occupancy per FED Ratio": hfill removed
//                  "Occupancy per Channel ratio": hfill removed
//                  polishing
// ******************************************************************

// standard includes
#include <stdlib.h>
#include <stdio.h>

// ONLINE includes
#include "rhp.h"
#include "event.h"

// Arte includes
#include "arte/arte.hh"
#include "farm/farm.hh"
#include "dq/DQ.h"
#include "dq/DQ_RICH.h"

// rich includes
#include "rich/rich.h"

int DQ_RICH_hit_evnt()
{
  ARTE_mark( "DQ_RICH_hit_evnt 0", 0 );

  // build RICH hits in case reco is off
  dric2hitb_();
  
  // monitor RICH on hit level
  float NrRICHHits=RichRun::gede->hitl+1 - RichRun::gede->hit1;
  rhp_hf1(DQ_ID(COMP_RICH,LVL_HIT,1),NrRICHHits,1);

  for( ArteTable<HITB>::iterator ihitb=RichRun::gede->hit1; 
       ihitb!=RichRun::gede->hitl+1; ++ihitb ){
    rhp_hfill(DQ_ID(COMP_RICH,LVL_HIT,2),(*ihitb)->q,(*ihitb)->r,1);
  }

  ARTE_mark( "DQ_RICH_hit_evnt 1", 0 );
  return 0; 
}

