// *****************************************************************************
//
// source:    faMem.C
//
// type:      source code
//
// created:   26 Oct 2001
//
// author:    Jose Hernandez
//
// purpose:   returns for linux total size and resident memory size
// changes:
// 03 Jul 02 (JH) remove external FAMEM

#include <sys/types.h>
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <ctype.h>
#include <unistd.h>
#include <string.h>

int vm_size(int *mem) {  /* mem[0]=size, mem[1]=resident */
  FILE *fd;
  char  pfile[256];
  pid_t pid = getpid();
  mem[0] = mem[1] = 0;

  sprintf(pfile,"/proc/%ld/statm",(long)pid);

  fd = fopen(pfile, "r");
  if(!fd) {
      printf("Can't open %s\n\n", pfile);
      return(1);
  }

  fscanf(fd, "%d %d", mem, mem+1);
  mem[0] *= 4096; /* convert from #pages to bytes */
  mem[1] *= 4096;

  fclose(fd);
  return 0;
}
