/************************************************************************
* GEOACT
* written by Siegmund Nowak, 30/08/95 09.18.12
*
* Description: Reads data card DETV from ASCII kumac file and selects
*              the short, long or user variant of a detector version
*
* called from  KUIP
***********************************************************************/
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "arte/arte.hh"
#include "arte/ArteMessage.hh"
#include "gean/ZGESL.h"
#include "gean/ZGDETV.h"

extern "C" { char* ku_getc();   
static int  geoact_first=1;
void geoact_() {   
 
  char name[70]; 
  if(geoact_first) {
    arteMsg <<"The card DETV is valid only to deselect a subdetector";
    arteMsg.warn();
    arteMsg <<"long/short selects should be made by an entry in gversxxxx.dat";
    arteMsg.warn();
    arteMsg <<"To force the magnet on/off use the card 'MAGN ON'/'MAGN OFF'";
    arteMsg.warn();
    geoact_first=0;       
  }
  char input[5];
  strncpy(input,ku_getc(),5);
  input[4] = '\0';
  if(strlen(input)>0) {
    int found = 0;
    for(int i=0; i<32; i=i++) {
       if(!strncmp(&subdet_names[4*i],input,strlen(input))) {
             zgdetv_.DETV[i] = 'U'; found=1;    break;
          
       }
    } 
    if(!found) {
       arteMsg << "DETV - subdetector " << input << " not found; correct names are:";
       arteMsg.warn();
       memset(name,' ',70);  
       int j=0;
       for(int i=0; i<32; i=i++) {
          if(!strncmp(&subdet_names[4*i],"    ",4)) continue;
	  strncpy(&name[j],&subdet_names[4*i],4);
          j=j+5;
          if(j>=70) { 
             name[j] = '\0';      
             arteMsg << name;
             arteMsg.warn();
             memset(name,' ',70);
             j=0;
          }
       }
       name[j] = '\0';      
       arteMsg << name;
       arteMsg.error();
  
    } 
  }
}}

/*   END    GEOACT    */




