/***********************************************************************
*
* GUOUT
* written by Siegmund Nowak  04/03/93
*
* Description: GEANT routine called at the end of each event,
*              here used for a call for sorting/storing  MIMP/MCAL banks
*              and for deleting temporary containers
* called from  GEANT
*
***********************************************************************/
#include <vector.h>
#include "gean/zgkine.hh"
#include "gean/zgmimp.hh"

extern "C" {
   void guout_();
   void crkibk_();
   void crmibk_();
   void dggept_();
}
 
void guout_() {
   extern vector<int>    *hg_vert;
   extern vector<hgmtra> *hg_mtra;
   extern vector<hgmimp> *normal_mimp;
   extern vector<hgmimp> *modul_mimp;
   extern vector<hgmimp> *TRD_mimp;
   extern vector<hgmcal> *TR_mimp;
   extern vector<hgmimp> *RICH_mimp;
   extern vector<hgmtcp> *ECA_ep;
   extern vector<hgmcal> *ECA_mimp;

   crmibk_();
   dggept_();

   if(hg_vert     != NULL) delete hg_vert;
   if(hg_mtra     != NULL) delete hg_mtra;
   if(normal_mimp != NULL) delete normal_mimp;
   if(modul_mimp  != NULL) delete modul_mimp;
   if(TRD_mimp    != NULL) delete TRD_mimp;
   if(TR_mimp     != NULL) delete TR_mimp;
   if(ECA_ep      != NULL) delete ECA_ep;
   if(ECA_mimp    != NULL) delete ECA_mimp;
   if(RICH_mimp   != NULL) delete RICH_mimp;   
}



