>Name HGKUIP

>Menu HBGEAN
>Guidance

>COMMAND GEAN
>GUIDANCE
Switch HERA-B detector simulation on.
The initial setting is GEAN OFF.
if 'read' is given, Geant and Arte banks are read in; 
>ACTION kagean%C
>PARAMETER
+
SWITCH 'read' C D='  ' 


>COMMAND GEOM_INSTALL
>GUIDANCE
Switch HERA-B detector geometry installation on. Write out GEANT and
ARTE banks
>ACTION kagean%C



>MENU /HBGEAN/geankumac
>Guidance
Example of a arte.kumac file used for HBGEAN

 For HBGEAN most of the general GEANT interactive commands (see GEANT
 manual section XINT) are valid. Note that due to ambiguities some of
 GEANT command should be preceeded by GEANT/CONTROL/, GEANT/GEOMETRY/ or
 GEANT/PHYS. This is valid for instance for:
 GEANT/CONTROL/DEBUG
 GEANT/CONTROL/PRINT
 GEANT/PHYS/CUTS

 The following command must be replaced:
 TRIG by RUN
 NEXT by CLEAR

 If commands are not explicitely given the default values of GEANT (see
 GEANT manual BASE040) will be taken.
 .
 All drawing commands will work only, if grafic initialization is made
 before by the command PRISM

 Below an example of a arte.kumac file for usage of GEANT is given.

 *  seed 999 999
 *  LUND bb in 4. -b.
 *  exec /home/hydra/albrecht/anew/psik0
 *  IOFILE   GEOMIN hb1.geo
 IOFILE   READ geo.dat
 IOFILE   GEOMOUT hbm.geo  0  O
 IOFILE   EVIN1 /net/sgi/herab/data/jpsik0sal.dst
 IOFILE   EVIN2 /net/sgi/herab/data/inelal.dst
 IOFILE   PRISM hist.ps
 IOFILE   RAW bb.dst 0 O
 IOMIX    -1.  4.
 HBOOK gean.his -O
 GEANT/CONTROL/DEBUG  ON
 GEANT/CONTROL/SWIT 1 0
 GEANT/CONTROL/KINE 2
 GEANT/PHYS/CUTS .001 .001 .01 .01 .01 -1. -1. -1. -1. .01
 DETV TARL SIDL WTDL MTDL PTLL RICS CALL MUDL TRDS FLDS
 GEAN
 MIMP ON
 MMWRIT GEOMOUT GEHD
 RUN 3
 ENDKUMAC

 Most of the cards are explained in ARTE.
 Here the command MIMP tells the program whether MIMP should be written out
 (ON) or not (OF).  GEANT/CONTROL/SWIT 1 1 sets the Variable ISWIT(1) to 1,
 activating the event drawing ((if grafics was initiated by PRISM) .
 Otherwise the event drawing will be supressed (default). ISWIT(1) is the
 only switch used by HBGEAN, ISWIT(2-10) can be used by the user. If a
 command  IOFILE   GEOMOUT exists MMWRIT GEOMOUT GEHD  writes out the
 ARTE geometry banks. DETV and KINE will explained below:

**********************************************************************
**************************************************************************
>MENU /HBGEAN/COMMANDS
>Guidance 
Specific GEAN commands for HERA-B
***************************
>Command PHSP
>Guidance
Generates phase space particles
>Action KAPHSP
>Parameter
CPART 'Arte name of the wanted particle' C D='mu-'
PMIN  'minimal momentum' R D=10.
PMAX  'maximal momentum' r D=10.
THMIN 'minimal polar angle' R D=0.010
THMAX 'maximal polar angle' R D=0.250
PHIMIN 'minimal azimut angle' R D=0.
PHIMAX 'maximal azimut angle' R D=6.283185307




*************************************************************************
>Menu /HBGEAN/SHOW
>Guidance
Shows detector characteristics.
******************************
>Command PICT
>Guidance
Draws a perspective view of the  HERA-B-detector or of parts of it.
Possible parameters: DET SVD OTR ITR PT ECA MUON BEAM
>Action kapict%C
>Parameter
DET  ' Detector part (DET SI OTR ITR PT TRD CAL MUON BEAM) ' C D='DET'
PERS 'Perspective (p) or cut (cx or cy) view' C D='P'
+
NAM  'Superlayer name' C
LAY  'Layer number' I
SEC  'Sector number, 0 means all sectors' I D=0

*******************************
>Command PITEXT
>Guidance
Draws text.
If invoked with zero coordinates, asks for graphical input.
>Action PITEXT
>Parameter
x      'x' R D=0.
y      'y' R D=0.
string 'String to draw' C D=' '
+
color     'color (0 means no change)' R D=0.
height    'height (0 means 0.03 of viewport)' R D=0
font      '10*font+precision (see HIGZ manual, p.39)' I D=-130
alignment 'alignment: 0=10=left, 20=cent, 30=right, 0=base, 1=2=top, 3=mid' I D=0
********************************
>Command PIGSET
>Guidance
Shows and sets parameters of HIGZ graphical package.
Performs CALL IGSET(attribute,value).
See HIGZ manual, p.90 for meaning of attributes.
If invoked without parameters, shows all current and default values.
>Action PIGSET
>Parameter
+
attribute  'Attribute' C D='SHOW'
parameter  'Parameter' R D=0.

**************************
>Command GEANPRIS
>Guidance
Draws a Geant view over existing PRISM picture
Parameter MODE=1 means Geant DCUT command (cut view),
          MODE=2 means Geant DRAW command (3D view).
Supported Prism views are: 0 (xy plane), 1 (xz), 2 (yz), 3 (3D view).

At the end displays the corresponding interactive Geant command.
To use it interactively, perform a graphical reset before it (command GRESET),
and perform FLUSH after it.
>Action PIGEPR
>Parameter
+
VOLNAM 'Volume name to draw' C D='MOTH'
CUTVAL 'Cut value for DCUT' R D=0.
MODE   'Mode number' I D=1 R=1:2
HBGEAN 'Wether to draw HbGeant: 0 - not to draw' I D=1 R=0:1


>Command FLUSH
>Guidance
Flushes HIGZ graphical buffer: finally you can see your GEANT drawing!
>Action PIFLUS
>Parameter

>Command GRESET
>Guidance
Perform graphical reset after PRISM stuff.
(Switch to normalization transformation NT=1
returning to default Geant user coordinates U and V).
See also Prism command SELNT.
>Action PIGRST
>Parameter
******************************
>Menu Particle_colours
>Guidance
The following colours are used for drawing the particle tracks:
  Leptons from J/Psi                            black *
  K0s products from J/Psi                       green *
  Tagging particles                             yellow *
  Hadrons                                       red
  Electrons/photons                             blue
  Muons                                         violet

  charged particles                             solid lines
  neutral particles                             dotted lines (if drawn)

  * if golden particles are selected
*************************************************************************
********************************************************************
>MENU /HBGEAN/GEOM
>Guidance 
Geometry commands
***************************
>Command VERS
>Guidance
Definition of the geometry version for HBGEAN
>Action kageov%C
>Parameter
GEOMVERS 'GEOMETRY version' R D=0.
***************************
>Command DETV
>Guidance
 This command rejects subdetector completely from the geometry installation.
 The syntax is 
 DETV subdetector1 subdetector2 ...
 where  subdetector1/subdetector2 can be 'SVD OTR ITR PTC RIC TRD ECA MUON' 
>Action GEOACT
>Parameter
DETV 'reject subdetector(s)' C VARARG LOOP
***************************
>Command MAGNET
>Guidance
switches magnet ON or OFF
>Action kamagn%C
>Parameter
MAGNFL 'MAGNET_FLAG' C
+
REVFL  'Reversion flag' C D=' '
***************************
>COMMAND WIRE
>Guidance
changes the effectivity of wire materials.
>ACTION kawire%C
>PARAMETER
+
SELPAR 'selection parameter (1all, 1i,1o,1t,1b, 2i, 2o, 2t, 2b or MAT' C D=' '
VALPAR 'effectivity for wires or material name for MAT' C D=' '


********************************************************************
********************************************************************
>MENU /HBGEAN/TRACE
>Guidance 
Tracing  commands
***************************
>COMMAND TURB
>Guidance 
switch on fast electron tracing in muon system
>ACTION katurb%C
>PARAMETER
TURB   'switch off slow electron tracing in muon system' C D='off'
********************
>COMMAND CKOV
>GUIDANCE
switch off cerenkov photon generation .
>ACTION katrace%C
>PARAMETER
+
CKOV 'switch for Cerenkov generation' C  D='ON'

***************************
>COMMAND TRD
>GUIDANCE
switch off TRD photon generation .
>ACTION katrace%C
>PARAMETER
+
TR48 'switch on/off' C  D='OFF'

***************************
>COMMAND NSPIRL
>Guidance
defines the maximal angle for spiraling particles
>ACTION kaspirl%C
>PARAMETER
nspirl_angle 'maximal angle for spiraling particles' R D=94.25

***************************
>COMMAND PBEAM
>GUIDANCE
switches generation time smearing or beam shift on or out  
>ACTION kabeam%C
>PARAMETER
TYPE     'TIME or SHIFT' C D='SHIFT', R='TIME','SHIFT'  
ITGTIM   'switch on or off of generation time' C D='off' R='on','off'
+
SIGMA    'sigma in ns for bunch spread' R  D=1.
MEAN     'time shift in ns'             R  D=0. 



********************************************************************
>Menu /HBGEAN/OTR
>Guidance
OTR-specific commands.

>Command OTRG10
>Guidance

This command sets condition whether G10 strips will be declared
as walls and Geant volumes during definition of OTR geometry.
In total, G10 strips have much less material than pokalon modules themselves,
so it is usually safe to ignore the material of G10 strips.
Please note that this command has effect only if used before GEAN command

Meaning of mode parameter:
 OFF            - not declare
 ON             - declare G10 strips
 CONCISE        - (not yet implemented!) declare G10 strips in concise way
                  by grouping strips at approximately the same
                  position as one wall
 <no parameter> - show current status

>Action WALLG10
>Parameter
+
Mode 'Mode: OFF - not declare, ON - full declare, CONCISE - declare in concise way' C D=' '

********************************************************************
>MENU /HBGEAN/PTL
>Guidance
commands for high pt cchambers
>Command PTLPRINT 
>Guidance 
  Print information about PTL chambers and walls (using only PTGE table)
  Perform scan PTGE table from row FIRST to row LAST and print information
  about all objects which satisfy the selection criteria: 
        NAME , OBJECTS, SUPERLAYER and MOTHER
  Suitable for fast finding of the object. 
  FIRST = MIN( MAX( 1     , FIRST ) , NPTGE() )
  LAST  = MIN( MAX( FIRST , LAST  ) , NPTGE() )
  Example: 
   PTLPRINT 1 50 ALL WALL ALL ALL TPL TABLE  - will scan first 50 rows in 
     PTGE table and print information about all OBJECTS of type=WALL  
>Action PTLPRN
>Parameters 
+
FIRST       'First object to be printed                          ' I D=1 
LAST        'Last  object to be printed                          ' I D=10000 
NAME        'Name of object to be printed                        ' C D='ALL'  
OBJECTS     'Chambers?Walls?All?                                 ' C D='ALL'  
SUPERLAYER  'Print objects which belongs to THIS superlayer only ' C D='ALL' 
MOTHER      'Print objects which belongs to THIS mother only     ' C D='ALL'
DESTINATION 'Printer destination: any combination of T , P and L ' C D='TPL'
FORMAT      'Format: FILE or TABLE                               ' C D='TABLE'

>Command PTLLIST 
>Guidance 
  List  information about PTL chambers and walls (using only PTGE table)
  action is almost the same as for PTLPRINT command. 
  Perform scan PTGE table from row FIRST to row LAST and list information
  about all objects which satisfy the selection criteria: 
            NAMES , OBJECTS , SUPERLAYER and MOTHER
   Suitable for detailed description and for ASCII-file creation.  
   FIRST = MIN( MAX( 1     , FIRST ) , NPTGE() )
   LAST  = MIN( MAX( FIRST , LAST  ) , NPTGE() )
  Example: 
   PTLLIST 1 0 PTC1 ALL ALL ALL TPL FILE  - will scan all PTGE table, 
   and list information about all OBJECTS with name PTC1 
>Action PTLPRN
>Parameters 
+
FIRST       'First object to be listed                           ' I D=1 
LAST        'Last  object to be listed                           ' I D=10000 
NAME        'Name of object to be listed                         ' C D='ALL'  
OBJECTS     'Only Chambers? Only Walls? All?                     ' C D='ALL'  
SUPERLAYER  'List objects which belongs to THIS superlayer only  ' C D='ALL' 
MOTHER      'List objects which belongs to THIS mother only      ' C D='ALL'
DESTINATION 'List destination: any combination of T , P and L    ' C D='TPL'
FORMAT      'Format: FILE-like or TABLE-like                     ' C D='FILE'

>Command PTLDRAW
>Guidance 
 call GDRAW or GDRAWC for PT SUPERLAYERS 
>Action  PTLDRW
>Parameters 
PERS    ' DRAW(D) or CUT(c) view ' C D=D
SUPL    ' Superlayer name        ' C D='PTL1' R='PTL1','PTL2','PTL3','MAGN','MOTH'
THETA    'angle THETA for GDRAW  ' R D=20.0
PHI      'angle PHI   for GDRAW  ' R D=45.0
PSI      'angle PSI   for GDRAW  ' R D=0.0
AXE      'Axis of the GDRAWC     ' I D=3 
CUT      'cut value for GDRAWC   ' R D=0.0
U0       'U0                     ' R D=10.0  
V0       'V0                     ' R D=10.0  
SU       'SU                     ' R D=0.1  
SV       'SV                     ' R D=0.1  

>Command PTLREAD  
>Guidance 
Force the reading of PT-geometry information and put it into Arte table PTGE. 
Existing PTGE table will be removed. New information in PTGE Arte table 
*can differ* from existing GEANT JVOLUM structure. Therefore be carefull 
using this command. Currently onlu SOURCE=File is implemented.   
Being frequently used within one ineractive job this command *can force* 
Arte  termination via "no place for rotation matrix in CRROTM" error. 
>Action PTLREA 
>Parameters 
+
SOURCE 'where the information should be read from?File?DBase?' C D='FILE' 

>Command CLEAR_HPT_SETUP_STRUCTURE
>Action clear_hpt_setup_or_not
>Parameters
string   'YES or NO' C D=YES
>Guidance
This option has an effect when the geometry is generated (not read from
file). High-Pt GEDE planes are then filled using hpt_setup C++ structure. 
If one does not need it after that he can clear it and save some memory. 
This is the default. If hpt_setup structure should be retained one should give 
parameter "NO" to the command. If the geometry is read from file hpt_setup is 
empty in any case (see also gean/ptlset.C).

>Menu /HBGEAN/TRIG
>Guidance
by giving one or more trigger cards in your kumac , i.e.
all particles on the input event (from the generator) are checked whether they
fullfill these conditions. They and only they will be traced first. 
After tracing them a subroutine ustrig is called, where the user can decide 
whether to take the event or not. Only after this decision the rest of the 
event will be traced and written out (or not depending on the user decision).
Note that the cut is valid only for input particles, not for particles
generated during tracing.
>COMMAND PTRIG
>ACTION ka_trig%C
>PARAMETER
PCODE 'PARTICLE NAME' C D=' '
P     'TRIGGER IMPULS' R D=0
+
PT    'TRIGGER TRANVERSAL MOMENTUM' R D=0

>Menu /HBGEAN/CHECK
>Guidance
OTR-specific checks for correct geometry installation

>Command chinvol
>Guidance
checks whether all NEDE and NWAL are inside the dimensions of NESL
>action kaChVolInNesl%C
>parameter

>Menu /HBGEAN/CORRECT
>Guidance
corrections for existing geometries by hand
>Command corr020103
>guidance
introduces additional air walls into magnet, replaces VPSM sphere by box
>action kacorr020103%C
>parameter
