// -- Author : 
#include <stdio.h>
#include "arte/arte.hh"
#include "gean/ZGESL.h"

extern "C" {
  void kaChVolInNesl();
}

void kaChVolInNesl() {

  for( ArteTableIterator<NEDE> nd; nd.valid(); nd.next()){
    ArtePointer<NESL> ns = (*nd)->nesl;
    if(ns.index() <=0 || ns.index() > ArteTable<NESL>::size())
              printf("NEDE without NESL %d \n",nd.index());
  }

  for( ArteTableIterator<NWAL> nw; nw.valid(); nw.next()){
    ArtePointer<NESL> ns = (*nw)->nesl;
    if(ns.index() <=0 || ns.index() > ArteTable<NESL>::size())
              printf("NWAL without NESL %d \n",nw.index());
  }

  for( ArteTableIterator<NESL> ns; ns.valid(); ns.next()){

    float zmin = (*ns)->z1 -1.e-4,  zmax = (*ns)->z2 +1.e-4;
    float xmin = (*ns)->x1 -1.e-4,  xmax = (*ns)->x2 +1.e-4;
    float ymin = (*ns)->y1 -1.e-4,  ymax = (*ns)->y2 +1.e-4;
    printf("superlayer %d %.4s \n \n",(*ns).index(),(*ns)->name);

    if ((*ns)->cmp != LGESL_ECA  && (*ns)->cmp != LGESL_HOD3) {

       for(int j= (*ns)->fpl;  j<(*ns)->fpl+(*ns)->npl; j++){
	 ArtePointer<NEDE> nd(j);         
         if( nd->zmin  <  zmin || nd->zmax  >  zmax) 
           printf("z NESL %d %f %f NEDE %d %f %f %.4s\n",
               (*ns).index(),zmin,zmax,j,nd->zmin,nd->zmax,nd->gvol);

         if(nd->shp == 1) {
            if(nd->xmin < xmin  ||  nd->xmax > xmax) 
               printf("x NESL  %d %f %f NEDE %d %f %f %.4s\n",
	          (*ns).index(),xmin,xmax,j,nd->xmin,nd->xmax,nd->gvol);
            if(nd->ymin < ymin  ||  nd->ymax > ymax)
               printf("y NESL  %d %f %f NEDE %d %f %f %.4s\n",
		  (*ns).index(),ymin,ymax,j,nd->ymin,nd->ymax,nd->gvol);
	 }
       }


       for(int j= (*ns)->fwl;  j<(*ns)->fwl+(*ns)->nwl; j++){
	 ArtePointer<NWAL> nw(j);
         if(nw->zmin < zmin  ||  nw->zmax  >  zmax) 
	   printf("z NESL %d %f %f NWAL %d %f %f %.4s\n",
		(*ns).index(),zmin,zmax,j,nw->zmin,nw->zmax,nw->gvol);

         if(nw->shp == 1) {
           if(nw->xmin < xmin  ||  nw->xmax  >  xmax)
	     printf("x NESL %d %f %f NWAL %d %f %f %.4s\n",
              (*ns).index(),xmin,xmax,j,nw->xmin,nw->xmax,nw->gvol);

           if(nw->ymin < ymin  ||  nw->ymax  >  ymax)
	     printf("y NESL %d %f %f NWAL %d %f %f %.4s\n",
	      (*ns).index(),ymin,ymax,j,nw->ymin,nw->ymax,nw->gvol);

	 }
       }
    }
  }
}

