/***********************************************************************
*
* RPOT_ARTE
* written by Siegmund Nowak
*
* This routine changes the spherical end flange of the Roman pot into 
* a box (in NWAL table only, Geant banks are untouched) 
*
*       called from cr_arte_user
*
* The transferred parameters are
* void rpot_arte_(int nede,int nwal,char lvols[],int lcopy[],int nlev)
************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include "arte/arte.hh"
#include "arte/ArteMessage.hh"
#include "arte/ArteUtil.h"
#include "arte/ArteFlag.h"

void rpot_arte(const int,const int nwal,const char lvols[],const int lcopy[],
                                                            const int nlev) {

   if(!strncmp(&lvols[4*nlev],"VPSM",4)) { 
      if(arteflag_.geomvers > 99. || arteflag_.geomvers <= 2.01031) return; 
      ArtePointer<NWAL> cr(nwal);
      float zmin = cr->zmin - cr->xmax;
      float zmax = cr->zmin - cr->xmin;
      float ro =  cr->xmin * sin(cr->zmax* AR_DEGRAD);
      cr->zmin = zmin; 
      cr->zmax = zmax;
      cr->xmin = -ro;
      cr->xmax = ro;
      cr->ymin = -ro;
      cr->ymax = ro;      
      cr->shp = 1;
      cr->xmad =0;   cr->ymad = 0.;    cr->zmad = 0.; 
   }
       
}


