*CMZ :  0.01/02 26/08/94  11.59.38  by  Dominik Ressing
*CMZ :  0.01/01 24/07/94  13.13.55  by  Dominik Ressing
*-- Author :    Dominik Ressing   19/07/94
************************************************************************************
*
* L1JOBRC
* written by Dominik Ressing, 19/07/94 19.32.19
*
* This routines action:
* Reconnect a JOB: Fill time into job,
* search for the correct insertion position in the execution-queue
* (according to its time-stamp) and connect the job there.
*
* Variables   kind         description
*          (in,update,out)
*-----------------------------------------------------------------------------------
* itime       in           time stamp for job
* jobpo       in           job to store
*
************************************************************************************
c
      SUBROUTINE L1JOBRC(itime,jobpo)
c
      IMPLICIT NONE
c
#include "l1si/l1param.fi"
#include "l1si/l1jobdf.fi"
c
      INTEGER itime,jobpo,inext,ithis,jtime
c
c
c     --- fill time into the job
      L1JOBstore(jobpo+L1JOBtime) = itime
c
c     --- set start values for job search
      ithis = L1JOBsused
      inext = L1JOBsused
      jtime = itime - 1
c
c     --- search for input position ( just in front of the next later job!)
      DO WHILE( jtime.le.itime .and. inext.gt.0 )
c        --- remember last tried
         ithis = inext
c        --- point to next job and get its time-stamp
         inext = L1JOBstore(inext)
         IF ( inext.gt.0 ) jtime = L1JOBstore(inext+L1JOBtime)
      END DO
c
c     --- insert job in execution queue behind last scanned job
      CALL l1jobco(jobpo,ithis)
c
      IF (L1PARprnlev.ge.1) THEN
         WRITE(L1LUNprn,900) jobpo,itime
  900    FORMAT(1x,'L1JOBRC==> connect job ',i5,' at time ',i5)
      END IF
c
      RETURN
c
      END
