*CMZ :  1.00/00 27/01/95  12.34.55  by  Dominik Ressing
*CMZ :  0.01/02 26/08/94  11.59.59  by  Dominik Ressing
*CMZ :  0.01/01 24/07/94  13.32.15  by  Dominik Ressing
*-- Author :    Dominik Ressing   18/07/94
************************************************************************************
*
* L1JOBSB
* written by Dominik Ressing, 18/07/94 15.08.35
*
* This routines action:
* Submit a JOB: Get a free job from the free-job-queue, fill its contents,
* search for the correct insertion position in the execution-queue
* (according to its time-stamp) and connect the new job there.
*
* Variables   kind         description
*          (in,update,out)
*-----------------------------------------------------------------------------------
* imess       in           message pointer of message for job
* itime       in           time stamp for job
* jobpo       out          pointer to stored job or 0 if no success
*
************************************************************************************
c
      SUBROUTINE L1JOBSB(imess,itime,jobpo)
c
      IMPLICIT NONE
c
#include "l1si/l1param.fi"
#include "l1si/l1jobdf.fi"
c
      INTEGER imess,itime,jobpo,inext,iprev,ithis
c
c     --- pointer to first free job
      jobpo = L1JOBstore(L1JOBsfree)
c     --- if no more free jobs (with error jobpo<=0)
      IF ( jobpo.le.0 ) THEN
         WRITE(L1LUNprn,*) 'L1JOBSB==> no free jobs left !!!!!!'
         jobpo = 0
         RETURN
      END IF
c     --- use the first free job and disconnect it from the free-job-queue
      CALL l1jobdi(jobpo)
c
c     --- fill job description
      L1JOBstore(jobpo+L1JOBmess) = imess          ! fill message pointer
      L1JOBstore(jobpo+L1JOBflag) = L1JOBFLAGnorm  ! job in normal state
c
      IF (L1PARprnlev.ge.1) THEN
         WRITE(L1LUNprn,900) jobpo,itime,imess
  900    FORMAT(1x,'L1JOBSB==> submit job  ',i5,' at time ',i5,
     &             ' with message ',i5)
      END IF
c
c     --- (re-)connect at proper position
      CALL l1jobrc(itime,jobpo)
c
      CALL l1usrsb(imess)
c
      RETURN
c
      END
