*CMZ :   . 1/03 23/07/94  20.38.51  by  Dominik Ressing
*-- Author :    Dominik Ressing   22/07/94
************************************************************************
*
* L1PRCVA
* written by Dominik Ressing, 22/07/94 19.50.02
*
* This routines action:
* Returns .true. if processor of type and num is defined.
* This function performes range checking on num.
* For invalid values of itype an error message is printed.
*
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
* itype       in          one of the defined proc. types (in $L1PRCDF)
* num         in          processor number in L1PARAM definition fields
*
************************************************************************
c
      LOGICAL FUNCTION L1PRCVA(itype,num)
c
      IMPLICIT NONE
c
#include "l1si/l1param.fi"
#include "l1si/l1prcdf.fi"
c
      INTEGER itype,num
c
      IF (itype.eq.L1PCtpre) THEN
         IF ( num.le.0 .or. num.gt.L1DEFmaxpre ) THEN
            L1PRCVA = .false.
         ELSE
            L1PRCVA = ( L1DEFpredef(L1PREntfu,num).gt.0 )
         END IF
      ELSEIF (itype.eq.L1PCttfu) THEN
         IF ( num.le.0 .or. num.gt.L1DEFmaxtfu ) THEN
            L1PRCVA = .false.
         ELSE
            L1PRCVA = ( L1DEFtfudef(L1TFUsup,num).gt.0 )
         END IF
      ELSEIF (itype.eq.L1PCttpm) THEN
         IF ( num.le.0 .or. num.gt.L1DEFmaxtpm ) THEN
            L1PRCVA = .false.
         ELSE
            L1PRCVA = ( L1DEFtpmdef(L1TPMnmcu,num).gt.0 )
         END IF
      ELSEIF (itype.eq.L1PCtmcu) THEN
         IF ( num.le.0 .or. num.gt.L1DEFmaxmcu ) THEN
            L1PRCVA = .false.
         ELSE
            L1PRCVA = ( L1DEFmcudef(L1MCUnum,num).eq.num )
         END IF
      ELSE
         WRITE(L1LUNprn,*) ' L1PRCVA ==> undefined type :',itype
         L1PRCVA = .false.
      END IF
c
      RETURN
c
      END
