*CMZ :  1.00/07 26/10/95  11.54.31  by  Fouzia SAADI
*CMZ :  1.00/00 04/01/95  20.18.05  by  Dominik Ressing
*-- Author :    Dominik Ressing   18/10/94
************************************************************************
*
* L1PRETR
* written by Dominik Ressing, 18/10/94 11.05.22
*
* This routines action:
* Emulate pretrigger using a track from the hand-entered l1simu track bank
*
* Arguments  kind         description
*          (in,update,out)
*----------------------------------------------------------------------*
* iP          in          pointer to processor definition for this pretrigger
* ierr        out         set to <>0 on error
*
************************************************************************
c
      SUBROUTINE L1PRETR(iP,ierr)
c
      IMPLICIT NONE
c
#include "gean/gcbank.fi"
#include "l1si/l1runpa.fi"
#include "l1si/l1param.fi"
#include "l1si/l1geodf.fi"
#include "l1si/l1detdf.fi"
#include "l1si/l1mesdf.fi"
#include "l1si/l1jobdf.fi"
#include "l1si/l1prcdf.fi"
c
      INTEGER itr,iECAL,iDetSpe(L1DETSPElen),iDetKal,iTime,MessPo,
     &        jCaloGeo,jCaloInf,jCellGeo
      REAL    Point(L1POINTlen),zECAL,dxECAL,dyECAL,PTrack,Cut
      REAL    t1ecath
      LOGICAL initialized
      SAVE    initialized,zECAL,dxECAL,dyECAL
      INTEGER l1detsl,IPRE,iPoPo,iP,ierr,JobPo
      EXTERNAL l1detsl,t1ecath
c
      DATA    initialized /.false./
c
#include "l1si/l1mesdf.ff"
c
c     --- find pretrigger dimensions and position in z
      IF ( .not.initialized ) THEN
        CALL UCTOH('KALW',iECAL,4,4)
        iDetKAL = l1detsl(iECAL)
        IF ( iDetKAL.LE.1) THEN		! detector KALi not existing
          WRITE (L1LUNprn,*) ' L1PRETR==> invalid ECAL'
          ierr = 1
          RETURN
        END IF
        iDetSpe(L1DETSPEdet) = iDetKAL
        iDetSpe(L1DETSPElayer) = 1
        iDetSpe(L1DETSPEsection) = 1
        CALL l1detif(iDetSpe,jCaloGeo,jCaloInf,jCellGeo)
         zECAL = Q(jCaloGeo+L1GEOINFz)
        dxECAL = Q(jCaloGeo+L1GEOINFsx)
        dyECAL = Q(jCaloGeo+L1GEOINFsy)
      END IF
c
      DO itr=1,L1DETntr
         IF (T1DETtracks(L1DETtrBX,itr).eq.L1RUNcuBX) THEN ! use this track
c
            Point(L1POINTz0) = zECAL
c
            CALL l1kinpo(T1DETtracks(L1DETtrPx,itr), ! get intersept point x0,y0
     &           T1DETtracks(L1DETtrPy,itr),
     &           T1DETtracks(L1DETtrPz,itr),
     &           T1DETtracks(L1DETtrVx,itr),
     &           T1DETtracks(L1DETtrVy,itr),
     &           T1DETtracks(L1DETtrVz,itr),
     &           Point(L1POINTz0),
     &           Point(L1POINTx0),
     &           Point(L1POINTy0))
            Point(L1POINTdx) = 0.
            Point(L1POINTdy) = 0.
            PTrack = SQRT(T1DETtracks(L1DETtrPx,itr)**2 +
     &           T1DETtracks(L1DETtrPy,itr)**2 +
     &           T1DETtracks(L1DETtrPz,itr)**2 )
c
            IF ( PTrack.lt.T1DEFmommin ) GO TO 765
            Cut = T1ECATH(PTrack,0,0,Point(L1POINTx0),Point(L1POINTy0))
            IF (Cut.lt.1.) GO TO 765
c
            CALL l1mesne(L1RUNcuBX,MessPo) ! get new message
            IF ( MessPo.le.0 ) THEN ! message storage exceeded
               WRITE(L1LUNprn,*) ' L1PRETR ==> message storage exceeded'
               ierr = 1
               RETURN
            END IF
c
c
            iTime = L1RUNcutime+L1DEFcaltim ! time after Pretrigger
c --- set flags
            L1MEstor(MessPo+L1MElast)  = 0  ! last point was pretrigger
            L1MEstor(MessPo+L1MEnextPC)= iP ! set active proc.
c --- fill soft message
            L1MEstor(MessPo+L1MEprid) = L1PREtest
            L1MEstor(MessPo+L1MEprbx) = L1RUNcuBX
            T1MEstor(MessPo+L1MEpren) = PTrack
            T1MEstor(MessPo+L1MEprth) = Cut
            T1MEstor(MessPo+L1MEpreth)= PTrack/Cut
c
            iPRE = L1PCstor(iP+L1PCnum)           ! pretrigger number
            iPoPo = L1MEpoint(0)+MessPo
            L1MEstor(iPoPo+L1POpcpo) = iP
            L1MEstor(iPoPo+L1POtrkn) = 0
            L1MEstor(iPoPo+L1POtrk0) = 0
            L1MEstor(iPoPo+L1POtrkp) = 0
            L1MEstor(iPoPo+L1POsup)  = L1DEFpredef(L1PREsl,iPRE)
            L1MEstor(iPoPo+L1POtime) = iTime
            iPOPO = iPOPO+L1POreg
            T1MEstor(iPoPo+L1GEOINFx0) = Point(L1POINTx0)-dxECAL/2.
            T1MEstor(iPoPo+L1GEOINFy0) = Point(L1POINTy0)-dyECAL/2.
            T1MEstor(iPoPo+L1GEOINFz)  = Point(L1POINTz0)
            T1MEstor(iPoPo+L1GEOINFsx) = dxECAL
            T1MEstor(iPoPo+L1GEOINFsy) = dyECAL
c --- fill hard message
            L1MEstor(MessPo+L1HAprbx)  = L1RUNcuBX
            L1MEstor(MessPo+L1HAprid)  = L1PREtest
            T1MEstor(MessPo+L1HApren)  = PTrack
            T1MEstor(MessPo+L1HAtxi)  =
     &           T1MEstor(iPoPo+L1GEOINFx0)+0.5*T1MEstor(iPoPo
     $           +L1GEOINFsx)
            T1MEstor(MessPo+L1HAteta)  =
     &           T1MEstor(iPoPo+L1GEOINFy0)+0.5*T1MEstor(iPoPo
     $           +L1GEOINFsy)

c
c$$$            PRINT '(''L1PRETR==> before L1MESUP: x/sx/y/sy:'',5f6.2)',
c$$$     &           T1MEstor(iPoPo+L1GEOINFx0),T1MEstor(iPoPo+L1GEOINFsx),
c$$$     &           T1MEstor(iPoPo+L1GEOINFy0),T1MEstor(iPoPo+L1GEOINFsy),
c$$$     &           T1MEstor(iPoPo+L1GEOINFz )
            CALL l1mesup(MessPo,iTime,ierr) ! update message (get ROI(s))
            IF ( ierr.ge.2 ) RETURN ! fatal error
            IF ( ierr.eq.1 ) THEN
               WRITE(L1LUNprn,*) ' L1PRETR==> Connection error'
               ierr = 1
            ELSE
               CALL l1jobsb(MessPo,iTime,JobPo) ! submitt job
c$$$               PRINT '(''L1PRETR==> submited job: x/sx/y/sy:'',5f6.2)',
c$$$     &              T1MEstor(iPoPo+L1GEOINFx0),T1MEstor(iPoPo+L1GEOINFsx
c$$$     $              ),T1MEstor(iPoPo+L1GEOINFy0),T1MEstor(iPoPo
c$$$     $              +L1GEOINFsy)
            END IF
 765        CONTINUE
         END IF
      END DO
c
      RETURN
c
      END
