>NAME LIKUIP1

>MENU /Listing
>GUIDANCE
List, print, etc. (see also menu List2).
Here obviously quite some parallel program development occured.

>HELP_ITEM DESTINATION
>GUIDANCE
Declaration the print-out destination of list/print commands.
It can be given by the options -t (terminal; standard output for interactive
sessions), -p (printer; standard output for batch jobs), -l (log file)
or a combination (e.g.: -pl). In batch jobs: -t is converted to -p; -tp
to -p.

>COMMAND LTITLE
>GUIDANCE
List program title page.
.
>ACTION KALTIT
>PARAMETER
+
OPTION 'print destination' C D='tp'

>COMMAND LIOSTATUS
>GUIDANCE
List name and status of input/output files.
.
If the parameter (logical unit number / stream name) is omitted
then all i/o will be listed. Examples:
 LIO
 LIO 3
 LIO prnt
 LIO 3 -L
The option -L routes the output to the log file.
Description of the listing:
 LUN: stream number (1...99)
 SYMB: stream name
 IOS: input-output-status as determined by OPEN etc.
      -1  IOS unknown;
       0  ok;
      >0  error.
 Flags
       r  reserved; file name may not be known.
       n  named: file name known.
       o  OPENed
       w  rewound
       e  end-of-file condition: File should be closed but probably is not.
       c  CLOSEed
       f  formatted
       b  unformatted (binary)
 Zebra and GPACK flags:
       I  input
       O  output
       G  Gpack (default)
       M  Gpack with shared memory access
       A  Zebra alpha format
       N  Zebra native format (machine dependent)
       X  Zebra exchange format (still machine-dependent!)
       L  Zebra machine-independent format
 RECL: record length (direct access); 0: sequential
 NREC: number of records read/written
 STREAM: every stream may contain several concatenated files.
 NAME: file name
 TABLES: tables which are subject to I/O on this stream (given in a
         separate list)
>ACTION KALIOS
>PARAMETER
+
LUNSYM 'logical unit number or stream name' C D='0'
OPTION 'print destination' C D='tp'

>COMMAND LTABLES
>GUIDANCE
List names, hierarchy, and iostatus of tables and relations.
 Examples:
 LTABLES       list information for all banks
 LTABLES EVHD  list information for bank EVHD only.
.
 Description of the print-output:
 Link:    sequential link number (note: link 1 does not exist)
 Col:     number of columns
 Oc:      only Oc columns will be written on output files; Oc <= Col
 Rows:    number of rows currently booked
 Input:   # read from input
 Output:  # written to output
 D:       division (event / const)
 Name:    table name
 (header) Table is a header table
 h        name of the corresponding header table
 s1       first superior table; omitted if == header
 s2       2nd superior (relations only)
2nd list: list of relations, parallel tables, and other subordinate
tables depending on this table.
.
3rd list: list of I/O streams on which this table is expected.
 input:   table will be accepted on input files given later.
 /input:  table is flagged for input but one of the superior tables
          is not: discarded on input files.
 output, /output: corresponding to input, /input.
 All other keyword indicate stream names.
 File names preceded by a slash: table is flagged for I/O but one
 of the superior tables is not: discarded for I/O.
.
A < sign indicates input and a > sign output. For streams not referred
to in the present program and for data bases the input or output state
cannot be determined.
>ACTION KALTAB
>PARAMETER
+
NAME 'table name' C D=' '
OPTION 'print destination' C D='tp'

>COMMAND LZEBRA
>GUIDANCE
List content of Zebra array Q/IQ or of a specified table.
Arte tables are printed according to their data definition
unless option -F is given which causes printout
in all formats (int, float, hexadecimal, character). Other options
'TPL' determine the output destination (q.v.).
.
Examples
 LZEBRA 10000 30           list 30 words, starting at word 10000
 LZEBRA -f 10000           list 40 words (default), starting at word 10000
 LZEBRA MVER 400 -FP       list 400 words, starting at table MVER
Description of the output:
   word count in the working space
   word count inside the table
   r row number
   c column number
   | value either in the data format specified in the DD or
     value in the order int float 0xhex 'char'; a grave sign ` indicates
     an unprintable character; NAN is Not A Number. Trailing blank
     spaces are omitted even if they extend over several words.
 For tables only:
   attribute name
 For relations only: 
   relation name
   one/many indicator
   name of the table which the relation points to
   row numbers of the related entities (but not more than 1 line)
>ACTION KALZEB
>PARAMETER
LOCNAME 'location within array Q/IQ or table name' C D=' '
+
NWORDS 'nwords' I D=40
OPTION 'print destination; -f: all formats' C D='tp'

>COMMAND LROW
>GUIDANCE
List rows of a table.
Similar to the command LZEBRA. The first parameter
must be a table name, the second one a row number.
.
Examples
 LROW RTRA               list the whole table RTRA
 LROW RTRA 10 -F         list 10th track in all formats
 LROW RTRA 10 4 -T       list tracks 10,11,12,13 on terminal only
Output description: see LZEBRA.
>ACTION KALROW
>PARAMETER
NAME 'table name' C D=' '
+
ROW1 'first row / 0 -> all rows' I D=0
ROWS 'how many rows' I D=0
OPTION 'print destination; -f : all formats' C D='tp'

>COMMAND LCOLUMN
>GUIDANCE
List one column of a table / a whole table.
Similar to the command LZEBRA. The first parameter
must be a table name, the second one a column number.
.
Examples
 LCOL RTRA          list the whole table RTRA
 LCOL RTRA 11       list the 11th column of all tracks
 LCOL RTRA 11 -F    11th column of all tracks in dec, hex, char.
Output description: see LZEBRA.
>ACTION KALCOL
>PARAMETER
NAME 'table name' C D=' '
+
COL  'column number' I D=0
OPTION 'print destination; -f : all formats' C D='tp'

>COMMAND LMESSAGE
>GUIDANCE
List errors, warning, messages.
.
The message text appears as in the 1st occurrence of the message;
later modifications to the text are not taken into account.
>ACTION KALMES
>PARAMETER
+
OPTION 'print destination' C D='tp'

>COMMAND LEVENT
>GUIDANCE
List event current event number.
>ACTION KALEVH
>PARAMETER
+
OPTION 'print destination' C D='tp'

>COMMAND LMCTRUTH
>GUIDANCE
List Monte-Carlo truth: tables MTRA and MVER
.
 Examples:
   LMC        list all particles and vertices
   LMC 57     list particle 57 in table MTRA and its kin
   lMC B+     list all B+ mesons and their kin
Output description:
 track/resonance        vertex
 ===============        ======
 MTRA mother particle   MTRA incoming track (primary vertex: 0)
 pz         note the    z
 px         order of    x
 py       coordinates!  y
 mass                   ia: interaction number (non-primary vertices: 0)
 track length
    (10000: unknown)    -----> flag: 0: primary vertex; x=y=z=0;
                                     1: primary vertex at target;
                                     2: decay vertex; 3: kink;
                                     4: 2ndary,3rtiary, ... interaction
 flag: 0: just created; not yet processed
       1: expected to decay according to QMTRX_LENG
       2: decayed resonance or electromagnetic decay
          (production vertex = decay vertex)
       3: decay with non-zero track length
       4: track ends in a electromagnetic or
          hadronic interaction
       5: track leaves the detector volume
       6: track stops inside detector volume
       7: track curls up inside detector volume
 MVER vertex number
 imp: # of MIMPs
 cal: # of MCALs
 particle name; each dot represents one decay generation.
>ACTION KALMCT
>PARAMETER
+
NAMNUM 'particle name or particle number' C D=' '
OPTION 'print destination' C D='tp'

>COMMAND LMIMP
>GUIDANCE
List Monte Carlo Impact Points (MIMP)
Examples:
 LMIMP 0       list all MIMPs (lengthy!)
 LMIMP 4712    list MIMP 4712
 LMIMP -15     list MIMPs belonging to MC track (MTRA) 15.
>ACTION KALMIM
>PARAMETER
+
MIMP 'mimp / -mtra' I D=1
OPTION 'print destination' C D='tp'

>COMMAND LTOPP
>GUIDANCE
List ARTE Table of Particle Properties.
.
 Examples:
   LTOPP       list the properties all particles
   LTOPP 57    list particle 57 (whatever it is)
   ltopp PI+   list the properties of the pi+
Output description:
 name of the particle
 name of the antiparticle
 mass
 charge in units of quark charges
 colour information: 0 = colour singlet;
    1 = quark or anti-quark; 2 = gluon
   -1 = anti-diquark or diquark
 Lund decay flag (0 = no decay)
 width
 truncation value for Breit-Wigner
 Lund particle code
 Geant particle code
 Geant code of the antiparticle
 Arte particle code (row number in TOPP)
 life time (calculated from width)
>ACTION KALTOP
>PARAMETER
+
NAMNUM 'particle name or particle number' C D=' '
OPTION 'print destination' C D='tp'

>COMMAND LUTOPP
>GUIDANCE
List Lund Table of Particle Properties.
The data are taken from the Lund COMMONs LUDATn which are derived from
the Arte TOPP table; Lund, however, does not contain all particles
and all data of the TOPP table. Examples:
   LUTOPP       list the properties all particles
   LUTOPP 57    list particle 57 (whatever that is)
   LUTOPP pi+   list properties of the pi+
The 1st printed number is the so-called compressed Lund code.
Then the arrays CHAF, KCHG, PMAS, MDCY(*,1), and the Arte particle
code are printed.

>ACTION KALUTO
>PARAMETER
+
NAMENUM 'particle name orLund particle number' C D=' '
OPTION 'print destination' C D='tp'

>COMMAND LDECAY
>GUIDANCE
List ARTE Particle decay table.
The output can be used as input for another Arte job.
Example:
 LDEC B+      list decays for B+ and B-
 ldec 1       list decays for the 1st particle
 LDEC         all decays, lengthy!
The printed numbers are MDME(*,1), MDME(*,2), and the branching ratio
(see Lund manual).
>ACTION KALDEC
>PARAMETER
+
NAMNUM 'particle name or particle number' C D=' '
OPTION 'print destination' C D='tp'

>COMMAND LUDECAY
>GUIDANCE
List Lund Particle decay data.
LUDECAY and LDECAY (q.v.)  must give identical output as the Lund
decay data (COMMONs LUDATn) and the Arte decay table (TDEC)
must contain the same data.
>ACTION KALUDE
>PARAMETER
+
NAMNUM 'particle name or particle number' C D=' '
OPTION 'print destination' C D='tp'

>COMMAND LLUND
>GUIDANCE
List an event created by Lund and stored in COMMON /LUJETS/
(see SUBROUTINE LULIST described in the Lund manual; the 1st
parameter is the MLIST argument for LULIST).
>ACTION KALLUN
>PARAMETER
+
MLIST 'what to be listed' I D=1
OPTION 'print destination' C D='tp'

>COMMAND LDdef
>GUIDANCE
list the data definition table DDEF.
The listing is written in the format of Data Definition commands
and may serve as input for another job. All tables are listed if
no table name is specified.
>ACTION KALDDE
>PARAMETER
+
NAME   'table name' C D=' '
OPTION 'print destination' C D='tp'

>COMMAND MMSTAT
>GUIDANCE
List statiscics of tables.
 Examples:
 MMSTAT        list information for all tables
 MMSTAT  EVHD  list information for table EVHD only.
.
 Description of the print-output:
.
 Book     # bookings
 Drop     # droppings
 Extn     # extensions
 Maxr     maximum number of rows
 MeanRow  mean number of rows
 Nin      # read from input files
 Nout     # written to output files
 TabName  table name
>ACTION KASTATISTICS
>PARAMETER
+
NAME 'table name' C D=' '
OPTION 'print destination' C D='tp'

>COMMAND MMASTAT
>GUIDANCE
List statiscics of tables attributes.
 Examples:
 MMASTAT        list information for all tables
 MMASTAT  EVHD  list information for table EVHD only.
.
 Description of the print-output:
.
 . . . .  table name
.
 Low      allowed minimum value of attibute (if set)
 Upp      allowed maximum value of attibute (if set)
 Min      minimum value of attibute
 Max      maximum value of attibute
 AtrName  attibute name
>ACTION KAASTATISTICS
>PARAMETER
+
NAME 'table name' C D=' '
OPTION 'print destination' C D='tp'
