/************************************************************************
* MuMCTubHit2Digi.C
* first author : Oxana Barsoukova
* purpose      : Infill of DMUT table
* called from  : dgmuoo.F
* comment      : function gets ipl - number of gede plane
*                and chid - number of wire in gede (total number is 16) 
************************************************************************/

#include <stdio.h>
#include "etb.h"

#include "arte/arte.hh"
#include "arte/ArteTable.hh"
#include "arte/ArteMessage.hh"
#include "murec/MuDbTubeArte.h"


extern MuDbTubeArte  Tube;

extern "C"
{
  int acReadMuon(int);
  void mmbook_(int &, const int &);
  int CheckEndian();
  void FillCharArr(LWord, char*);
  void musini_();
}


extern "C" void mumctubhit2digi_(int& ipl, int& chid)
{
  musini_();

  static int OnceCall = 1;
  static Word CratesNumberT = 0;
  static Word CratesIdT[30];
  
  LWord HexConst = 0x1;
  LWord mask = 0;

  char  mudata[4];
  LWord HeaderStr = 0;
  LWord NWord = 0;
  LWord* TableWordRef = 0;
  LWord TableWord = 0;
  LWord nbit = 0;
  LWord nbit1 = 0;

  if (OnceCall)
    {
      OnceCall = 0;
      
// check that the object is initialized
      if(Tube.Ivalid != 1) acReadMuon(0);
      if(Tube.Ivalid != 1) 
      {
	arteMsg << "MuMCTubHit2Digi: tubes are not initialized";
        arteMsg.error();
        return;
      }

      Word CrateIdT_ = 0;
      
      for (int ii = 0; ii < 30; ii++)
	CratesIdT[ii] = CrateIdT_;
      
      for(Word sl=0; sl<Tube.TubeGeoSl; sl++)
	for(Word lay=0; lay<Tube.TubeGeoLay; lay++)
	  for(Word ud=0; ud<Tube.TubeGeoUpDown; ud++)
	    for(Word nx=0; nx<Tube.NchambT[sl][lay][ud]; nx++) // NchambT - number of chambers
	      {
		int found = 0;

		CrateIdT_ = Tube.CrateT[sl][lay][ud][nx]; // CrateT - crate's name

		for (int ii = 0; ii < 30; ii++)
		  if (CrateIdT_ != 0 && CrateIdT_ == CratesIdT[ii])
		    {
		      found = 1;
		      break;
		    }
		
		if(!found && CrateIdT_ != 0 && CrateIdT_ != CratesIdT[CratesNumberT])
		  {
		    CratesIdT[CratesNumberT] = CrateIdT_;
		    CratesNumberT++;
		    //		    break;
		  }
	      }

    } // end of OnceCall



  if (!ArteTable<DMUT>::booked())
    mmbook_(ArtePointer<DMUT>::getLink().getRef(), 18*34);
  
  for (LWord CrN = 0; CrN < CratesNumberT; CrN++)
    {
      HeaderStr = 2 + 34*CrN;
      FillCharArr(CratesIdT[CrN], mudata);
      ArtePointer<DMUT>(HeaderStr)->bits = mudata;
    }


  ArtePointer<GEDE> gede(ipl);
  Word sl = gede->gesl->nsl - 1;
  Word lay = gede->lay - 1;
  Word channel = chid - 1;


  for(Word ud=0; ud<Tube.TubeGeoUpDown; ud++)
    for(Word sd=0; sd<Tube.TubeGeoSd; sd++)
      for(Word nx=0; nx<Tube.NchambT[sl][lay][ud]; nx++)
	if (ipl == int(Tube.TubeGede[sl][lay][ud][nx][sd]))
	  for (LWord CrN = 0; CrN < CratesNumberT; CrN++)
	    if (CratesIdT[CrN] == Tube.CrateT[sl][lay][ud][nx])
	      {
		Word wire = (channel>=8) ? (channel-8) : channel;
		
		// Connectors of down modules put in order 0, 1 by X axis;
		// Connectors of upper modules in order 1, 0
		Word nc;
		if ((channel<= 7 && ud == 1) || (channel > 7 && ud == 0))
		  nc = 0;
		if ((channel > 7 && ud == 1) || (channel <= 7 && ud == 0))
		  nc = 1;
		
		nbit1 = Tube.Nbit1T[sl][lay][ud][nx][nc][sd];
		int  step  = Tube.StepT[sl][lay][ud][nx];
		int astp   = (step<0)? -step : step;
		
		// Wires in upper modules are swapped inside each connector
		if (ud == 0) wire = 7 - wire;
		nbit = nbit1 + astp*wire;
		
		
		LWord nwd=nbit/32;
		LWord nbt1 = nbit - 32*nwd;
		nbit = 32*nwd + 31-nbt1;
		
		HeaderStr = 2 + 34*CrN;
		NWord = HeaderStr + nbit/32 + 1; // Number of word
		TableWordRef = (LWord*)(ArtePointer<DMUT>(NWord+1)->bits);
		
		if (CheckEndian() == 1)
		  TableWord = *TableWordRef;
		else if (CheckEndian() == 2)
		  TableWord = ESP_SWAP_INT(*TableWordRef);
		
		Word nw = nbit/32;
		Word nbtt = nbit - 32*nw;
		Word nbyte = nbtt/8;
		Word nbb = nbtt - 8*nbyte;
		Word nb = 7 - nbb;
		Word nbt = 8*nbyte+nb;
		
		mask = HexConst << nbt;
		TableWord = TableWord | mask;
		
		FillCharArr(TableWord, mudata);
		ArtePointer<DMUT>(NWord+1)->bits = mudata;
	      }
  return;
} 






