#ifndef MuDbEffPixel_h
#define MuDbEffPixel_h 1

//## Class: MuDbEffPixel
//      /**Author:        Boris Fominykh
//
//      Date:             May 6th, 2002
//
//      Class:            MuDbEffPixel
//
//      Base Class:       MuDbTable
//
//      Description:
//      This class is to read the pixel chamber efficiencies from DB MUON_NEW*/

#include "murec/MuDbTable.h"
#include <set>
#include "murec/MuEffPixel.h"

typedef unsigned short Word;
typedef unsigned int   LWord;

/////////////////////////////////////
static bool
operator<(const MuEffPixel c1, const MuEffPixel c2)
{
      return c1.key <= c2.key;
}
/////////////////////////////////////

class MuDbEffPixel : public MuDbTable
{
  public:
    //## Constructor
           MuDbEffPixel();
    //## Destructor
           ~MuDbEffPixel();

    //public methods
      //        /** Initialization */
      void Ini(int rormc);
      //        /**Clear the object*/
      void Clear();
      //        /**Read the table as it's defined in kumac */
      int Read();
      //        /**Read the table from DB */
      int ReadDB();
      //        /**Read the table from ascii-file*/
      int ReadFile();
      //        /**Print the efficiencies collected in set */
      void Print();
      //        /**Get the efficiency */
      float GetEff(int sl,int qu,int nx,int ny);

    //## Get and Set Operations for Class Attributes
      void MuDbEffPixel::setRorMC(int value);

    int    Valid;
    int    RorMC;   // 0- real measured efficiency, 1- MC efficiency

  protected:

  private:

    static const Word SlM  = 4;
    static const Word QuM  = 4;

  // number of collected containers
    Word Ncont[SlM][QuM];
  // set of containers
    set<MuEffPixel> Cont[SlM][QuM];

  //        /**Add the next container to object*/
      int Add(MuEffPixel* con);
};

//## Get and Set Operations for Class Attributes (inline)

inline void MuDbEffPixel::setRorMC(int value)
{
  RorMC=value;
}

#endif

