#ifndef MuDbPixel_h
#define MuDbPixel_h 1

//## Class: MuDbPixel
//      /**Author:        Boris Fominykh
//
//      Date:             December 30, 1999
//        updated         May 6th, 2002 - /MUON_NEW implemented
//
//      Class:            MuDbPixel
//
//      Base Class:       MuDbChamber
//
//      Description:
//      This class is to describe the configuration of muon pixel chambers */

#include "murec/MuDbConfig.h"
#include "murec/MuDbHots.h"
#include "murec/MuDbChamber.h"
#include "murec/MuPixChamber.h"

typedef unsigned int   LWord;
typedef unsigned short Word;

class MuDbPixel:  public MuDbChamber
{
  public:
    //## Constructor
           MuDbPixel();
    //## Destructor
           ~MuDbPixel();

    //public methods
      //        /** Clear the object */
      void Clear();
      //        /** Set the cable connection */
      int SetConnect();
      //        /**Print the contents of the object*/
      void Print();

    int Ivalid;

    static const Word PixGeoSl = 4;
    static const Word PixGeoQu = 4;
//## number of connectors per chamber
    static const Word PixNcon = 24;

// GEDE volumes
    LWord PixGede[PixGeoSl][PixGeoQu];
// list of pixel chamber names
    char ChamListX[PixGeoSl][PixGeoQu][9];
//##  pixel readout mask
    Word MaskX[PixGeoSl][PixGeoQu][PixNcon];
//## first bit inside crate, the sign indicates the direction
    int  Nbit1X[PixGeoSl][PixGeoQu][PixNcon];
//## crate number
    Word  CrateX[PixGeoSl][PixGeoQu][PixNcon];

  protected:

  private:

};

#endif
