
#ifndef MuDbTable_h
#define MuDbTable_h 1

//## Class: MuDbTable
//      /**Author:        Boris Fominykh
//
//      Date:             January 19, 2000
//        updated         May 6th, 2002 - /MUON_NEW implemented
//
//      Class:            MuDbTable
//
//      Base Class:       none
//
//      Description:
//      This is a base class for muon DataBase tables*/

#include "database/keytable.h"

class MuDbTable
{
  public:
    //## Constructor
           MuDbTable();
    //## Destructor
           ~MuDbTable();

    //public methods
      //        /**Initialization*/
      void Ini();
      //        /**Open DB, write=1 - permission to write*/
      int Open(int write);
      //        /**Close DB*/
      void Close();
      //        /**Fetch the table*/
      int Fetch();
      //        /**String analysis*/
      int Itl(char*,int);

    //## Get and Set Operations for Class Attributes
      void MuDbTable::setOldOrNew(int value);
      void MuDbTable::setMajor(int value);
      void MuDbTable::setMinor(int value);
      void MuDbTable::setDBname(char* name);
      void MuDbTable::setName(char* name);
      void MuDbTable::setTitle(char* title);
      void MuDbTable::setDesc(char* description);
      void MuDbTable::setFile(char* filename);
      void MuDbTable::setKTstatus(int value);
      int  MuDbTable::getKTstatus();
      int  MuDbTable::getOldOrNew();
      const char* MuDbTable::getDBname();

  protected:

      int  KTstatus;
      char DBname[256];
      int  OldOrNew;
      char DBtable[256];
      char Title[64];
      char Desc[128];
      char FileName[128];
      int  MUserver;
      int  MUtable;
      int  Major;
      int  Minor;
      Tables X;
      int  T;
      int  Nf;
      int  Size;
      int  IvalT;

  private:

};

//## Get and Set Operations for Class Attributes (inline)

inline void MuDbTable::setOldOrNew(int value)
{
  OldOrNew=value;
}

inline void MuDbTable::setMajor(int value)
{
  Major=value;
}

inline void MuDbTable::setMinor(int value)
{
  Minor=value;
}

inline void MuDbTable::setKTstatus(int value)
{
  KTstatus=value;
}

inline int MuDbTable::getKTstatus()
{
  return KTstatus;
}

inline int MuDbTable::getOldOrNew()
{
  return OldOrNew;
}

inline const char* MuDbTable::getDBname()
{
  return &DBname[0];
}


#endif





