
// Boris Fominykh 6.05.2002
// returns efficiency of pixels

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <iostream.h>
#include <iomanip.h>

#include "arte/arte.hh"
#include "arte/ArteMessage.hh"

#include "murec/MuDbEffPixel.h"

  static MuDbEffPixel EffXR;
  static MuDbEffPixel EffXMC;
  static int First = 0;

float mueffx(int sl,int qu,int nx,int ny)
{
// initialization in first call
  if(First == 0)
  {
    First = 1;

    EffXR.Ini(0);
    int rr = EffXR.Read();
    if(rr != 0)
    {
      arteMsg << "mueffx: EffXR.Read() return= " << rr << endl;
      arteMsg.error();
      return -1.;
    }
    EffXR.Print();

    EffXMC.Ini(1);
    int rm = EffXMC.Read();
    if(rm != 0)
    {
      arteMsg << "mueffx: EffXMC.Read() return= " << rm << endl;
      arteMsg.error();
      return -1.;
    }
    EffXMC.Print();
  }

// check that objects are initialized
  if(EffXR.Valid != 1 || EffXMC.Valid != 1)
  {
    arteMsg << "mueffx: objects are not initialized " << EffXR.Valid << " " << EffXMC.Valid << endl;
    arteMsg.error();
    return -1.;
  }

// get efficiency
  float efr = EffXR.GetEff(sl,qu,nx,ny);
  float efm = EffXMC.GetEff(sl,qu,nx,ny);
  float eff = 0.;
  if(efm > 1.e-5) eff=efr/efm;
  if(eff > 1.) eff=1.;

  // cout << "mueffx: sl " << sl << " qu " << qu << " nx " << nx << " ny " << ny;
  // cout << " efr= " << efr << " efm= " << efm << " eff " << eff << endl;

  return eff;
}

