
*  B.Fominykh  25.04.2000
*  the program of MuonID package
*  calculates the likelihood contributions for pad chambers
*
*  input:  MSL      - muon superlayer
*          NCL      - number of clusters
*          LCL(NCL) - list of clusters
*          ISD      - # seed
*          IPR      - print control
*  otput:  LHS      - shape likelyhood
*          LHP      - position (deflection) likelyhood
*
*  updated 05.01.2001 by B.Fominykh - tune the parameters
*
*
      SUBROUTINE MURLHPAD(MSL,NCL,LCL,ISD,IPR,LHS,LHP)
C-    ================================================
      IMPLICIT NONE
      INTEGER MSL,IPR,NCL,LCL(1),IC,JC,ISD,JSD,I,II
      INTEGER NPAD,RLAY,IH,JH
      REAL XD(2),ZD(2),ERX(2),LH(2),RES(2)
      REAL LHS,LHP,Z0,CX,CY,TX,TY,EMS,EXTX,ERT
      REAL EFF,UNEFT,UNEFP
***      DATA EFF /1./,UNEFT /0.1/,UNEFP /0.05/ 
      DATA EFF /1./,UNEFT /0.3/,UNEFP /0.4/ 

#include "murec/MUCBTAB.fi"
#include "arte/Arte.fi"
#include "arte/Arte.ff"
C----+===1=========2=========3=========4=========5=========6=========7==********
***      LHS=-1.
      LHS=-ALOG(UNEFT)
      LHP=-1.
      IF(NCL.LT.1) RETURN
      IF(MSL.LT.3.OR.MSL.GT.4) RETURN

* clusters
      IF(JTMP8.LE.0)       GOTO 999
      IF(IQ(JTMP8+1).LE.0) GOTO 999
      IF(IQ(JTMP8+2).LT.3) GOTO 999
      NPAD=0
      ERX(1)=-10.
        ERX(2)=-10.
      DO I=1,NCL
        IC=LCL(I)
        IF(IC.LE.0.OR.IC.GT.IQ(JTMP8+2)) GOTO 999
        JC=JTMP8+IQ(JTMP8+1)*(IC-1)+2
        IF(IQ(JC+5).EQ.2) NPAD=NPAD+1
        IF(IQ(JC+5).EQ.1) THEN
* reconstruction layer
          IH=IQ(JC+15)
          JH=JTMP9+IQ(JTMP9+1)*(IH-1)+2
          RLAY=IQ(JH+2)
          IF(RLAY.EQ.10*MSL-11.OR.RLAY.EQ.10*MSL-7) II=1
          IF(RLAY.EQ.10*MSL-8.OR.RLAY.EQ.10*MSL-4)  II=2
          XD(II) =Q(JC+8)
          ZD(II) =Q(JC+6)
          ERX(II)=Q(JC+11)
        ENDIF
      ENDDO

* shape likelyhood
      IF(NPAD.GT.0) THEN
        LHS=-ALOG(EFF)
      ELSE
        LHS=-ALOG(UNEFP)
      ENDIF
      DO I=1,2
        IF(ERX(I).GT.0.) THEN
          LHS=LHS-ALOG(EFF)
        ELSE
          LHS=LHS-ALOG(UNEFT)
        ENDIF
      ENDDO

*      IF(ERX(1).GT.0..AND.ERX(2).GT.0.) THEN
*        IF(ABS(XD(1)-XD(2)).LT.2.*(ERX(1)+ERX(2))) THEN
*          LHS=LHS-2.*ALOG(EFF)
*        ELSE
*          LHS=LHS-2.*ALOG(UNEFT)
*        ENDIF
*      ELSE
*        LHS=LHS-2.*ALOG(UNEFT)
*      ENDIF

* seed parameters
      IF(JTMP6.LE.0)       GOTO 999
      IF(IQ(JTMP6+1).LE.0) GOTO 999
      IF(ISD.LE.0.OR.ISD.GT.IQ(JTMP6+2)) GOTO 999
      JSD=JTMP6+IQ(JTMP6+1)*(ISD-1)+2
* error of multiple scattering
      IF(MSL.EQ.3) EMS=Q(JSD+29)
      IF(MSL.EQ.4) EMS=Q(JSD+31)
* error of extrapolation
      I=JSD+MSL*6+54
      IF(MSL.EQ.4) I=I-1
      EXTX=Q(I)
      Z0=Q(JSD+5)
      CX=Q(JSD+6)
      CY=Q(JSD+7)
      TX=Q(JSD+8)
      TY=Q(JSD+9)

* position (deflection) likelyhood
      LHP=0.
      DO I=1,2
        IF(ERX(I).GT.0.) THEN
          RES(I)=XD(I)-CX-TX*(ZD(I)-Z0)
          ERT=EMS**2+EXTX**2+ERX(I)**2
          LH(I) =0.5*(ALOG(ERT)+RES(I)**2/ERT)
          LHP=LHP+LH(I)
        ELSE
          LH(I)=-1.
        ENDIF
      ENDDO

 999  CONTINUE
      IF(IPR.GT.0) THEN
        PRINT 1001,(I,XD(I),ZD(I),RES(I),EMS,EXTX,
     +             ERX(I),LH(I),I=1,2)
 1001   FORMAT(1X,I1,' X,Z',F9.2,F10.2,' res',F7.2,
     +               ' err',3F6.2,' LH',E12.4)
        PRINT 1002,LHS,LHP
 1002   FORMAT(1X,' LHS',E12.4,' LHP',E12.4)
      ENDIF

*
      RETURN
      END




