        subroutine dicellv(idpl)
*********************************************************
*
* Draws all honeycomb cells of plane idpl in Prism framework.
*   (Preliminary version! Draws only on X-Z plane)
*
* Parameters:
*   idpl  - identifier of GEDE plane
* 
* Called routines:
*   HIGZ:    igqwk isclip iuwk igsg igset ifa ipl islwsc igarc
*
* Author: Alexander Lanyov   Apr 97
*         taylored for prism/didraw by Rainer Mankel  Apr 97
*
*********************************************************
        implicit none

#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "pris/zmh.fi"
#include "pris/zgraf.fi"
#include "gean/ZGESL.fi"

C****        character*(*) chopt
        real xxx(7),yyy(7),zzz(7),sintot,costot
	real ri,ro,pit,dia,xw,x,y,z,wn(4),rwire,col
	real xmin,xmax,zmin,zmax
	real xoffoct(7),zoffoct(7)
        integer iwkid,i,isl,pl,pl1,pl2,nl,il,nw,iw,isec,idpl
	logical ltop,lside

#include "arte/Arte.ff"
#include "auto/GEO.ff"

	data xoffoct/+1., +0.5, -0.5, -1., -0.5, +0.5, +1./
	data zoffoct/ 0., +0.5, +0.5,  0., -0.5, -0.5, +0./

**	call iselnt(51)		! switch to Prism NT
**      call isclip(1)

        if (jgede.le.0) go to 999

        iwkid=1
        call igqwk(iwkid,'NTWN',wn)
	zmin=wn(1)
	zmax=wn(2)
	xmin=wn(3)
	xmax=wn(4)

c------------------------------------------------------ Loop on superlayers
        do isl=1,1
         pl1 = idpl
	 pl2 = idpl
	 if (igede_cmp(idpl) .ne. lgesl_wch) pl2=0

c------------------------------------------------------ Loop on planes
         do pl=pl1,pl2

	  if (fgede_rot(1,pl) .ne. 1.) goto 100

          sintot = fgede_sin(pl) * fgede_rot(1,pl) ! total coordinate angle
     &           + fgede_cos(pl) * fgede_rot(2,pl)

          costot = fgede_cos(pl) * fgede_rot(1,pl)
     &           - fgede_sin(pl) * fgede_rot(2,pl)

          if (.not.lstereozg) then
            if (abs(sintot).gt.0.001) go to 100
          endif

          ltop = (abs(sintot).lt. 0.01 .and. iviewzg.eq.1)
     &          .or. (sintot .gt. 0.01 .and. iviewzg.eq.7)
     &          .or. (sintot .lt.-0.01 .and. iviewzg.eq.8)

          lside = (.not.ltop) .and.
     &       iviewzg.eq.0 .or. (iviewzg.ge.3 .and. iviewzg.le.6)

          if (.not.ltop) goto 100

          call igsg(1)

	  nl  = igede_nsl(pl)
	  pit = fgede_pit(pl)

	  dia = pit/sqrt(3.)
          dia = 0.1 * int(fgede_dod(pl)*20.01 + 0.5)  ! Diameter in cm (rounded)
          ri = fgede_dod(pl) ! inner radius of hexagon
          ro = 0.5*dia       ! outer radius of hexagon

	  isec = igede_sec(pl)		! to use this for color output?

c---------------------------------------------------- Loop on monolayers
	  do il=1,nl
	   xw = fgede_xfw(il,pl)
	   z  = fgede_zfw(il,pl)
	   nw = igede_nwi(il,pl)

	   if ((z-ro).gt.zmax) goto 991
	   if ((z+ro).lt.zmin) goto 991

c--------------------------------------------------- Loop on wires
  	   do iw=1,nw
	    x = xw + (iw-1)*pit

	    if ((x-ro).gt.xmax) goto 99
	    if ((x+ro).lt.xmin) goto 99

c	    if (iw.eq.1 .or. iw.eq.nw)
c     &       write (*,'('' dicellv: Drawing sl='',i2,'', pl='',i4,
c     &                  '' il='',i1,'', iw='',i2,'', dia='',f5.2)')
c     &             isl,pl,il,iw,dia

c--------------------------------------------------- Loop on corners
            do i=1,7  ! corners of hexagon
             zzz(i) = z + dia * zoffoct(i)
             xxx(i) = x + pit/3. * xoffoct(i)
            end do
c--------------------------------------------------- End of loop on corners


             call igset('FACI',cocevzg)	! HIGZ, p.27 - fill area color index
             call igset('FAIS',1.)	! HIGZ, p.28 - fill area style index

            call ifa(7,zzz,xxx)		! HIGZ, p.25 - fill area

            call igset('PLCI',cocebzg)	! HIGZ, p.90 - polyline color index
            call islwsc(1.)		! HIGZ, p.31 - line width scale factor
            call ipl(7,zzz,xxx)		! HIGZ, p.24 - polyline

	    rwire = 25.e-4
	    if ((wn(4)-wn(3)) .lt. 20.) then
	     rwire = max(rwire, 0.001*(wn(4)-wn(3)))
	    end if
	    call igarc(z,x,rwire,rwire,0.,0.) ! draw an arc - here circle

c          elseif (lside) then
c           call igset('PLCI',cowirzg) ! both wire ends visible
c           call ipl(2,xxxw,yyyw)
c           endif

99	    continue
           end do
c--------------------------------------------------- End of loop on monolayers

991	   continue
 	  end do

100 	  continue
         end do
c--------------------------------------------------- End of loop on planes
        end do
c--------------------------------------------------- End of loop on superlayers

 999    continue
	return
        end
