
>Name DIKUIP

>Menu DISPLAY
>Guidance
Commands related to the event visualisation tool prism.

>Command DETECTOR
>Parameters
+
ISLFIRST 'Id of first superlayer to be displayed' I D=0
ISLLAST  'Id of last  superlayer to be displayed' I D=0
CHOPT 'Options' C D=' '
>Guidance
Display detector within scope defined by the display/scope command.
Optionally restrict to a given superlayer range. 
Options:
  -A : add to existing plot (no workstation clear)
  -B : B0 daughters only
  -C : display isochrones for drift devices
  -F : display found tracks only
  -G : display GEANT hits (Monte Carlo Impact Points)
  -I : plot and print plane info, pause after each plane
  -L : wire addresses are listed while drawn
  -M : draw the Monte-Carlo track
  -N : display number of MC particle on the right side of the hit
  -P : list MC information for each hit
  -R : display reference tracks only
  -T : draw the reconstructed track
  -U : show only ghost tracks (with -T)
  -V : show vertices
  -W : draw the active wires
  -0 : show only track reconstructed in 0-deg planes
  -Y : show only track reconstructed in stereo planes
  -Z : use polyline (Zigzag) rather than smooth curve for MC track

>Action DIDET

>Command SUPERLAYER
>Parameters
+
ISLFIRST 'Id of first superlayer to be displayed' I D=0
ISLLAST  'Id of last  superlayer to be displayed' I D=0
CHOPT 'Options' C D=' '
>Guidance
Display range of superlayers.
Options:
  -A : add to existing plot (no workstation clear)
  -B : B0 daughters only
  -C : display isochrones for drift devices
  -F : display found tracks only
  -G : display GEANT hits (Monte Carlo Impact Points)
  -I : plot and print plane info, pause after each plane
  -L : wire addresses are listed while drawn
  -M : draw the Monte-Carlo track
  -N : display number of MC particle on the right side of the hit
  -P : list MC information for each hit
  -R : display reference tracks only
  -T : draw the reconstructed track
  -U : show only ghost tracks (with -T)
  -V : show vertices
  -W : draw the active wires
  -0 : show only track reconstructed in 0-deg planes
  -Y : show only track reconstructed in stereo planes
  -Z : use polyline (Zigzag) rather than smooth curve for MC track

>Action DISUPL

>Command PLANE
>Parameters
IPL 'Id of plane' I D=28
+
CHOPT 'Options' C D=' '
>Guidance
Display plane IPL.
Options:
  -A : add to existing plot (no workstation clear)
  -B : B0 daughters only
  -C : display isochrones for drift devices
  -F : display found tracks only
  -G : display GEANT hits (Monte Carlo Impact Points)
  -I : plot and print plane info, pause after each plane
  -L : wire addresses are listed while drawn
  -M : draw the Monte-Carlo track
  -N : display number of MC particle on the right side of the hit
  -P : list MC information for each hit
  -R : display reference tracks only
  -T : draw the reconstructed track
  -U : show only ghost tracks (with -T)
  -W : draw the active wires
  -0 : show only track reconstructed in 0-deg planes
  -Y : show only track reconstructed in stereo planes
  -Z : use polyline (Zigzag) rather than smooth curve for MC track

>Action DISPL

>Command DRAW

>Guidance
(Re)draw the detector using the latest (or default) set of redraw
parameters.

>Action DIDRAW

>Command STYLE
>Parameters
+
MTMIMP 'use mimps to draw MC tracks (y/n) ?' C D=' '
RTRHIT 'use rhits to draw RC tracks (y/n) ?' C D=' '
CR*OSS  'draw crosses at rhit position (y/n) ?' C D=' '
O*PAQUE 'draw opaque detector planes (y/n) ?' C D=' '
H*EADER 'draw header (y/n) ?' C D=' '
F*RAME  'draw frame (y/n) ?' C D=' '
AX*IS   'draw axes (y/n) ?' C D=' '
T*YPE   'draw particle type string (y/n) ?' C D=' '
ST*EREO 'show stereo plane (y/n) ?' C D=' '
BA*CKGROUND 'use background colour (y/n) ?' C D=' '
MT*RA   'show MC tracks (y/n) ?' C D=' '
B0      'restrict to golden B0 daughters (y/n) ?' C D=' '
RT*RA   'show RC tracks (y/n) ?' C D=' '
MI*MPS  'show MIMPS (y/n) ?' C D=' '
QU*ANT  'show QUANTITY (y/n) ?' C D=' '
HI*T    'show wires/hits (y/n) ?' C D=' '
AS*PECT 'force conserved aspect ratio (y/n) ?' C D=' '
GW*AL   'draw walls (y/n) ?' C D=' '
SE*NS   'use sensitive areas for drawing planes (y/n) ?' C D=' '
MV*ER   'draw MC vertices (y/n) ?' C D=' '
GE*DE   'draw planes (y/n) ?' C D=' '
SC*LIP  'apply software clipping (y/n) ?' C D=' '
NE*UT   'show neutral MC particles (MTRA must be active) (y/n) ?' C D=' '
CH*AIN  'show whole decay chain (y/n) ?' C D=' '
EV*ER   'show end vertices (y/n) ?' C D=' '
MAG*NET 'show magnet (y/n) ?' C D=' '
RV*ER   'show reconstructed vertices (y/n) ?' C D=' '
SPL*INE 'use spline to display tracks in magnet (y/n) ?' C D=' '
RS*EG   'show reconstructed segments (y/n) ?' C D=' '
CE*LL   'show detector cells (y/n) ?' C D=' '
TA*RGET 'show target (y/n) ?' C D=' '
RP*NT   'draw reconstructed points (y/n) ?' C D=' '
RCC*L   'draw reconstructed clusters (y/n) ?' C D=' '
GC*AL   'draw ECAL cells (y/n) ?' C D=' '
SL*T    'show SLT info (y/n) ?' C D=' '
WIDMT   'width factor of MC lines' R D=0.
WIDRT   'width factor of RC lines' R D=0.
ZCONT   'Z coordinate to which RSEGs are continued' R D=-999.
PMIN    'Minimal momentum of neutral particle to display' R D=-999.
CHOPT   'Options' C D=' '
>Guidance
Set parameters which influence the drawing style.
Option L displays the current values.

Options:
  -L : display current option values

>Action DISTYLE

>Command SCOPE
>Parameters
+
SCOPE1  'Scope descriptor' C D=' '
SCOPE2  'Scope descriptor' C D=' '
SCOPE3  'Scope descriptor' C D=' '
SCOPE4  'Scope descriptor' C D=' '
SCOPE5  'Scope descriptor' C D=' '
SCOPE6  'Scope descriptor' C D=' '
SCOPE7  'Scope descriptor' C D=' '
SCOPE8  'Scope descriptor' C D=' '
SCOPE9  'Scope descriptor' C D=' '
SCOPE10 'Scope descriptor' C D=' '
SCOPE11 'Scope descriptor' C D=' '
SCOPE12 'Scope descriptor' C D=' '
SCOPE13 'Scope descriptor' C D=' '
SCOPE14 'Scope descriptor' C D=' '
SCOPE15 'Scope descriptor' C D=' '
CHOPT   'Options' C D=' '
>Guidance
Define the display scope through descriptors for superlayer names.
Option 'L' just lists the current scope, ignoring all other arguments.

The scope arguments may be superlayer names - including a trailing
asterisk as placeholder - or a predefined group name. Examples:

  display/scope TC*        - display OT trigger chambers only
  display/scope SI08 SI09  - display some magnet silicons only
  display/scope MX*        - display muon pixel chabmers only

Valid group names:

  SIVD  - all silicons with z<200cm
  MAIN  - all silicon, MSGC and HDC trackers with z>200cm
  FULL  - all silicon, MSGC and HDC trackers
  IMAIN - all inner main trackers
  OMAIN - all outer main trackers
  MAG   - all magnet trackers
  IMAG  - all inner magnet trackers
  OMAG  - all outer magnet trackers
  PAT   - all pattern trackers
  IPAT  - all inner pattern trackers
  OPAT  - all outer pattern trackers
  TRIG  - all trigger trackers
  ITRIG - all inner trigger trackers
  OTRIG - all outer trigger trackers
  ECAL  - calorimeter
  MUON  - all muon chambers
  PT    - all high-pt trigger chambers

Example:

  display/scope SIVD IMAG     - display vertex detector and inner 
                                magnet tracker

Options:
  -I  : add items to present scope
  -O  : remove items from present scope
  -L  : list present scope

Example:

  display/scope MS03 -O       - remove MS03 from present scope

>Action DIKSCOPE


>Command PARAMETERS
>Parameters
+
MT*RA   'Restrict to MC track ' I D=-1
RT*RA   'Restrict to RC track ' I D=-1
RV*ER   'Restrict to RC vertex ' I D=-1
CMP     'Restrict to component ' I D=-1
LAYER   'Restrict to layer' I D=-1
SECTOR  'Restrict to sector' I D=-1
TOPP    'Restrict to particle type' I D=0
CTOPP   'Restrict no particle name' C D=' '
CHOPT   'Options' C D=' '
>Guidance
Define parameters for subsequent display/draw commands.
Option -R resets all parameters
>Action DIKPARAM

>Command FRAME
>Parameters
+
XLEFT   'Left   x bound of frame ' R D=0.0
XRIGHT  'Right  x bound of frame ' R D=0.0
YLOW    'Lower  y bound of frame ' R D=0.0
YHIGH   'Higher y bound of frame ' R D=0.0
CHOPT   'Options' C D=' '
FACTOR  'How much to move (in units of current frame size)' R D=1.
>Guidance
Define new frame via explicit world coordinates, or via rubberband.
Option 'R' resets to original frame.
 
Options:
  -R : reset to standard frame. The standard frame is determined from
       the detector dimensions in x,y,z projected into the current
       view
 
  -B : go back to the previous frame. prism remembers the five last 
       frames.
 
  -I : Zoom in (2x)
 
  -O : Zoom out (2x)
 
  -N : No automatic redraw
 
  -U : Move window Up
  -D : Move window Down
  -L : Move window Left
  -T : Move window righT
 
>Action DIFRAM

>Command ANGLES
>Parameters
THETA 'Polar angle of observers view' R D=70. R=-180.:180.
PHI   'Azimuth angle of observers view' R D=0. R=-360.:360.
+
CHOPT 'Options' C D=' '
>Guidance
Define the 3D viewing angles used for view 3.

Options:

  -N : No automatic redraw

>Action DIANGL

>Command SCALE
>Parameters
+
FSCALX 'x axis scale factor' R D=1.
FSCALY 'y axis scale factor' R D=1.
FSCALZ 'z axis scale factor' R D=1.
>Guidance
Define additional scaling factors for each axis.

>Action DISCAL

>Command VIEW
>Parameters
+
IVIEW 'Identifier of view selection' I D=-1
CHOPT 'Options' C D=' '

>Guidance
Select the VIEW identifier, which determines the detector projection
into the twodimensional plane.
Possible values:

    IVIEW = 0      xy projection
            1      xz     
            2      yz     
            3      free 3D   (see ANGLES command)
            4      isometric projection
            5      dimetric     
            6      trimetric
            7      u
            8      v
            9      cone-corrected
           10      cone-corrected, pseudo-logarithmic x-scale

Any other integer keeps the view unchanged.

Options:
  -F : view is directed forward in z (relevant for hidden lines removal)
  -B : view is directed backward in z (standard)
  -N : No automatic redraw


>Action DIVIEW

>Command HEADER
>Guidance
Draw prism header & edge on top of current picture.
>Action DIKHEAD

>Command CLIP
>Parameters
ICLIP 'Clipping mode' I D=1 R=0,1

>Guidance
See HIGZ manual under ISCLIP

>Action DICLIP

>Command SELNT
>Parameters
NT 'Normalization transform id' I D=1

>Guidance
See HIGZ manual under ISELNT

>Action DISELNT

>Command COLOR
>Parameters

CR  'Red volume' R D=1.0
CG  'Green volume' R D=1.0
CB  'Blue volume' R D=1.0

>Guidance
Test a color mixture in rgb space.

>Action DICOLR

>Command SETCOL
>Parameters
+
IC  'Color index'  I D=15
CR  'Red volume'   R D=1.0
CG  'Green volume' R D=1.0
CB  'Blue volume'  R D=1.0
CHOPT 'Options' C D=' '

>Guidance
Add/change colour mixture. Option -L displays colors defined.

Note:
Use the ASSIGNCOL command without parameters to see which colour
indices are already used.


>Action DISETC

>Command ASSIGNCOL
>Parameters

OBJECT 'Object to be assigned' C D=' '
COLOR  'Color index'  I D=-1

>Guidance
Assign color index to object name.
If the color index is not predefined it must have been generated
from rgb code by the SETCOL command.

If no OBJECT argument is given, the current assignments will be listed.

>Action DIASSC


>Command PICK
>Parameters
PICKITEM  'Kind of item to be picked' C D=' '

>Guidance
Pick graphical objects in display window. Possible pick items are:

      MTRA  - pick Monte Carlo track
      RTRA  - pick reconstructed track 
      RSEG  - pick reconstructed segment
      MImp  - pick Monte Carlo impact point
      Hit   - pick detector hit
      Gede  - pick detector plane
      MV    - pick Monte Carlo vertex   (planned)
      RV    - pick reconstructed vertex (planned)
      Gwal  - pick wall                 (planned)

>Action PKPICK


>Command DQUERY

>Guidance
Query status of graphical workstations

>Action DIQUERY


>Command SAVE
>Parameters

KUNAME  'Name of KUMAC file where parameters should be saved ' C D='dummy.kumac'
+
KUDIR   'Directory in which to store KUMAC file' C D=' '

>Guidance
Store graphics constants (frame etc) to a KUIP macro

>Action DISAVE


>Command DILAY
>Guidance
Displays OTR superlayer with specified stereo layer (stereo layer 0 means all).
Each sector is marked by a special color.
It is recommended that the following Prism styles should be turned on:
  sty opaque=y; (otherwise sectors will be not filled with colors)
  sty stereo=y; (otherwise only zero angle stereo layers will be displayed)
  sty sens=y;   (otherwise all volume will be displayed
                 both nonsensitive and sensitive ones)
  view 0;       (Good views for displaying sectors are 0 or 3)
If first parameter is ALL then all OTR superlayers are displayed.
>Action DILAY
>Parameter
SL     'Superlayer name (or ALL)' C D='ALL'
+
LAY    'Stereolayer (=0 for all)' I D=0.


>Command PIBOX
>Guidance
Draws box.
>Action PIBOX
>Parameter
x1     'x1' R D=0.
x2     'x2' R D=0.
y1     'y1' R D=0.
y2     'y2' R D=0.
color 'Fill area color index (FACI)'      R D=0.
+
fais 'Fill area interior style (1=solid)' R D=1.
fasi 'Fill area style index'              R D=0.
bord 'Border flag (0=not drawn, 1=drawn)' R D=0.
plci 'Border line color'                  R D=1.
lwid 'Border line width'                  R D=1.
ltyp 'Border line type'                   R D=1.

 
>Command PILINE
>Guidance
Draws line. If envoked without parameters, asks for graphical input.
>Action PILINE
>Parameter
+
x1    'x1'         R D=0.
y1    'y1'         R D=0.
x2    'x2'         R D=0.
y2    'y2'         R D=0.
color 'line color' R D=1.
width 'line width' R D=1.

 
>Command DICELL
>Guidance
Displays a cut view of OTR honeycomb cells in Prism framework.
Picture is overlayed on the existing Prism picture.
Only cells with sense wires are drawn.
Cells which are only partially intersected by the cross-section plane
are not drawn.
Prism views 1-8 are supported.

Selection of cut value can be done by one of the following ways:
 - specifying one constant cut value (CUTVAL);
 - specyfying two cut values at two different Z coordinates
   (CUTVAL at Z1, CUTVAL2 at Z2);
 - specifying RSEG or MTRA.
If nothing is specified, CUTVAL=0 is used (cross section is done by XZ-plane).

Options:
  -h : show hits (RHIT - red, HITB - green, can be changed with assign command)
  -i : show isochrones (-h is required)
  -s : show status of channels (good=green, bad=yellow, cyan=noisy/missing FED)
  -l : show stereolayer orientation
  -d : show dead regions from OTDR tables
  -n : show ASD channels
  -a : show ASD numbers
  -f : show ASD name in full (-a is required)
  -m : show module borders
  -g : show GEDE number (not yet implemented)

Cells can be also filled with some color (FILCOL),
their borders can be drawn by line
of some color (LINCOL) and width (LINWID).

>Action DICELL
>Parameter
+
CUTVAL  'Cut value'  R D=0.
Z1      'Z1 - Z coordinate for CUTVAL' R D=717.
CUTVAL2 'Cut value at Z2' R D=-9999.
Z2      'Z2 - Z coordinate for CUTVAL2' R D=840.
FILCOL  'Fill color' R D=0.
LINCOL  'Line color' R D=1.
LINWID  'Line width' R D=1.
SL      'Superlayer name (if not specified, All superlayers in window are used' C D=' '
CHOPT   'Options' C D=' '
RSEG    'RSEG from which to take CUTVALs and Zs' I D=0
MTRA    'MTRA from which to take CUTVALs and Zs' I D=0
RTRA    'RTRA from which to take CUTVALs and Zs (not yet implemented)' I D=0
TRIGGER 'SLT trigger number (starting from 0)' I D=-1
TRACK   'SLT track number (starting from 0)' I D=-1

>Command DIOTR
>Guidance

Displays number of OTR single layers traversed by a straight line from target.

This is done for specified stereo layer (stereo layer 0 means all).

If first parameter is ALL then all OTR superlayers are displayed.

Please switch to Prism X-Y view by command 'view 0'.

 Example of corresponding Prism commands:

   run
   view 0 -n
   sty stereo=y sens=y head=n
   scope MC01
   frame -r -n
   draw; diotr MC01 1 1 0; dilay MC01 1
   greset; pitext 10 17.2 'MC01: layer 1' 1 0.6 -130 20

 (The last line will make a title for the picture.
  It will work only if you have switched
  MONTE_CARLO on in your usSelect.hh file.)

>Action DIOTR
>Parameter
SL        'Superlayer name (or ALL)' C D='ALL'
+
LAY       'Stereolayer (=0 for all)' I D=0
Usemask   'Use masks?'               I D=0
Countcell 'Count cells?'             I D=0
