*-- Author :    Rainer Mankel   18/01/94

      subroutine dimc(idmc,mv,islsta,islend,chopt)

*     **** shell routine to display MC tracks
      implicit none
#include "arte/Arte.fi"

#include "pris/zmh.fi"
#include "pris/zgraf.fi"
      integer idmc, islsta, islend, imc, mv, idmc1, idmc2,
     +      ii,jj,indx_dau,mc_dau
      real p
      character*(*) chopt

#include "auto/MIMP.fi"
#include "auto/MTRA.fi"
#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "auto/MVER.fi"
#include "auto/TOPP.fi"

#include "arte/Arte.ff"
#include "auto/MIMP.ff"
#include "auto/MTRA.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
#include "auto/MVER.ff"
#include "auto/TOPP.ff"

      if (jmtra.le.0) go to 999

      if (idmc.eq.0) then
         idmc1 = 1
         idmc2 = iq(jmtra+2)
      else
         idmc1 = idmc
         idmc2 = idmc
      endif

*     **** set constant part of drawing attributes
      call igset('PLCI',comczg)

*     **** initialize /zmh/ if needed
      call tusomh()

*     **** loop over MC particles
      do 10 imc=idmc1,idmc2

         if (index(chopt,'O').eq.0) then ! check if override
*           **** check B0 option
            if ((lb0zg.or.index(chopt,'B').gt.0)
     +           .and..not.gold_mh(imc)) go to 10

*           **** check mc vertex option
            if (mv.ne.0) then
               if (omtra_bver(imc).ne.mv) go to 10
            endif

*           **** check topp selection
            if (toppzg.gt.0.and.(omtra_topp(imc).ne.toppzg
     +           .and.omtra_topp(imc).ne.iqtopp_anti(toppzg))) go to 10

*           **** check reference option
            if (index(chopt,'R').gt.0.and..not.ref_mh(imc)) go to 10

*           **** check reconstructed option
            if (index(chopt,'F').gt.0.and.pmtra_rtra(imc).le.0) go to 10

*           **** check the momentum of neutral particle   (A.Lanyov, 03.03.02)
            if (itopp_chrg(omtra_topp(imc)).eq.0) then
             p=sqrt(fmtra_px(imc)**2+fmtra_py(imc)**2+fmtra_pz(imc)**2)
             if (p.lt.pmin_neutral) go to 10
            endif

         endif

         call di1mc(imc,islsta,islend,chopt)

         if (lchainzg.and.index(chopt,'O').eq.0) then
     +                                   ! display whole decay chain
            if (idmc.gt.0.or.mv.gt.0.or.toppzg.gt.0.or.lb0zg) then
               call mmbwrk(jtemp,0,1,20) ! book working table

               call mmbook(jtemp,1)
               iq(l_l(1,jtemp)) = imc ! fill mother

               do ii=1,999      ! loop over rows in jtemp
                  if (ii.gt.iq(jtemp+2)) go to 10

                  do jj=1,99    ! locate daughters of row ii
                     if (jj.eq.1) then
                        indx_dau = pmtra_etra(i_v(1,ii,jtemp))
                     else
                        indx_dau = xmtra_etra(indx_dau)
                     endif
                     if (indx_dau.eq.0) go to 21
                     call mmbook(jtemp,1)
                     iq(l_l(1,jtemp)) = mmtra_etra(indx_dau)
                     mc_dau = mmtra_etra(indx_dau)
                     call di1mc(mc_dau,islsta,islend,chopt)
                  enddo
                  print *,' () di1mc: inner chain loop exceeded!'
 21               continue
               enddo
               print *,' () di1mc: outer chain loop exceeded!'
            endif
            call mmbwrk(jtemp,0,1,0) ! reset working table
         endif
 10   continue
 999  end




