*----  created                                 16.01.2001 by Olya Igonkina
      SUBROUTINE PYGETCOM( AS, S, T, U, KFRES, CONTRIB, CROSSSECTION)
********************************************************************
* CALCULATES DIFFERENTIAL CROSS SECTION FOR COLOR OCTET MECHANISM
*
*     [sigma] = SUM : 1/(16*PI*SH**2)* | A(AB->QQ~(H8)) |**2 * OCOM^H8(KFRES)
*
*    CONTRIB =  
*             1   q + q~ -> X8 -> H 
*             2   g + g  -> X8 -> H
*             3   q + q~ -> X8 + g -> H 
*             4   g + q  -> X8 + q -> H 
*             5   g + g  -> X8 + g -> H 
*
********************************************************************
      IMPLICIT NONE
#include "jets/LUDAT1.fi"
#include "jets/LUDAT2.fi"
#include "pyth/PYPARS.fi"
#include "pyth/PYINT1.fi"
#include "pyth/pyocom.fi"
     
      INTEGER KFRES, CONTRIB
      REAL AS, S, T, U
      REAL SIGMA
      REAL  CROSSSECTION


      DOUBLE PRECISION FACTOR2,FACTOR3,FACTORM, GENFACT
      DATA FACTOR2 /0./, FACTOR3 /0./,GENFACT /0./
      SAVE FACTOR2, FACTOR3,GENFACT


      INTEGER IH, LUCOMP, KC
      EXTERNAL LUCOMP
      DOUBLE PRECISION MASS, MASS2, MASS4, MASS6, MASS8, MASS10, MASS12,
     &     MASS14,MASS16, MASS18, MASS20
      DOUBLE PRECISION S2, U2, T2, Z2, Z, SM, UM, TM, STUM2, T2U2, TU,
     &     SM2,SM4, s2z22, s2u2, su, tm2, tm4, s4, s6, s8, s10, s12,
     & z4, z6, z8, z10, z12, s3, sm4smz4

      DOUBLE PRECISION FGG2ETA,FGG2CHIC0,FGG2CHIC2,FQQ2PSI,
     &     FQQ2ETAG,FQQ2PSIG,FQQ2CHIC0G,FQQ2CHIC1G,FQQ2CHIC2G
     &     FGQ2ETAQ,FGQ2PSIQ,FGQ2CHIC0Q,FGQ2CHIC1Q,FGQ2CHIC2Q0,
     &     FGQ2CHIC2Q1,FGQ2CHIC2Q2,FGQ2CHIC2Q,FGG2CHI2G0,FGG2CHI2G1,
     &     FGG2ETAG,FGG2PSIG,FGG2CHI0G,FGG2CHI1G0,FGG2CHI1G1,
     &     FQQ2CHIC2G2,FQQ2CHIC2G,FGQ2ETAQ,FGG2CHI2G2


*      REAL GGPT, GG15, GG16, GG17, gg18, gg19
*      COMMON /FGG/GGPT, GG15, GG16, GG17, gg18, gg19

          
********************************************************************888

      FACTOR2 = (4*PARU(1)*AS)**2
      FACTOR3 = (4*PARU(1)*AS)**3
      GENFACT  = 1./16./PARU(1)/S**2

      CROSSSECTION = 0
      PYOISUB = MSTI(1)
********************************************************************888
* Choice of long distance matrix
      IH = 0
      IF( KFRES.EQ.   443 ) THEN ! J/PSI
         IH = 1
      ELSEIF( KFRES.EQ. 30443 ) THEN ! PSI(2S)
         IH = 2
      ELSEIF( KFRES.EQ. 10441 )  THEN ! CHI_C0
         IH = 3
      ELSEIF( KFRES.EQ. 20443 )  THEN ! CHI_C1
         IH = 4
      ELSEIF( KFRES.EQ.   445 )  THEN ! CHI_C2
         IH = 5
*      ELSEIF(     KFRES .EQ.  441 ) THEN ! ETA_C
*         IH = 6
*      ELSEIF(     KFRES .EQ.  441 ) THEN ! ETA_C(2S)
*         IH = 7
      ENDIF
      IF( IH.eq. 0 ) THEN
         PRINT *,'GETCOM ERROR : NO COLOR OCTET MODEL FOR RESONANCE ',
     &        KFRES
         GOTO 999
      ENDIF

********************************************************************888


      KC = LUCOMP(KFRES)
      MASS = PMAS(KC,1)
      MASS2 = MASS*MASS

      FACTORM = FACTOR3/MASS2/MASS


C=================================================================
C..   q+q~ -> X8 
C=================================================================
      IF( CONTRIB .EQ.1 ) THEN


         FQQ2PSI = FACTOR2/27./MASS ! 3S1
         CROSSSECTION = GENFACT* FQQ2PSI *PYO1S1(IH)
      
         
C=================================================================
C..   g+g ->  X8 
C=================================================================
      ELSEIF( CONTRIB .EQ.2 ) THEN
         FACTORM = FACTOR2/MASS2/MASS
            
         FGG2ETA   = 5.*FACTOR2/192./MASS
         FGG2CHIC0 = 5.*FACTORM/16.
         FGG2CHIC2 =    FACTORM/12.

         CROSSSECTION = GENFACT*( FGG2ETA*PYO1S0(IH) +
     &        + FGG2CHIC0*PYO1P0(IH) + FGG2CHIC2*5.*PYO1P0(IH))

C=================================================================
C..   q+q~ -> X8 + g
C=================================================================
      ELSEIF( CONTRIB .EQ.3 ) THEN

      MASS2 = MASS**2
      SM = S - MASS2
      SM2 = SM**2
      SM4 = SM2**2
      S2 = S*S
      T2U2 = T**2 + U**2 
      TU = T*U


      FQQ2ETAG = 5.*FACTOR3/27./MASS*T2U2/S/SM2

      FQQ2PSIG = FACTORM/81.*(4.*T2U2-TU)/SM4*2.*
     &     (4.*Mass2*s+(s2+mass4)*T2U2/TU)
      
      FQQ2CHIC0G = 20.* FACTORM/81.*(s-3.*Mass2)**2*T2U2/s/SM4
      FQQ2CHIC1G = 40.*FACTORM/81.*(s*T2U2+4.*Mass2*TU)/SM4
      FQQ2CHIC2G = FACTORM/27.*
     &     (8./3.*s*T2U2+32.*mass2*TU+16./s*Mass2**2*T2U2)/SM4

      CROSSSECTION = GENFACT*( FQQ2ETAG*PYO1S0(IH) +
     &     FQQ2PSIG*PYO1S1(IH)   + FQQ2CHIC0G*PYO1P0(IH) + 
     &     FQQ2CHIC1G*3.*PYO1P0(IH) + FQQ2CHIC2G*5.*PYO1P0(IH) )

C=================================================================
C..   g+q -> X8 + g
C=================================================================
      ELSEIF( CONTRIB .EQ.4 ) THEN

      MASS2 = MASS**2
      MASS4 = MASS2**2

      SM = S - MASS2
      TM2 = (T - MASS2)**2
      TM4 = TM2*TM2
      SM2 = SM*SM
      SM4 = SM2*SM2

      S2 = S*S
      T2 = T*T
      U2 = U*U
      S2U2 = S2 + U2
      SU = S*U

      FGQ2ETAQ = -5.*FACTOR3/72./Mass*(s2u2)/t/TM2
      CROSSSECTION = GENFACT*FGQ2ETAQ*PYO1S0(IH)

      FGQ2PSIQ = -FACTORM/108.*(4.*(s2u2)-su)/SM2/TM2*
     &     (2.*Mass2*t+((s2u2+2.*Mass2*t)*SM2-2.*Mass2*SU*t)/SU)
      CROSSSECTION = CROSSSECTION + GENFACT*FGQ2PSIQ*PYO1S1(IH)

      FGQ2CHIC0Q = -5.*FACTORM/54.*(t-3.*Mass2)**2*(s2u2)/t/TM4
      CROSSSECTION = CROSSSECTION + GENFACT*FGQ2CHIC0Q*PYO1P0(IH)
      
      FGQ2CHIC1Q = -5.*FACTORM/27*(t*(s2*sm2+u2*(s+Mass2)**2)+
     &     4.*Mass2*su*(t2+t*u+u2))/TM4/SM2
      CROSSSECTION = CROSSSECTION + GENFACT*FGQ2CHIC1Q*3.*PYO1P0(IH)

      FGQ2CHIC2Q0 = -FACTORM/27.*t/tm4*
     &     (s2u2+12.*Mass2*s*u2*(s2+Mass2*s+Mass4)/sm4)
      FGQ2CHIC2Q1 = -4.*FACTORM/9.*Mass2*su/tm4*
     &     (sm2*(s2+Mass4)-(s+Mass2)**2*t*u)/SM4
      FGQ2CHIC2Q2 = -2.*FACTORM/9.*Mass4/t/(t-Mass2)**4*
     &     (s2u2+2.*s2*t*u*(SM*(2.*t+u)-u2)/SM4)

      FGQ2CHIC2Q = FGQ2CHIC2Q0 + FGQ2CHIC2Q1 + FGQ2CHIC2Q2
      CROSSSECTION = CROSSSECTION + GENFACT*FGQ2CHIC2Q*5.*PYO1P0(IH)


C=================================================================
C..   g+g -> X8 + g 
C=================================================================
      ELSEIF( CONTRIB .EQ.5 ) THEN

      MASS2  = MASS**2
      MASS4  = MASS2 *MASS2
      MASS6  = MASS4 *MASS2
      MASS8  = MASS6 *MASS2
      MASS10 = MASS8 *MASS2
      MASS12 = MASS10 *MASS2
      MASS14 = MASS12 *MASS2
      MASS16 = MASS14 *MASS2
      MASS18 = MASS16 *MASS2
      MASS20 = MASS18 *MASS2

      SM = S - MASS2
      SM2 = SM*SM
      TM = T - MASS2
      UM = U - MASS2
      STUM2 = (SM*TM*UM)**2
      sm4smz4 = SM2**2*(s*Mass2+z2)**4

      S2 = S*S
      S3 = S2*S
      S4 = S2 *S2
      S6 = S4 *S2
      S8 = S6 *S2
      S10 = S8 *S2
      S12 = S10 *S2

      Z  = SQRT(T*U)
      Z2 = T*U
      z4 = z2 *z2
      z6 = z4 *z2
      z8 = z6 *z2
      z10 = z8 *z2
      z12 = z10 *z2

      s2z22 = (s2-z2)**2


      FGG2ETAG = 5D0*FACTOR3/16D0/MASS*
     &     (S2*SM**2+S*Z2*(MASS2-2.*S)+z4)*
     &     ((S2-MASS2*S+MASS4)**2-Z2*(2.*T2+3.*Z2+2*U2))/
     &     S/Z2/STUM2

      CROSSSECTION =  GENFACT*FGG2ETAG*PYO1S0(IH)
      
      FGG2PSIG = -FACTORM/144D0*S/SM2*
     &     (2.*MASS2*(T2+U2)*Z2+
     &     S*(SM**4+T2**2+U2**2+2.*MASS4*(Z2/S)**2))*
     &     (27.*(S*T+z2+U*S)-19.*MASS4)/STUM2
      CROSSSECTION =  CROSSSECTION + GENFACT*FGG2PSIG*PYO1S1(IH)
         
      FGG2CHI0G = 5D0/12D0*FACTORM*
     &     (s2*z4*s2z22**2
     &     +Mass2*s*z2*s2z22*(3.*s2-2.*z2)*(2.*s4-6.*s2*z2+3.*z4)
     &     +Mass4*(9.*s12-84.*s10*z2+265.*s8*z4-382.*s6*z6+
     &     276.*s4*z8-88.*s2*z10+9.*z12) 
     &     -Mass6*s*(54.*s10-357.*s8*z2+844.*s6*z4-
     &     898.*s4*z6+439.*s2*z8-81.*z10) 
     &     +Mass8*(153.*s10-798.*s8*z2+1415.*s6*z4-
     &     1041.*s4*z6+301.*s2*z8-18.*z10) 
     &     -Mass10*s*(270.*s8-1089.*s6*z2+
     &     1365.*s4*z4-616.*s2*z6+87.*z8)
     &     +Mass12*(324.*s8-951.*s6*z2+
     &     769.*s4*z4-189.*s2*z6+9.*z8) 
     &     -9.*Mass14*s*(6.*s2-z2)*(5.*s4-9.*s2*z2+3.*z4) 
     &     +3.*Mass16*s2*(51.*s4-59.*s2*z2+12.*z4) 
     &     -27*Mass18*s3*(2.*s2-z2)+9.*Mass20*s4)/sm4smz4/S/z2

         CROSSSECTION =  CROSSSECTION + GENFACT*FGG2CHI0G*PYO1P0(IH)


         FGG2CHI1G0 = 5.*FACTORM/6. *
     &        ( s*z2*s2z22**2+ Mass2*s2z22*(2.*s6-10.*s4*z2+s2*z4-2.*z6)
     &        -Mass4*s*(10.*s8-39.*s6*z2+33.*s4*z4-13.*s2*z6+3.*z8)
     &        +Mass6*(21.*s8-47.*s6*z2+22.*s4*z4-6.*s2*z6+z8)
     &        -2.*Mass8*s*(12.*s6-15.*s4*z2+5.*s2*z4-z6) 
     &        +Mass10*s2*(16.*s4-11.*s2*z2+3.*z4)
     &        -2.*Mass12*s3*(3.*s2-z2)+Mass14*s4 )/sm4smz4
      CROSSSECTION =  CROSSSECTION + 
     &        GENFACT*FGG2CHI1G0*3.*PYO1P0(IH)

      FGG2CHI2G0 = FACTORM/6.*s*z2*
     &     (s2*s2z22**2 -Mass2*s*z2*s2z22*(11.*s2+2.*z2)
     &     +Mass4*(s8-12.*s6*z2+41.*s4*z4-20.*s2*z6+z8)
     &     -Mass6*s*(4.*s6-26.*s4*z2-s2*z4-5.*z6)
     &     +Mass8*(29.*s6-114.*s4*z2+108*s2*z4-10.*z6)
     &     -Mass10*s*(65.*s4-104.*s2*z2-33.*z4)
     &     +Mass12*(54.*s4-20.*s2*z2+7.*z4) -Mass14*s*(23.*s2+5.*z2)
     &     +7.*Mass16*s2)/SM2/sm4smz4

      FGG2CHI2G1 = FACTORM/2.*Mass2*
     &     (2.*s2*s2z22*(s6-4.*s4*z2+s2*z4-z6)
     &     -Mass2*s*(10.*s10-37.*s8*z2+19.*s6*z4
     &     +11.*s4*z6-s2*z8-4.*z10)
     &     +Mass4*(25.*s10-61.*s8*z2+27.*s6*z4
     &     -34.*s4*z6+23.*s2*z8-2.*z10)
     &     -Mass6*s*(42.*s8-77.*s6*z2+41.*s4*z4-22.*s2*z6+17.*z8)
     &     +Mass8*(53.*s8-88.*s6*z2+69.*s4*z4-68.*s2*z6+3.*z8)
     &     -Mass10*s*(54.*s6-85.*s4*z2+60.*s2*z4-9.*z6)
     &     +Mass12*s2*(43.*s4-47.*s2*z2+20.*z4)
     &     -Mass14*s3*(22.*s2-9.*z2)+5.*Mass16*s4)/SM2/sm4smz4

      FGG2CHI2G2 = FACTORM/2.*Mass4*
     &     (2.*s2*(s12-8.*s10*z2+22.*s8*z4-
     &     24.*s6*z6+10.*s4*z8-3.*s2*z10+z12)
     &     -Mass2*s*(16.*s12-102.*s10*z2+210.*s8*z4-
     &     153.*s6*z6+36.*s4*z8-6.*s2*z10+4.*z12)
     &     +Mass4*(60.*s12-306.*s10*z2+482.*s8*z4-
     &     271.*s6*z6+77.*s4*z8-18.*s2*z10+2.*z12)
     &     -Mass6*s*(140.*s10-573.*s8*z2+710.*s6*z4-
     &     344.*s4*z6+91.*s2*z8-18.*z10)
     &     +Mass8*(226.*s10-741.*s8*z2+737.*s6*z4-
     &     310.*s4*z6+77.*s2*z8-4.*z10)
     &     -Mass10*s*(264.*s8-686.*s6*z2+541.*s4*z4
     &     -177.*s2*z6+25.*z8)
     &     +Mass12*(226.*s8-452.*s6*z2+
     &     261.*s4*z4-55.*s2*z6+2.*z8)
     &     -Mass14*s*(140.*s6-201.*s4*z2+71.*s2*z4-6.*z6)
     &     +Mass16*s2*(60.*s4-53.*s2*z2+8.*z4)
     &     -2.*Mass18*s3*(8.*s2-3.*z2)+2.*Mass20*s4)/s/z2/SM2/sm4smz4

      CROSSSECTION =  CROSSSECTION + 
     &     GENFACT*(FGG2CHI2G0+FGG2CHI2G1+FGG2CHI2G2)*5.*PYO1P0(IH)

      ELSE
         PRINT *,'ERROR PYGETCOM : Process N=',CONTRIB,' is not defined'

      ENDIF


 999  CONTINUE
 
      RETURN
      END
