// 
//  Author:  Rainer Mankel                     Created:  30-Apr-99
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

// ranger composite layer set

#include "rang/CompLaySet.hh"
#include "rang/CompLay.hh"

rangerCompLay*  rangerCompLaySet::findCl(int cmp,int gl) {
  for (vector<rangerCompLay*>::iterator clsi=CLs.begin();
	 clsi != CLs.end(); ++clsi) {
#ifdef FINDWARN
    if ((*clsi)->getGlay(cmp) == 0) {
      cout << "rangerCompLaySet::findCl: cmp=" << cmp
	   << " gl=" << gl << " not found in this set" << endl;
    }
#endif
    if ((*clsi)->getGlay(cmp) == gl) {
      return *clsi;
    }
  }
//   cout << "rangerCompLaySet::findcl: CompLay not found for cmp="
//        << cmp << " gl=" << gl << endl;
  return 0;
}
    

void rangerCompLaySet::dump(const int level) {
  //cout << " CLSet: number of CL=" << CLs.size() << endl;
  
  if (level > 1) {
    for (vector<rangerCompLay*>::iterator clsi=CLs.begin();
	 clsi != CLs.end(); ++clsi) {
      (*clsi)->dump(level-1);
    }
  }
}
