// 
//  Author:  Rainer Mankel                     Created:  22-Apr-99
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

#include "rang/SeedSet.hh"
#include "rang/DomLay.hh"
#include "rang/DomWin.hh"


rangerSeedSet::rangerSeedSet(rangerDomWin* dw,int method,int direction,
			     int lay1,int lay2,int lay3) {

  // "lay" counts from 1

  direct = direction;
  meth = method;
  wi = dw;

  filled = 1;

  for (int ii=0; ii<3; ++ii) {
    int l = 0;
    switch (ii) {
    case 0:
      l = lay1;
      break;
    case 1:
      l = lay2;
      break;
    case 2:
      l = lay3;
      break;
    }

    if (l) {
      int nl = 0;
      int found = 0;
      for (rangerDomLay* dl=dw->firstDL(method,+1); dl; 
	   dl = dl->next(method,+1)) {
	++nl;
	if (nl == l) {
	  dls.push_back(dl);
	  found = 1;
	  break;
	}
      }
      // not found
      if (! found) {
	filled = 0;
	cout << "SeedSet:.............failure for" << endl;
	cout << "     wi=" << *wi 
	     << " method=" << method
	     << " dir=" << direction
	     << " layers=" << lay1
	     << " " << lay2
	     << " " << lay3 << endl;
	break;
      }
    }
  }
}


void rangerSeedSet::dump(const int level) {
  cout << "   rangerSeedSet "
       << " direct=" << direct
       << " method=" << meth
       << " win=" << *wi
       << " # dl=" << dls.size()
       << endl;
  if (level > 1) {
    for (vector<rangerDomLay*>::iterator dli=dls.begin();
	 dli != dls.end(); ++dli) {
      (*dli)->dump(1);
    }
  }
}
