// 
//  Author:  Rainer Mankel                     Created:  29-Sep-98
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 
// Modifications:
// - Slight modification in inclusion of header files
//                                      14-Aug-00 Wouter Hulsbergen
//   applyDeDxe( dedx() )                          01/03/02  A.Spiridonov

//#define FULL_PN

#include <iostream>
#include <math.h>
#include "arte/arte.hh"
#include "rang/Thin.hh"
#include "rang/zfpar.hh"
#include "rang/utfeld.hh"
#include "rang/RadEl.hh"
#include "rang/ParticleType.hh"
#include "rang/ScatThick.hh"

void rangerThin::processNoise(rangerParticleType pType) {

  rangerScatThin scat( ms(), state->qPEst(),
		       state->tx(),
		       state->ty());

  state->applyScat( scat );

  if (pType == ELECTRON) {
    rangerRadEl rad( radiationThickness(), state->qP() );
    state->applyRadEl( rad );
  }
  //state->applyDeDx( radiationThickness() );
  state->applyDeDxe( dedx() );
}


void rangerThin::predProcessNoise(rangerParticleType pType) {

//   double sqxy = sqrt(1 + predictedState->tx() * predictedState->tx() 
// 		     + predictedState->ty() * predictedState->ty());
                                 // traversed distance in medium correction
#ifdef FULL_PN
  cout << " rangerThin::predProcessNoise  ms " << ms() 
       << " dedex " << dedx() << " z " << predictedState->z() << endl;
#endif

  rangerScatThin scat( ms(), predictedState->qPEst(),
		       predictedState->tx(),
		       predictedState->ty());

  predictedState->applyScat( scat );

  if (pType == ELECTRON) {
    rangerRadEl rad( radiationThickness(), predictedState->qP() );
    predictedState->applyRadEl( rad );
  }

  //predictedState->applyDeDx( radiationThickEff() );
  predictedState->applyDeDxe( dedx() );

#ifdef FULL
  cout << "rangerThin::processNoise: correction applied, cov matrix is now "
       << state->cov() << endl;
#endif
}
