// 
//  Author:  Rainer Mankel                     Created:  22-Apr-99
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

#ifndef RANGER_DOMSEG_HH
#define RANGER_DOMSEG_HH

class rangerDomain;
class rangerDomWin;

class rangerDomSeg {

public:
  rangerDomSeg(){};
  rangerDomSeg(rangerDomain* dom);
  ~rangerDomSeg(){};

  double z() { return zseg;};
  double x() { return xseg;};
  double tx() { return txseg;};
  void setDomSeg(const double z,const double x,const double tx,
		 rangerDomWin* dw) {
    zseg = z; xseg = x; txseg = tx; dwin = dw; };
  void clr() { fillBit = 0; };

private:
  int fillBit;
  rangerDomain* domain;
  double zseg;             // segment ref z
  double xseg;          // segment x
  double txseg;         // segment tx
  rangerDomWin* dwin;

};

#endif  
