// 
//  Author:  Rainer Mankel                     Created:  29-Sep-98
//  changed :
//  int dim() const { return m->num_row();         28/05/01 W. Hulsbergen 
//
// class rangerECClus
// node for reconstructed cluster in ECAL

#ifndef rangerECClus_HH
#define rangerECClus_HH

#include "arte/arte.hh"
#include "CLHEP/Matrix/Matrix.h"
#include "CLHEP/Matrix/SymMatrix.h"
#include "CLHEP/Matrix/Vector.h"
#include "rang/HitBase.hh"
#include "rang/StateL.hh"
#include "rang/StateLI.hh"
#include "rang/StateP.hh"
#include "rang/StatePI.hh"
#include "rang/FitMode.hh"

class rangerECClus : public rangerHitBase {

public:
  rangerECClus();
  rangerECClus(ArtePointer<RCCL> rccl,int charge,rangerFitMode fm,const float radTh);
  virtual ~rangerECClus();   // virtual destructor
  
  inline float ms() const { return (0.0136*0.0136)*radThick; }
  inline float msPlain() const { return (0.0136*0.0136)*radThick; }
  float dz(){ return 0; };           // thickness in z
  int plane() ;

  int dim() const { return m->num_row(); }    // dimension of measurement
  inline const ArtePointer<HITB> getHitb() const { return 0;} 
                                      // Accessor for hitb
  inline int hasHitb() { return 0;}
  void projectP(HepVector& resid,HepMatrix& HH,rangerStateP* s);
  void projectPI(HepVector& resid,HepMatrix& HH,rangerStatePI* s);
  void projectL(HepVector& resid,HepMatrix& HH,rangerStateL* s);
  void projectLI(HepVector& resid,HepMatrix& HH,rangerStateLI* s);

private:
  ArtePointer<RCCL> rcl;    // Arte pointer to HITB table
  float radThick;
};

#endif
