*-- Author :    Rainer Mankel   16/07/96
*-- changed:    A.Spiridonov    12/11/98
*  zmax_mag_zfpar = 682.,upper z bound of magnet   26/07/00 A. Spiridonov
*  whit_cmp_zfpar(1) = 2.,                         13/08/00 A. Spiridonov  
*  set parameter sline_mode_zfpar                  19/08/00 A. Spiridonov
*  set parameter slt_mode_zfpar                    03/09/00 A. Spiridonov
*  set param. slt_magn_,tc_mode_,slt_clone_zfpar   01/11/00 A. Spiridonov
*  set param. cats_,fit_magn_zfpar                 27/11/00 A. Spiridonov
*  set param. tema_,uniq_mode_zfpar                04/02/01 A. Spiridonov
*  call of rgdef moved to tfevntr.F                06/02/01 A. Spiridonov
*  set ranger parameters according to rgmc()       06/02/01 A. Spiridonov
*  set identical parameters for MC and data        23/02/01 A. Spiridonov
*  set param. fast_mode_zfpar,unchi_mode_zfpar     08/04/01 A. Spiridonov
*  whit_cmp_zfpar(3)=1,uniq_mode_zfpar = 1         30/04/01 A. Spiridonov
*  unchi_mode_zfpar = .false.
*  more strict settings in init. cov. matrix       12/06/01 A. Spiridonov
*  set param. outlmode_zfpar                       18/07/01 A. Spiridonov
*  set param. store_magn_zfpar
*  set param. mcmode_,match_,hptmode_zfpar         17/02/02 A. Spiridonov
*
      subroutine tf1init()

*     **** initialize the ranger parameters
*     **** called by rginit
      implicit none
      integer ii

      logical MonteCarlo
      integer rgmc

#include "rang/zfpar.fi"
#include "rang/zfpar_tc.fi"
#include "rang/zfmode.fi"
#include "rang/zfout.fi"
#include "rang/zfconst.fi"
#include "rang/FLAGWhit.hh"

      call tfversion()          ! print version #
      call dmdef()              ! define default domain table
**    call rgdef()

      if(rgmc().eq.1) then 
         MonteCarlo = .true.
**         print *,' tf1init.F : settings for MONTE CARLO' 
      else
         MonteCarlo = .false.
**         print *,' tf1init.F : settings for DATA' 
      endif

      MonteCarlo = .false.     

      dlevel_zfpar = 9          ! will be checked in tfrinit

      rlevel_zfpar = 4          ! default run level
      smooth_zfpar = 1          ! smoothing in ranger fit
      niter_zfpar  = 1          ! # iterations in ranger fit
      msmode_zfpar = 3          ! mode for mult scat correction
      max_plpick_zfpar = 199    ! max #planes picked up in ms corr
      if(MonteCarlo) then
         maxflt_patx_zfpar = 4  ! max #faults in sequence (pat area,x)  3.
         maxflt_paty_zfpar = 4  ! max #faults in sequence (pat area,y)  3.
         maxflt_3d_zfpar   = 3  ! max N_faults in sequence (3D)         3.
         maxflt_mag_zfpar = 3   ! max #faults in sequence (mag area)    2.
         maxflt_TC_zfpar = 4    ! max #faults in sequence (TC area)     3.
      else   ! data                        
         maxflt_patx_zfpar = 4  ! max #faults in sequence (pat area,x)
         maxflt_paty_zfpar = 4  ! max #faults in sequence (pat area,y)
         maxflt_3d_zfpar   = 3  ! max N_faults in sequence (3D)
         maxflt_mag_zfpar = 3   ! max #faults in sequence (mag area)
         maxflt_TC_zfpar = 4    ! max #faults in sequence (TC area)
      endif
      rmax_x_zfpar = 5          ! max rank x tracking
      rmax_y_zfpar = 5          ! max rank y tracking
      rmax_TC_zfpar= 5          ! max rank of TC tracking

      minmimp_pref_zfpar = 18   ! min #mimps for pat ref track

      cxxrf_zfpar   = 16.       ! initial cov matrix elements
      cyyrf_zfpar   = 50.       !              in ranger fit
      ctxtxrf_zfpar = 0.01      !
      ctytyrf_zfpar = 0.04      !
      cqqrf_zfpar   = 0.02      !

      f_moliere_zfpar = 2.9     ! m.s. correction from moliere scat

      f_cov_zfpar(1) = 1.       ! fudge factors for covariance matrix
      f_cov_zfpar(2) = 1.
      f_cov_zfpar(3) = 1.
      f_cov_zfpar(4) = 1.
      f_cov_zfpar(5) = 1.

      wchi_x_zfpar = .1    ! quality function chi**2 weight x tracking
      wchi_y_zfpar = .05   ! quality function chi**2 weight y tracking
      wchi_3d_zfpar = .1   ! quality function chi**2 weight 3d tracking
      wchi_mag_zfpar = .05 ! quality function chi**2 weight mag tracking
      wchi_TC_zfpar = .05  ! quality function chi**2 weight TC tracking

      do ii=1,maxcmp_zfpar
         whit_cmp_zfpar(ii) = 1. ! hit weight according to cmp
      enddo
      whit_cmp_zfpar(1) = 2.     ! hit weight VDS according to cmp

      chmax_x_zfpar   = 8.  ! max chi**2 in filter step x tracking
      chmax_y_zfpar   = 16. ! max chi**2 in filter step y tracking
      chmax_3d_zfpar  = 8.  ! max chi**2 in filter step 3d tracking
      chmax_mag_zfpar = 16. ! max chi**2 in filter step mag tracking
      chmax_TC_zfpar = 16.  ! max chi**2 in filter step TC tracking

      if(MonteCarlo) then
         whitmin_x_zfpar   = 6. ! minimal whit for maturity x tracking 8.
         whitmin_y_zfpar   = 6. ! minimal whit for maturity y tracking 8.
         whitmin_3d_zfpar  = 6. ! minimal whit for maturity 3d tracking 8.
#ifdef RT_WHIT
         whitmin_mag_zfpar = 9. ! minimal whit for maturity mag tracking 9.
#else 
         whitmin_mag_zfpar = 6. ! minimal whit for maturity mag tracking 3.
#endif
         whitmin_TC_zfpar = 5.  ! minimal whit for maturity TC tracking 4.
         quality_TC_min = 4.    ! minimal quality_ft() for TC track  3.4
      else   !  data
         whitmin_x_zfpar   = 6. ! minimal whit for maturity x tracking
         whitmin_y_zfpar   = 6. ! minimal whit for maturity y tracking
         whitmin_3d_zfpar  = 6. ! minimal whit for maturity 3d tracking
#ifdef RT_WHIT
         whitmin_mag_zfpar = 9. ! minimal whit for maturity mag tracking
#else 
         whitmin_mag_zfpar = 6. ! minimal whit for maturity mag tracking
#endif
         whitmin_TC_zfpar = 5.  ! minimal whit for maturity TC tracking
         quality_TC_min = 4.    ! minimal quality_ft() for TC track
      endif
      
      qplimit_zfpar = 4.17

      zmin_ec_zfpar = 250.      ! lower z bound for energy loss corr
      zmax_ec_zfpar = 650.      ! upper z bound for energy loss corr

      zmin_mag_zfpar = 190.     ! lower z bound for magnet-type tracking
      zmax_mag_zfpar = 682.     ! upper z bound for magnet-type tracking
      zmin_TC_zfpar = 1175.     ! lower z bound for TC tracking
      zmax_TC_zfpar = 1330.     ! upper z bound for TC type tracking

      dzpara_mag_zfpar = 20.    ! max dz for parabolic expansion

      segstor_zfpar = .true.    ! store in track table

      f_p_zfpar = 0.            ! coefficient of momentum process noise
      f_molRF_zfpar = 1.        ! moliere factor for mult scat in r++ fit

      llog_zfout = .false.      ! initial output levels
      lref_zfout = .false.
      lrec_zfout = .false.
      leff_zfout = .false.

      tI_zfconst = 0.           ! initialize zfconst
      dOff_zfconst = 0.
      sigI_zfconst = 1.

      l_rinit = .false.         ! mark rinit as not yet done

      rlevel_fit = 0            ! default fit level

      if(MonteCarlo) then
         qualmin_x_zfpar = 5.   ! minimal quality after x propagation  7.
         qualmin_y_zfpar = 5.   ! minimal quality after y propagation  7.
         nhitmin_y_zfpar = 6    ! minimal number of hits after y propagation 8.
      else
         qualmin_x_zfpar = 5.   ! minimal quality after x propagation
         qualmin_y_zfpar = 5.   ! minimal quality after y propagation
         nhitmin_y_zfpar = 6    ! minimal number of hits after y propagation
      endif

      whitmin_mcon_zfpar = 0.   ! minimal continuation weight in magnet

      dgsel_zfpar = .false.    ! honour dgsel parameters

      navmode_zfpar = 0        ! navigation mode (0=auto,1=old,2=new)
      
      qpmax_trip_zfpar = 1.    ! maximal q/p for triplet

      down_mode_zfpar = .false.! mode of downstream propagation

      qmin_down_zfpar = 15.    ! minimal quality for downstream propagation

      sline_mode_zfpar = .false. ! straight line fit mode

      slt_mode_zfpar = 0  ! mode of slt track seeding (0 no,1 e,2 mu,3 e+mu)

      slt_magn_zfpar = .false.  ! mode of slt seeded magnet tracking

      tc_mode_zfpar = .true.    ! tc tracking with slt and downstream

      slt_clone_zfpar = .false. ! slt clone are tested with normal ranger

      cats_mode_zfpar = .false. ! OtrCats  was not called

      fit_magn_zfpar = .true. ! hits in magnet are used for refit 

      tema_mode_zfpar = .false. ! Tema  was not called

      uniq_mode_zfpar = 1  ! clone check mode (=0 no, =1 nhit, =2 rfac.hit)

      nhmax_uniq_zfpar = 2 ! maximal number of common hit in rseg

      frmax_uniq_zfpar = 0.5 ! maximal fraction of common hit

      itr_mode_zfpar = 0   ! itr mode (=0 all, =12 MS12 removed)

      fast_mode_zfpar = .false. ! fast version of x tracking (lower eff.)
*                                      (tfmatripn(), tfstseg())

      unchi_mode_zfpar = .false. ! call rguniqchi() (kill close rsegs)

      outlmode_zfpar = 0 ! outlay remove mode (=0 no, =1 Wouter's method)

      store_magn_zfpar = 0 ! magnet store mode (=0,all PC, =1 only with magnet) 

      mcmode_zfpar = 0 ! mode of use mc1/ms1 (=0,mc1 not used, =1,mc1 added to vds) 

      match_zfpar = 0 ! (=0,no action, =1, call of rgmatcha) 

      hptmode_zfpar = 0 ! (=0,no action,=1, ihpt are used in rgmatcha) 

      end

