
*-- Author :    A.Spiridonov   24/05/2000

      subroutine tfhtseg(ift,ihbad,iftbad)

*     **** take track candidate ift from ranger buffer
*     **** define bad hit ihbad
*
      implicit none
#include "arte/Arte.fi"
#include "auto/HITB.fi"
#include "auto/GEO.fi"
#include "auto/MTRA.fi"
#include "auto/RSEG.fi"
#include "auto/RHIT.fi"
#include "auto/RPNT.fi"

#include "rang/zf.fi"
#include "rang/zfmode.fi"
#include "rang/zcut.fi"
#include "rang/zfpar.fi"

      integer nzfmx_s
      parameter (nzfmx_s=300)

      integer ihbad,iftbad,izf, ift, ih, ii,
     +     jft, iift, ihf, izf_s(nzfmx_s),
     +     nzf_s, iizf, iseg
      integer jj, rgsetcmp, iLowZ, iHighZ, iInc, zfLow, zfHigh

      logical lchi2,llsmoo,smoothed(nzfmx_s),init,sm

      integer maxpnt
      parameter (maxpnt=4)
      integer zfPnt(maxpnt),ipnt,jpnt,rp
      real zPnt(maxpnt),zlow,zhigh
      logical smPnt(maxpnt)
      character*4 cc
      integer indrp

#include "pris/zmpack.fi"

      save init,zpnt,zlow,zhigh
      data init /.false./

      real xseg_1,xseg_2,yseg_1,yseg_2
      integer message_id_1

      real x_t,y_t,dx_t,dx
*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      real dx_2,nx_2,dx_1,dx_good,nx_good
      real prob
      integer nn_good

#include "arte/Arte.ff"
#include "auto/HITB.ff"
#include "auto/GEO.ff"
#include "auto/MTRA.ff"
#include "auto/RSEG.ff"
#include "auto/RHIT.ff"
#include "auto/RPNT.ff"

*********************************************************
*
*     Meaning of the candidate flag stat_ft:
*
*        stat_ft = 1   x candidate
*                  2   y candidate
*                  3   3D, smoothed
*                  4   momentum information
*                  5   momentum information,, smoothed
*
*********************************************************

*      lsmoo = stat_ft(ift).eq.3.or.stat_ft(ift).eq.5

*%%%%%%%%%%%%%%%%%%%%%%%%%%%
      dx_2 = 0.
      nx_2 = 0.

      dx_t = 0.
      ihbad = 0
      iftbad = 0

**      print '(" tfhtseg.F : ----  ift,stat,prev ",3i5)'
**     +       ,ift,stat_ft(ift),prev_ft(ift)

*     **** create vector of hits
      nzf_s = 0

*     **** loop over segments in ranger buffer
      do 10 iift=1,3
       if (iift.eq.1) then
        jft = ift
       elseif (prev_ft(jft).gt.0) then
        jft = prev_ft(jft)
       else
        go to 11
       endif

       llsmoo = stat_ft(jft).eq.3.or.stat_ft(jft).eq.5

       do iizf=1,nhit_ft(jft)

        if (iizf.eq.1) then
         izf = last_ft(jft)
        else
         if (.not.llsmoo) then
          izf = prev_zf(izf)
         else
*         **** smoothed ordering
          izf = prevs_zf(izf)
         endif
        endif
        if (izf.eq.0) then
         print *,' () tfstseg: izf=', izf,
     +           ' iift,iizf,ift,jft,stat_ft,nhit_ft,llsmoo=',
     +             iift,iizf, ift, jft, stat_ft(ift), nhit_ft(jft),
     +             llsmoo
         call tfwait()
         go to 999
        endif
        if (hit_zf(izf).eq.0) go to 31 ! skip dummy hit
        if (nzf_s.lt.nzfmx_s) then

         if(nzf_s.gt.0) then
           do jj=1,nzf_s
             if(hit_zf(izf_s(jj)).eq.hit_zf(izf)) go to 61 ! skip double hit
           end do
         end if

         nzf_s = nzf_s + 1
         izf_s(nzf_s) = izf
         smoothed(nzf_s) = llsmoo

  61    continue
        else
         print *,' () tfstseg: overflowing nzf_s=', nzf_s
         go to 11
        endif
       enddo
 31    continue
 10   continue
 11   continue

*      **** security check
      ih = hit_zf(izf_s(1))
      if (nzf_s.eq.0.or.ih.le.0.or.ih.gt.iq(jhitb+2)) then
         print *,' () tfstseg: nzf_s,ii,ih,iq(jhitb+2),ift,nhit_ft =',
     +        nzf_s,ii,ih,iq(jhitb+2),ift,
     +        nhit_ft(ift)
         call tfwait()
         go to 999
      endif

*     **** identify indices of lowest/highest z
      if (z_zf(izf_s(1)).lt.z_zf(izf_s(nzf_s))) then
         iLowZ  = 1         ! normal ordering
         iHighZ = nzf_s
         iInc   = +1        ! loops from low to high use +iInc
      else
         iLowZ  = nzf_s     ! reverse ordering
         iHighZ = 1
         iInc   = -1        ! loops from high to low use -iInc
      endif

*     **** take impact parameter of lowest-z point
      zfLow  = izf_s(iLowZ)
      zfHigh = izf_s(iHighZ)

*    *****  check segment coordinates

      if (.not.smoothed(iLowZ)) then ! first point segment not smoothed
         if (smoothed(iHighZ)) then 
            xseg_1 = xx_zf(1,zfLow)
            xseg_2 = xs_zf(1,zfHigh)
            yseg_1 = xx_zf(2,zfLow)
            yseg_2 = xs_zf(2,zfHigh)
         else
            xseg_1 = xx_zf(1,zfLow)
            xseg_2 = xx_zf(1,zfHigh)
            yseg_1 = xx_zf(2,zfLow)
            yseg_2 = xx_zf(2,zfHigh)
         endif
      else                      ! first point segment smoothed
         if (smoothed(iHighZ)) then
            xseg_1 = xs_zf(1,zfLow)
            xseg_2 = xs_zf(1,zfHigh)
            yseg_1 = xs_zf(2,zfLow)
            yseg_2 = xs_zf(2,zfHigh)
         else
            xseg_1 = xs_zf(1,zfLow)
            xseg_2 = xx_zf(1,zfHigh)
            yseg_1 = xs_zf(2,zfLow)
            yseg_2 = xx_zf(2,zfHigh)
         endif
      endif

      if(  abs(xseg_1).gt.300..or.abs(xseg_2).gt.300.
     + .or.abs(yseg_1).gt.350..or.abs(yseg_2).gt.350. ) then ! wrong x or y
**        iseg = nrseg() + 1
**        print '("tfstseg.F : is,x12,y12 =",i4,4(x,e11.4))'
**     +        ,iseg,xseg_1,xseg_2,yseg_1,yseg_2
        call mepric(message_id_1,1,'tfhstseg.F : x > 300 or y > 350')
        go to 999
      end if

      do 20 ii=iHighZ,iLowZ,-iInc ! decreasing z order
         izf = izf_s(ii)
         ih = hit_zf(izf)
         if (ih.le.0.or.ih.gt.nhitb()) then
            print *,' () tfstseg: izf, nzf_s, ii, ih, iq(jhitb+2)=',
     +           izf, nzf_s, ii, ih, iq(jhitb+2)
            go to 20
         endif

         if (.not.smoothed(ii)) then
            x_t = xx_zf(1,izf)
            y_t = xx_zf(2,izf)
         else
            x_t = xs_zf(1,izf)
            y_t = xs_zf(2,izf)
         endif
         
         call rgauxht(x_t,y_t,sign_zf(izf),ih,dx)
         if(dx.gt.dx_t) then
            ihbad = ih
            dx_t = dx
         end if

*%%%%%%%%%%%%%%%%%%%%%%%%%%%%
         dx_2 = dx_2 + dx * dx
         nx_2 = nx_2 + 1.

 20   continue   ! hitf loop

*     ***** select bad hit                         
      if(dx_t.le.3.) then
         ihbad = 0
         dx_good = dx_2
         nx_good = nx_2
      else
         dx_good = dx_2 - dx_t * dx_t
         nx_good = nx_2 - 1
      end if
      nn_good = nx_good
      dx_1 = dx_good / nx_good

      if(prob(dx_good,nn_good).lt.1.e-4) then 
         iftbad = 1
**         print *,' tfhtseg : ++++++ BAD dx_good,nn_good,dx_1,prob '
**     +        ,dx_good,nn_good,dx_1,prob(dx_good,nn_good)
      end if

*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*      print *,' tfhtseg : dx_2,nx_2,dx_n,dx_1 '
*     +       ,dx_2,nx_2,(dx_2/nx_2),dx_1
**      print *,' tfhtseg : dx_good,nn_good,dx_1,prob '
**     +       ,dx_good,nn_good,dx_1,prob(dx_good,nn_good)
       
 999  return
      end
