*-- Author :                                     12/04/01  A. Spiridonov
* changed :
*

*#define TFINDFIT_DEBUG

      subroutine tfindfit(ift,nzfmx_s,ind_s,nzf_s,p_start)

*     **** 3D linear fit of set if point in zf (outside magnet!)
*          tailored from tfsmfin(),tflfit()
*

      implicit none
#include "rang/zf.fi"
#include "rang/zfmode.fi"
#include "rang/zplx.fi"

      real p_start(5)
      integer nzfmx_s
**      parameter (nzfmx_s=300)
      integer ind_s(nzfmx_s), nzf_s, iizf, iseg, ift, jft, izf, jpl,
     +     xsig, ii, jj, kk, jzf, jzf_ylast, ih, ifail, jzf_xlast
      double precision dz, du, cs_thetu, dnoise, xm_p, xr_p,
     +     cr_p, hch, kalman(dimp,dimm), ihk, m_u, sum, dppi(4,4),
     +     ak(4,4)
      
      integer kkzf, kzf, ihkk, tfmitoqpt, imc, mimp, nnmimp, imcass
      real fracmc,tfqptest
      character*1 csig
      
      real pnoise, xyfac, tupmc, tx, ty, qp, qpt
      integer ll, mm, seg_first(2), seg_last(2), tfmc
      double precision f(4,4)
      parameter (xyfac=1.)

      integer N_h_zf
      double precision h_1,h_2,k_1,k_2,k_3,k_4
      double precision c21
      double precision kh_1,kh_2,kh_3,kh_4
            
      double precision f13,f24,x,y,z

      double precision FL_1

      double precision c11 , c12 , c13 , c14 
      double precision       c22 , c23 , c24 
      double precision             c33 , c34 
      double precision                   c44
 
      double precision g11 , g12 , g13 , g14 
      double precision g21 , g22 , g23 , g24 
      double precision g31 , g32 , g33 , g34 
      double precision g41 , g42 , g43 , g44 

      equivalence (f13,f(1,3)),(f24,f(2,4))

#include "arte/Arte.fi"      
#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "auto/MIMP.fi"
#include "auto/MTRA.fi"
#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
#include "auto/MIMP.ff"
#include "auto/MTRA.ff"
      
      kh_1(x,y) = k_1 * ( h_1 * x + h_2 * y )
      kh_2(x,y) = k_2 * ( h_1 * x + h_2 * y )
      kh_3(x,y) = k_3 * ( h_1 * x + h_2 * y )
      kh_4(x,y) = k_4 * ( h_1 * x + h_2 * y )

      FL_1(x,y) = x + f13*y 
*
*================================================================
*
            
      if (l_diag) then
         print *,' tfsmfi starting for ift=', ift
         call tfwait()
      endif
      
      
*     **** filter points
      do iizf=1,nzf_s
         jzf = ind_s(iizf)
         
         jpl = plane_zf(jzf)
         xsig = sign_zf(jzf)
         ih = hit_zf(jzf)

         if (iizf.eq.1) then        !    first point

            xp_zf(1,jzf) = p_start(1)
            xp_zf(2,jzf) = p_start(2)
            xp_zf(3,jzf) = p_start(3)
            xp_zf(4,jzf) = p_start(4)
            xp_zf(5,jzf) = p_start(5)
            qpt = p_start(5)
            qp = abs(qpt)

            if (qp.gt.2.) qp = 2
*     *        print *,' tfsmfi: replace pnoise=',pnoise
            if (qp.gt.0) then
               pnoise = 1/qp
            else
               pnoise = 10.
            endif
*     *        print *,' .......................... with pnoise=',pnoise
            
            if (diag_level.ge.3) then
               print '((a),4f10.3)',' pred init:',(xp_zf(ii,jzf),ii=1,4)
               print *,' jzf_xlast, jzf_ylast=',jzf_xlast,jzf_ylast
               call tfwait()
            endif
            
            do ii=1,dimp
               do jj=1,dimp
                  cp_zf(ii,jj,jzf) = 0.
               enddo
            enddo
            cp_zf(1,1,jzf) = 100.
            cp_zf(2,2,jzf) = 1000.
            cp_zf(3,3,jzf) = 1.
            cp_zf(4,4,jzf) = 1.
            cp_zf(5,5,jzf) = 0.
         else                                         ! end of first point
            izf = ind_s(iizf-1)
            dz = z_zf(jzf) - z_zf(izf)
            
*     **** Kalman filter pred            xp_zf(5,jzf) = 0.

            xp_zf(1,jzf) = xs_zf(1,izf) + dz * xs_zf(3,izf)
            xp_zf(2,jzf) = xs_zf(2,izf) + dz * xs_zf(4,izf)
            xp_zf(3,jzf) = xs_zf(3,izf)
            xp_zf(4,jzf) = xs_zf(4,izf)
            
            dnoise = 4.d0 * fgede_ms(jpl) / pnoise**2
            
*#ifdef TFSMFIN_NEWCODE
            f13 = dz

            c11 = cs_zf(1,1,izf) 
            c12 = cs_zf(1,2,izf)
            c13 = cs_zf(1,3,izf) 
            c14 = cs_zf(1,4,izf)
            c22 = cs_zf(2,2,izf) 
            c23 = cs_zf(2,3,izf)
            c24 = cs_zf(2,4,izf) 
            c33 = cs_zf(3,3,izf) 
            c34 = cs_zf(3,4,izf)
            c44 = cs_zf(4,4,izf)
            
            g11 = FL_1( c11 , c13 )
            g12 = FL_1( c12 , c23 )  
            g13 = FL_1( c13 , c33 )
            g14 = FL_1( c14 , c34 )
            
            g21 = FL_1( c12 , c14 )
            g22 = FL_1( c22 , c24 )
            g23 = FL_1( c23 , c34 )
            g24 = FL_1( c24 , c44 )
            
            g31 = c13 
            g32 = c23 
            g33 = c33 
            g34 = c34 
            
            g41 =      c14             
            g42 =      c24             
            g43 =      c34             
            g44 =      c44                          
            
            cp_zf(1,1,jzf) = FL_1( g11 , g13 )
            cp_zf(2,1,jzf) = FL_1( g21 , g23 )
            cp_zf(3,1,jzf) = FL_1( g31 , g33 )
            cp_zf(4,1,jzf) = FL_1( g41 , g43 )
            
            cp_zf(1,2,jzf) = cp_zf(2,1,jzf)
            cp_zf(2,2,jzf) = FL_1( g22 , g24 )
            cp_zf(3,2,jzf) = FL_1( g32 , g34 )
            cp_zf(4,2,jzf) = FL_1( g42 , g44 )
            
            cp_zf(1,3,jzf) = cp_zf(3,1,jzf)
            cp_zf(2,3,jzf) = cp_zf(3,2,jzf)
            cp_zf(3,3,jzf) = g33                + dnoise
            cp_zf(4,3,jzf) = g43 
            
            cp_zf(1,4,jzf) = cp_zf(4,1,jzf)
            cp_zf(2,4,jzf) = cp_zf(4,2,jzf)
            cp_zf(3,4,jzf) = cp_zf(4,3,jzf)
            cp_zf(4,4,jzf) = g44                + dnoise 
*#endif
            
            if (diag_level.ge.5) then
               print *,' tfsmfi: pred=', xp_zf(1,jzf),xp_zf(2,jzf),
     +              ' error ', dsqrt( cp_zf(1,1,jzf) ),
     +              dsqrt( cp_zf(2,2,jzf) ),
     +              'dz=', dz
               print *,' cp_zf(2,2,jzf),cp_zf(2,4,jzf),cp_zf(4,4,jzf)=',
     +              cp_zf(2,2,jzf), cp_zf(2,4,jzf), cp_zf(4,4,jzf)
            endif
         endif                                   ! end of any point 
         
*     **** projection
         if (igede_cmp(jpl).eq.2) then
            xm_zf(1,jzf)   = xsig * abs( fhitb_q(ih) )
            cm_zf(1,1,jzf) = xyfac * fhitb_r(ih)**2
*     fudge for L/R
            cm_zf(1,1,jzf) = cm_zf(1,1,jzf)
     +           *(1.2 + (fhitb_r(ih)-0.01)*10.)**2

*     **** tan(track angle) in uz-plane
            m_u = xp_zf(3,jzf) * cstot_plx(jpl)
     +           - xp_zf(4,jzf) * sntot_plx(jpl)
            cs_thetu = 1. / dsqrt(1.d0 + m_u**2)
*     **** distance from projection to wire (along u)
            du = xp_zf(1,jzf) * cstot_plx(jpl)  - fhitb_x(ih)
     +           - xp_zf(2,jzf) * sntot_plx(jpl)
            xm_p      = du * cs_thetu
*     **** difference to signed drift distance
            xr_p = xsig * abs( fhitb_q(ih) ) - xm_p
            
*#ifdef TFSMFIN_NEWCODE
            if(abs(sntot_plx(jpl)).lt.1.e-2) then ! X -chambers
               
               N_h_zf = 1
               
               h_zf(1,1,jzf) =   cstot_plx(jpl) * cs_thetu
               h_zf(1,2,jzf) = 0.
               h_zf(1,3,jzf) = 0.
               h_zf(1,4,jzf) = 0.
               h_zf(1,5,jzf) = 0.
               
               hch =  h_zf(1,1,jzf)**2 * cp_zf(1,1,jzf)
               
*     print '("tfsmfin : h,c ",2(x,f8.3))'
*     +    , h_zf(1,1,jzf),dsqrt(cp_zf(1,1,jzf))
               
            else                ! Y - chamber
               
               N_h_zf = 2
               
               h_zf(1,1,jzf) =   cstot_plx(jpl) * cs_thetu
               h_zf(1,2,jzf) = - sntot_plx(jpl) * cs_thetu
               h_zf(1,3,jzf) = 0.
               h_zf(1,4,jzf) = 0.
               h_zf(1,5,jzf) = 0.
               
               hch =  h_zf(1,1,jzf)**2 * cp_zf(1,1,jzf)
     +              +  h_zf(1,2,jzf)**2 * cp_zf(2,2,jzf)
     +              + 2.d0 * ( h_zf(1,1,jzf) * h_zf(1,2,jzf) 
     +              * cp_zf(1,2,jzf))

*     print '("tfsmfin : h,c ",5(x,f8.3))'
*     +    ,h_zf(1,1,jzf),h_zf(1,2,jzf)
*     +    ,dsqrt(cp_zf(1,1,jzf))
*     +    ,cp_zf(1,2,jzf)/(dsqrt(cp_zf(1,1,jzf))*dsqrt(cp_zf(2,2,jzf)))     
*     +    ,dsqrt(cp_zf(2,2,jzf))
               
            end if
            
*     print '(/"sin,H= ",5(f9.4) )',sntot_plx(jpl),h_zf(1,1,jzf)
*     +         ,h_zf(1,2,jzf),h_zf(1,3,jzf),h_zf(1,4,jzf)
*#endif

            cr_p = cm_zf(1,1,jzf) + hch

         elseif (igede_cmp(jpl).eq.3) then
*     **** warning: must care better for local coordinates!
            xm_zf(1,jzf)   = fhitb_x(ih)
            cm_zf(1,1,jzf) = xyfac * fhitb_r(ih)**2
            xm_p = xp_zf(1,jzf) * cstot_plx(jpl)
     +           - xp_zf(2,jzf) * sntot_plx(jpl)
            
            xr_p = fhitb_x(ih) - xm_p
            
*#ifdef TFSMFIN_NEWCODE
            if(abs(sntot_plx(jpl)).lt.1.e-2) then ! X -chambers
               
               N_h_zf = 1
               
               h_zf(1,1,jzf) =   cstot_plx(jpl) 
               h_zf(1,2,jzf) = 0.
               h_zf(1,3,jzf) = 0.
               h_zf(1,4,jzf) = 0.
               h_zf(1,5,jzf) = 0.
               
               hch =  h_zf(1,1,jzf)**2 * cp_zf(1,1,jzf)
               
*     print '("tfsmfin : h,c ",2(x,f8.3))'
*     +    , h_zf(1,1,jzf),dsqrt(cp_zf(1,1,jzf))
               
            else                ! Y - chamber
               
               N_h_zf = 2
               
               h_zf(1,1,jzf) =   cstot_plx(jpl)
               h_zf(1,2,jzf) = - sntot_plx(jpl) 
               h_zf(1,3,jzf) = 0.
               h_zf(1,4,jzf) = 0.
               h_zf(1,5,jzf) = 0.
               
               hch =  h_zf(1,1,jzf)**2 * cp_zf(1,1,jzf)
     +              +  h_zf(1,2,jzf)**2 * cp_zf(2,2,jzf)
     +              + 2.d0 * ( h_zf(1,1,jzf) * h_zf(1,2,jzf) 
     +              * cp_zf(1,2,jzf))

*     print '("tfsmfin : h,c ",5(x,f8.3))'
*     +    ,h_zf(1,1,jzf),h_zf(1,2,jzf)
*     +    ,dsqrt(cp_zf(1,1,jzf))
*     +    ,cp_zf(1,2,jzf)/(dsqrt(cp_zf(1,1,jzf))*dsqrt(cp_zf(2,2,jzf)))     
*     +    ,dsqrt(cp_zf(2,2,jzf))
               
            end if
            
*     print '(/"sin,H= ",5(f9.4) )',sntot_plx(jpl),h_zf(1,1,jzf)
*     +         ,h_zf(1,2,jzf),h_zf(1,3,jzf),h_zf(1,4,jzf)
*#endif

            cr_p = cm_zf(1,1,jzf) + hch
         else
            print *,' tfsmfi: non-supported type for jpl=', jpl
         endif
         
         if (diag_level.ge.5) then
            print *,' tfsmfi: fhitb_x(ih), xm_p, xr_p, er_p=',
     +           fhitb_x(ih), xm_p, xr_p, dsqrt(cr_p)
            
            print *,' hch, fhitb_r(ih)**2, cr_p=',
     +           hch, fhitb_r(ih)**2, cr_p
         endif
         
*     **** filter point

*#ifdef TFSMFIN_NEWCODE
         do ii=1,4
            if(N_h_zf.eq.1) then
               kalman(ii,1) = ( cp_zf(ii,1,jzf) * h_zf(1,1,jzf) ) / cr_p
            else if(N_h_zf.eq.2) then
               kalman(ii,1) = ( cp_zf(ii,1,jzf) * h_zf(1,1,jzf)
     +              + cp_zf(ii,2,jzf) * h_zf(1,2,jzf) ) / cr_p
            else
               kalman(ii,1) = ( cp_zf(ii,1,jzf) * h_zf(1,1,jzf)
     +              + cp_zf(ii,2,jzf) * h_zf(1,2,jzf)
     +              + cp_zf(ii,3,jzf) * h_zf(1,3,jzf)
     +              + cp_zf(ii,4,jzf) * h_zf(1,4,jzf) ) / cr_p
            end if
         enddo
*#endif

*     ******* fudge factors for small dz
**         if(abs(dz).lt.1.) then
**            kalman(3,1) = kalman(3,1) / 100.
**            kalman(4,1) = kalman(4,1) / 100.
**         end if
         
*     **** updated x value

         do ii=1,4
            xs_zf(ii,jzf) = xp_zf(ii,jzf) + kalman(ii,1) * xr_p
         enddo
*%%%
**         xs_zf(5,jzf) = 0.
         xs_zf(5,jzf) = qpt
         
#ifdef TFSMFIN_DEBUG
**         if(iizf.eq.1.or.iizf.eq.nzf_s)
         if(ift.eq.ift)
     +        print '(" tfsmfin.F update ----- jzf,x1-4",i5,4f9.3 )'
     +        ,jzf,xs_zf(1,jzf),xs_zf(2,jzf),xs_zf(3,jzf),xs_zf(4,jzf)
#ifdef TFSMFIN_DEBUG_TEST
         if(ift.eq.114)
     +        print '(" tfsmfin.F xr_p,kalm ",5f9.3 )'
     +        ,xr_p,kalman(1,1),kalman(2,1),kalman(3,1),kalman(4,1)
         if(ift.eq.114)
     +        print '(" tfsmfin.F dz,xp ",5f9.3 )'
     +        ,dz,xp_zf(1,jzf),xp_zf(2,jzf),xp_zf(3,jzf),xp_zf(4,jzf)
         if(ift.eq.114)
     +        print '(" tfsmfin.F izf,xs ",i3,4f9.3 )'
     +        ,izf,xs_zf(1,izf),xs_zf(2,izf),xs_zf(3,izf),xs_zf(4,izf)
         if(ift.eq.114)
     +        print '(" tfsmfin.F c31,h1i ",5f9.3 )'
     +        ,cp_zf(3,1,jzf),h_zf(1,1,jzf),h_zf(1,2,jzf)
     +        ,h_zf(1,3,jzf),h_zf(1,4,jzf)
#endif
#endif
                  
*     **** updated cov matrix

*#ifdef TFSMFIN_NEWCODE

         if(N_h_zf.eq.1) then
            
            h_1 = h_zf  (1,1,jzf)
            k_1 =  kalman(1,1) * h_1 
            k_2 =  kalman(2,1) * h_1
            k_3 =  kalman(3,1) * h_1
            k_4 =  kalman(4,1) * h_1
            
            c11 = cp_zf(1,1,jzf)
            c12 = cp_zf(1,2,jzf)
            c13 = cp_zf(1,3,jzf)
            c14 = cp_zf(1,4,jzf)
            
            cs_zf(1,1,jzf) = (1.d0 - k_1) * c11
            cs_zf(1,2,jzf) = (1.d0 - k_1) * c12
            cs_zf(1,3,jzf) = (1.d0 - k_1) * c13
            cs_zf(1,4,jzf) = (1.d0 - k_1) * c14
            
            cs_zf(2,1,jzf) = cs_zf(1,2,jzf)
            cs_zf(2,2,jzf) = cp_zf(2,2,jzf) - k_2 * c12
            cs_zf(2,3,jzf) = cp_zf(2,3,jzf) - k_2 * c13
            cs_zf(2,4,jzf) = cp_zf(2,4,jzf) - k_2 * c14
            
            cs_zf(3,1,jzf) = cs_zf(1,3,jzf) 
            cs_zf(3,2,jzf) = cs_zf(2,3,jzf)
            cs_zf(3,3,jzf) = cp_zf(3,3,jzf) - k_3 * c13
            cs_zf(3,4,jzf) = cp_zf(3,4,jzf) - k_3 * c14
            
            cs_zf(4,1,jzf) = cs_zf(1,4,jzf) 
            cs_zf(4,2,jzf) = cs_zf(2,4,jzf)
            cs_zf(4,3,jzf) = cs_zf(3,4,jzf)
            cs_zf(4,4,jzf) = cp_zf(4,4,jzf) - k_4 * c14

         else if(N_h_zf.eq.2) then
            
            h_1 = h_zf  (1,1,jzf)
            h_2 = h_zf  (1,2,jzf)
            k_1 =  kalman(1,1)  
            k_2 =  kalman(2,1) 
            k_3 =  kalman(3,1) 
            k_4 =  kalman(4,1)  
            
            c11 = cp_zf(1,1,jzf)
            c12 = cp_zf(1,2,jzf)
            c13 = cp_zf(1,3,jzf)
            c14 = cp_zf(1,4,jzf)
            
            c21 = cp_zf(2,1,jzf)
            c22 = cp_zf(2,2,jzf)
            c23 = cp_zf(2,3,jzf)
            c24 = cp_zf(2,4,jzf)
            
            cs_zf(1,1,jzf) = c11 - kh_1 ( c11 , c21 ) 
            cs_zf(1,2,jzf) = c12 - kh_1 ( c12 , c22 )
            cs_zf(1,3,jzf) = c13 - kh_1 ( c13 , c23 )
            cs_zf(1,4,jzf) = c14 - kh_1 ( c14 , c24 )
            
            cs_zf(2,1,jzf) = cs_zf(1,2,jzf)
            cs_zf(2,2,jzf) = cp_zf(2,2,jzf) - kh_2 ( c12 , c22 )
            cs_zf(2,3,jzf) = cp_zf(2,3,jzf) - kh_2 ( c13 , c23 )
            cs_zf(2,4,jzf) = cp_zf(2,4,jzf) - kh_2 ( c14 , c24 )
            
            cs_zf(3,1,jzf) = cs_zf(1,3,jzf) 
            cs_zf(3,2,jzf) = cs_zf(2,3,jzf)
            cs_zf(3,3,jzf) = cp_zf(3,3,jzf) - kh_3 ( c13 , c23 )
            cs_zf(3,4,jzf) = cp_zf(3,4,jzf) - kh_3 ( c14 , c24 )
            
            cs_zf(4,1,jzf) = cs_zf(1,4,jzf) 
            cs_zf(4,2,jzf) = cs_zf(2,4,jzf)
            cs_zf(4,3,jzf) = cs_zf(3,4,jzf)
            cs_zf(4,4,jzf) = cp_zf(4,4,jzf) - kh_4 ( c14 , c24 )
            
         else

            do ii=1,5
               do jj=1,5
                  cs_zf(ii,jj,jzf) = 0.
               enddo
            enddo
            
            do ii=1,4
               do jj=ii,4
                  sum = 0.
                  do kk=1,4
                     if (ii.eq.kk) then
                        sum = sum +
     +                       (1.d0 - kalman(ii,1) * h_zf(1,kk,jzf)) 
     +                       * cp_zf(kk,jj,jzf)
                     else
                        sum = sum - kalman(ii,1) * h_zf(1,kk,jzf) 
     +                       * cp_zf(kk,jj,jzf)
                     endif
                  enddo
                  cs_zf(ii,jj,jzf) = sum
                  if (ii.ne.jj) cs_zf(jj,ii,jzf) = sum
               enddo
            enddo
            
         endif      !    end of update cov matrix
*#endif
         
         if (diag_level.ge.5) then
            print *,' cp_zf(2,2,jzf)...cp_zf(4,4,jzf)=',
     +           cp_zf(2,2,jzf), cp_zf(4,2,jzf), cp_zf(2,4,jzf),
     +           cp_zf(4,4,jzf)
            
            print '((a),4f10.3)',' kalman=', (kalman(ii,1),ii=1,4)
            
            print *,' xr_p=', xr_p
         endif
         
         if (diag_level.ge.5) then
            print '((a)/4(f10.3,3x,4f10.3/))',
     +           ' xs_zf(,), cs_zf(1,1,jzf)...cs_zf(4,4,jzf)=',
     +           (xs_zf(jj,jzf),(cs_zf(ii,jj,jzf),ii=1,4),jj=1,4)
         endif

#ifdef TFSMFIN_DEBUG
            print '(i4,(a)/4(f10.3," / ",4(e11.4,x)/))',iizf,
     +           ' xs_zf(,), cs_zf(1,1,jzf)...cs_zf(4,4,jzf)=',
     +           (xs_zf(jj,jzf),(cs_zf(ii,jj,jzf),ii=1,4),jj=1,4)
#endif

*     **** updated residual

*#ifdef TFSMFIN_NEWCODE
         if(N_h_zf.eq.1) then
            ihk = 1. - h_zf(1,1,jzf) * kalman(1,1)
         else if(N_h_zf.eq.2) then
            ihk = 1. - h_zf(1,1,jzf) * kalman(1,1)
     +           - h_zf(1,2,jzf) * kalman(2,1)
         else  
            ihk = 1. - h_zf(1,1,jzf) * kalman(1,1)
     +           - h_zf(1,2,jzf) * kalman(2,1)
     +           - h_zf(1,3,jzf) * kalman(3,1)
     +           - h_zf(1,4,jzf) * kalman(4,1)
     +           - h_zf(1,5,jzf) * kalman(5,1)
         end if
*#endif

         xr_zf(1,jzf) = xr_p * ihk
         cr_zf(1,1,jzf) = cm_zf(1,1,jzf) * ihk
         
*     **** updated chi2 contribution
         ch_zf(jzf) = xr_zf(1,jzf)**2 / cr_zf(1,1,jzf)
         
         if (diag_level.ge.5) then
            print *,'>ihk, xr_zf(1,jzf), cr_zf(1,1,jzf), ch2=',
     +           ihk, xr_zf(1,jzf), cr_zf(1,1,jzf), ch_zf(jzf)
            print *,' h_zf(1,2,jzf), h_zf(1,4,jzf), cr_zf(1,1,jzf)=',
     +           h_zf(1,2,jzf), h_zf(1,4,jzf), cr_zf(1,1,jzf)
         endif
         
         if (diag_level.ge.3)
     +        print '(i3,4f10.3,4f10.3)',
     +        iizf, (xs_zf(ii,jzf),ii=1,4)
     +        , (dsqrt(cs_zf(ii,ii,jzf)),ii=1,4)
         
*     **** smoothed zf info
         if (iizf.eq.1) then
            cht_zf(jzf) = ch_zf(jzf)
            prevs_zf(jzf) = 0
         else
            cht_zf(jzf) = cht_zf(izf) + ch_zf(jzf)
            prevs_zf(jzf) = izf
         endif

      enddo                     ! end of filter loop
            
      if (diag_level.ge.5) then
         call tfls()
         call tfwait()
      endif
      
#ifdef TFSMFIN_DEBUG
      izf = ind_s(1)
      print '(" tfsmfin.F end x1-4",4f9.3 )'
     +     ,xs_zf(1,izf),xs_zf(2,izf),xs_zf(3,izf),xs_zf(4,izf)
      izf = ind_s(nzf_s)
      print '(" tfsmfin.F beg x1-4",4f8.3 )'
     +     ,xs_zf(1,izf),xs_zf(2,izf),xs_zf(3,izf),xs_zf(4,izf)
#endif
      
 999  end
