*-- Author :                                     12/04/01  A. Spiridonov
* changed :
*

*#define TFSMFIN_DEBUG

      subroutine tflfit(ift)

*     **** 3D linear fit of candidate (outside magnet!)
*          tailored from tfsmfin()
*

      implicit none
#include "rang/zf.fi"
#include "rang/zfpar.fi"
#include "rang/zfmode.fi"
#include "rang/zplx.fi"

      real p_start(5)
      integer nzfmx_s
      parameter (nzfmx_s=300)
      integer ind_s(nzfmx_s), nzf_s, iizf, iseg, ift, jft, izf, jpl,
     +     xsig, ii, jj, kk, jzf, jzf_ylast, ih, ifail, jzf_xlast
      integer ind_s1(nzfmx_s)
      double precision xs_f(5),cs_f(5,5)

      double precision dz, du, cs_thetu, dnoise, xm_p, xr_p,
     +     cr_p, hch, kalman(dimp,dimm), ihk, m_u, sum, dppi(4,4),
     +     ak(4,4)
      
      integer kkzf, kzf, ihkk, tfmitoqpt, imc, mimp, nnmimp, imcass
      real fracmc,tfqptest
      character*1 csig
      
      real pnoise, xyfac, tupmc, tx, ty, qp, qpt
      integer ll, mm, seg_first(2), seg_last(2), tfmc
      double precision f(4,4)
      parameter (xyfac=1.)
      logical lsmoo

**      parameter (lsmoo=.true.)
**      parameter (lsmoo=.false.)
      data lsmoo/.true./

      integer N_h_zf
      double precision h_1,h_2,k_1,k_2,k_3,k_4
      double precision c21
      double precision kh_1,kh_2,kh_3,kh_4
            
      double precision f13,f24,x,y,z

      double precision FL_1

      double precision c11 , c12 , c13 , c14 
      double precision       c22 , c23 , c24 
      double precision             c33 , c34 
      double precision                   c44
 
      double precision g11 , g12 , g13 , g14 
      double precision g21 , g22 , g23 , g24 
      double precision g31 , g32 , g33 , g34 
      double precision g41 , g42 , g43 , g44 

      equivalence (f13,f(1,3)),(f24,f(2,4))

#include "arte/Arte.fi"      
#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "auto/MIMP.fi"
#include "auto/MTRA.fi"
#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
#include "auto/MIMP.ff"
#include "auto/MTRA.ff"
      
      kh_1(x,y) = k_1 * ( h_1 * x + h_2 * y )
      kh_2(x,y) = k_2 * ( h_1 * x + h_2 * y )
      kh_3(x,y) = k_3 * ( h_1 * x + h_2 * y )
      kh_4(x,y) = k_4 * ( h_1 * x + h_2 * y )

      FL_1(x,y) = x + f13*y 
*
*================================================================
*
            
      lsmoo = .not.fast_mode_zfpar      ! no smoother for fast mode

      if (l_diag) then
         print *,' tfsmfi starting for ift=', ift
         call tfwait()
      endif
      
*     **** get izf of hits
      nzf_s = 0
      do 10 iseg=1,2
         if (iseg.eq.1) then
            jft = ift
         else
            jft = prev_ft(jft)
            if (jft.le.0) then
               print *,' () tfsmfi: missing segment iseg=', iseg
               go to 10
            endif
         endif
         
         do 20 iizf=1,nhit_ft(jft)
            if (iizf.eq.1) then
               izf = last_ft(jft)
               seg_first(iseg) = izf
            else
               izf = prev_zf(izf)
               seg_last(iseg) = izf
            endif
            if (izf.le.0) then
               print *,' tfsmfi: izf=', izf
               go to 20
            endif
            if (nzf_s.ge.100) then
               if (nzf_s.eq.100) print *,' () tfsmfi: nzf_s=',nzf_s
               if (nzf_s.ge.nzfmx_s) then
                  print *,' () tfsmfi: nzf_s=',nzf_s
                  go to 999
               endif
            endif
            if(plane_zf(izf).gt.0.and.hit_zf(izf).gt.0) then ! skip dummy hit
               nzf_s = nzf_s + 1
               ind_s(nzf_s) = izf
            end if
 20      continue
 10   continue

      if(stat_ft(ift).ne.2) then
         seg_first(2) = seg_first(1)
         seg_last(2) = seg_last(1)
      endif
      
*     **** sort according to decreasing z (if smooth )

      if(lsmoo) then
         call sortzv(z_zf,ind_s,nzf_s,+1,+1,+1)
      else
         call sortzv(z_zf,ind_s,nzf_s,+1, 0,+1)
      endif
            
*     **** printout
      if (diag_level.ge.3) then
         print *,' tfsmfi (t): hits to be fitted:'
         do iizf=1,nzf_s
            izf = ind_s(iizf)
            ih = hit_zf(izf)
            print '((a),4i6, f10.4,2f7.3)',
     +           ' izf, ih, imc, z, MC=', izf, hit_zf(izf)
     +           , plane_zf(izf),tfmc(izf),z_zf(izf),sign_zf(izf),
     +           fhitb_q(hit_zf(izf))
         enddo
      endif
      if (l_diag) call tfwait()
      
*     **** get pnoise
*          will be defined for 1st hit
*      pnoise = 10.

#ifdef TFSMFIN_DEBUG
      print '(" tfsmfin.F : ====== ift,stat ",2i5)',ift,stat_ft(ift)
      do iizf=1,nzf_s 
         jzf = ind_s(iizf) 
         jpl = plane_zf(jzf)
         xsig = sign_zf(jzf)
         ih = hit_zf(jzf)
         if(ift.eq.ift)
     +        print '(" tfsmfin.F : i,j,ih,z,x,e,a ",i2,i3,i5,4f9.3 )'
     +        ,iizf,jzf,ih,fhitb_z(ih),fhitb_x(ih)+xsig*fhitb_q(ih)
     +        ,fhitb_r(ih),sntot_plx(jpl)   
      end do
#endif

#ifdef TFSMFIN_NOREFIT

      do iizf=1,nzf_s 
         jzf = ind_s(iizf) 
         do ii=1,5
            xs_zf(ii,jzf) = xx_zf(ii,jzf)
            do jj = 1,5
               cs_zf(ii,jj,jzf) = cx_zf(ii,jj,jzf)
            enddo
         enddo

*     **** smoothed zf info
         if (iizf.eq.1) then
**            cht_zf(jzf) = ch_zf(jzf)
            prevs_zf(jzf) = 0
         else
**            cht_zf(jzf) = cht_zf(izf) + ch_zf(jzf)
            izf = ind_s(iizf-1) 
            prevs_zf(jzf) = izf
         endif

      end do

      first_ft(ift) = ind_s(1) 
      last_ft(ift)  = ind_s(nzf_s) 
      nhit_ft(ift)  = nzf_s 
      prev_ft(ift)  = 0 
      stat_ft(ift)  = 3 

**      print *,'tfsmfin.F : ift ',ift,' last_ft(ift) ',last_ft(ift)

      go to 999

#endif

*    *****  start parameters

      jzf = ind_s(1)
      
      jpl = plane_zf(jzf)
      xsig = sign_zf(jzf)
      ih = hit_zf(jzf)
         
      if (z_zf(seg_first(2)).lt.z_zf(seg_last(2))) then
         jzf_xlast = seg_first(2)
      else
         jzf_xlast = seg_last (2)
      endif
      if (z_zf(seg_first(1)).lt.z_zf(seg_last(1))) then
         jzf_ylast = seg_first(1)
      else
         jzf_ylast = seg_last (1)
      endif
      
#ifdef TFSMFIN_DEBUG
      print '(" tfsmfin.F xlast,ylast ",2i5)',jzf_xlast,jzf_ylast
#endif
      
      p_start(1) = xx_zf(1,jzf_xlast)
     +     + (z_zf(jzf) - z_zf(jzf_xlast)) * xx_zf(3,jzf_xlast)
      p_start(2) = xx_zf(2,jzf_ylast)
     +     + (z_zf(jzf) - z_zf(jzf_ylast)) * xx_zf(4,jzf_ylast)
      p_start(3) = xx_zf(3,jzf_xlast)
      
      p_start(4) = xx_zf(4,jzf_ylast)
      
      tx = xx_zf(3,jzf_xlast)
      ty = xx_zf(4,jzf_ylast)
      qpt = - tfqptest(z_zf(jzf_xlast),
     +     sngl(xx_zf(1,jzf_xlast)), tx) * 1.031
      qpt = qpt * sqrt( (1.+tx**2)/(1.+tx**2+ty**2) )
      
      p_start(5) = qpt

      call tfindfit(ift,nzfmx_s,ind_s,nzf_s,p_start)
      
*     **** backward-filter

      if (.not.lsmoo) then
*     **** store 1st point

         izf = ind_s(nzf_s)
         do ii=1,5
            xs_f(ii) = xs_zf(ii,izf)
            p_start(ii) = xs_zf(ii,izf)
            do jj=1,5
               cs_f(ii,jj) = cs_zf(ii,jj,izf)
            enddo
         enddo

*       ****   change order of sorting  according to decreasing z
         do ii=1,nzf_s
            ind_s1(ii) = ind_s(ii)
         end do
         do ii=1,nzf_s
            ind_s(nzf_s-ii+1) = ind_s1(ii)
         end do

         call tfindfit(ift,nzfmx_s,ind_s,nzf_s,p_start)
         
*     **** restore 1st point

         izf = ind_s(1)
         do ii=1,5
            xs_zf(ii,izf) = xs_f(ii)
            do jj=1,5
               cs_zf(ii,jj,izf) = cs_f(ii,jj)
            enddo
         enddo

      endif                                     ! end of backward-filter

*     **** backward-smoother

      if (lsmoo) then
         if (diag_level.ge.3)
     +        print *,' start smoothing ----------------------------->'
         do iizf=nzf_s-1,1,-1
            jzf = ind_s(iizf+1)
            izf = ind_s(iizf)
            
*     **** transport distance
            dz = z_zf(jzf) - z_zf(izf)
            
*     **** construct transport matrix F_(k+1) = f
            do ii=1,4
               do jj=1,4
                  if (ii.eq.jj) then
                     f(ii,jj) = 1.
                  elseif ((ii.eq.1.and.jj.eq.3)
     +                    .or.(ii.eq.2.and.jj.eq.4)) then
                     f(ii,jj) = dz
                  else
                     f(ii,jj) = 0.
                  endif
               enddo
            enddo
            
*     **** construct gain matrix ak
            do ii=1,4
               do jj=1,4
                  dppi(ii,jj) = cp_zf(ii,jj,jzf)
               enddo
            enddo
            call dsinv(4,dppi,4,ifail)

            if (ifail.ne.0) then
*     *         call tfls()
               print *,' tfsmfi: smoothing status:'
               print '(a5,a6,a5,a4,a5,1x,2a4,2a6,10a10)',
     +              'izf', 'hit', 'pla', 'pre', 'mc', 'nh', 'fau',
     +              'ch2', 'z', 'x', 'mx', 'y', 'my', 'cu',
     +              'xmc', 'mxmc', 'ymc', 'mymc', 'cumc'
                              
               print *,' () tfsmfi: ifail=',ifail
               print *,'          matrix=',((dppi(ii,jj),ii=1,4),jj=1,4)
               print *,'    skip smoothing for ift=', ift,' jzf=', jzf
               call tfwait()
               stat_ft(ift) = 2
               go to 999
            endif
            
            do ii=1,4
               do jj=1,4
                  sum = 0.
                  do kk=1,4
                     do ll=1,4
                        sum = sum + cs_zf(ii,kk,izf) * f(ll,kk) 
     +                       * dppi(ll,jj)
                     enddo
                  enddo
                  ak(ii,jj) = sum
               enddo
            enddo
            
*     **** calculate smoothed parameters
            do ii=1,4
               sum = 0.
               do jj=1,4
                  sum = sum + ak(ii,jj) * (xs_zf(jj,jzf)-xp_zf(jj,jzf))
               enddo
               xs_zf(ii,izf) = xs_zf(ii,izf) + sum
            enddo
            
*     **** cov matrix of smoothed parameters
            do ii=1,4
               do jj=1,4
                  sum = 0.
                  do kk=1,4
                     do ll=1,4
                        sum = sum + ak(ii,kk)
     +                       * (cs_zf(kk,ll,jzf) - cp_zf(kk,ll,jzf))
     +                       * ak(jj,ll)
                     enddo
                  enddo
                  cs_zf(ii,jj,izf) = cs_zf(ii,jj,izf) + sum
               enddo
            enddo
            
*     **** no smoothed update of residuals etc yet!
            if (diag_level.ge.3) then
               print '(i3,4f10.3,4f10.3)',
     +              iizf, (xs_zf(ii,jzf),ii=1,4)
     +              , (dsqrt(cs_zf(ii,ii,jzf)),ii=1,4)
            endif
            
         enddo                  ! loop over hits
      endif                     ! smoother option
      
*     **** smoothed candidate info

      first_ft(ift) = ind_s(1)
      last_ft(ift)  = ind_s(nzf_s)
      nhit_ft(ift)  = nzf_s
      prev_ft(ift)  = 0
      stat_ft(ift)  = 3
      
      if (diag_level.ge.5) then
         call tfls()
         call tfwait()
      endif
      
#ifdef TFSMFIN_DEBUG
      izf = ind_s(1)
      print '(" tfsmfin.F 1st x1-4",4(x,e11.4))'
     +     ,(xs_zf(ii,izf),ii=1,4)
      print '("              ex1-4",4(x,e11.4))'
     +     ,(dsqrt(cs_zf(ii,ii,izf)),ii=1,4)
      izf = ind_s(nzf_s)
      print '(" tfsmfin.F Lst x1-4",4(xe11.4))'
     +     ,(xs_zf(ii,izf),ii=1,4)
      print '("              ex1-4",4(x,e11.4))'
     +     ,(dsqrt(cs_zf(ii,ii,izf)),ii=1,4)
#endif
      
 999  end
