// grover package

#include "grover/grover.hh"
#include "arte/RSEG_cmp.hh"

namespace K0SLAMBDA {
  void K0LambdaSelectInit(void);
  void K0LambdaSelectInit(char *);
  void K0LambdaSelectInit(float,float,float,char *);
  void K0LambdaSelectInit(float,float,float,int,char *);
  void K0LambdaSelectInit(float,float,float);
  int K0LambdaSelect(void);
  void K0LambdaSelectClose(void);
  void K0LambdaSelectMassWindow( float k0low, float k0high, float Lmbdlow, float Lmbdhigh );
  void rc_Select_K0S_Lambda_OnlineMode();
  bool rcSelect_K0S_Lambda();
  int trSelect( vector< ArtePointer<RTRA> > &rtra, int &clpos, int &clneg);
  float distance(float vect[3],float pos[3],float poin[3]);
  void createRVER(GroverVertexList *rvv, int part);
  bool MassCut(int cand, float mass);
};

using namespace K0SLAMBDA;

// Ntuple....

typedef struct{
  float run;
  float evt;
  float time;
  float bx;
  float tcode;
  float part;
  float chi2;
  float dist;
  float distv;
  float ntr;
  float mass;
  float primtr;
  float prob;
  float xs;
  float ys;
  float zs;
  float q1;
  float nhtr1;
  float px1;
  float py1;
  float pz1;
  float px1lab;
  float py1lab;
  float pz1lab;
  float q2;
  float nhtr2;
  float px2;
  float py2;
  float pz2;
  float px2lab;
  float py2lab;
  float pz2lab;
  float flight;
  float nprim;
  float primx;
  float primy;
  float primz;
  float vxf1;
  float vyf1;
  float	vzf1;
  float vtxf1;
  float vtyf1;
  float vpf1;
  float vxe1;
  float vye1;
  float	vze1;
  float vtxe1;
  float vtye1;
  float vpe1;
  float txf1;
  float tyf1;
  float	tzf1;
  float ttxf1;
  float ttyf1;
  float tpf1;
  float txe1;
  float tye1;
  float	tze1;
  float ttxe1;
  float ttye1;
  float tpe1;
  float vxf2;
  float vyf2;
  float	vzf2;
  float vtxf2;
  float vtyf2;
  float vpf2;
  float vxe2;
  float vye2;
  float	vze2;
  float vtxe2;
  float vtye2;
  float vpe2;
  float txf2;
  float tyf2;
  float	tzf2;
  float ttxf2;
  float ttyf2;
  float tpf2;
  float txe2;
  float tye2;
  float	tze2;
  float ttxe2;
  float ttye2;
  float tpe2;
}ntuple;

static char Nt[]="run,evt,time,bx,tcode,part,chi2,dist,distv,ntr,mass,nprimtr,vprob,xs,ys,zs,q1,nhtr1,px1,py1,pz1,px1l,py1l,pz1l,q2,nhtr2,px2,py2,pz2,px2l,py2l,pz2l,flgt,nprim,primx,primy,primz,vxf1,vyf1,vzf1,vtxf1,vtyf1,vpf1,vxe1,vye1,vze1,vtxe1,vtye1,vpe1,txf1,tyf1,tzf1,ttxf1,ttyf1,tpf1,txe1,tye1,tze1,ttxe1,ttye1,tpe1,vxf2,vyf2,vzf2,vtxf2,vtyf2,vpf2,vxe2,vye2,vze2,vtxe2,vtye2,vpe2,txf2,tyf2,tzf2,ttxf2,ttyf2,tpf2,txe2,tye2,tze2,ttxe2,ttye2,tpe2";


static char Nt_mini[]="run,evt,time,bx,tcode,part,chi2,dist,distv,ntr,mass,nprimtr,vprob,xs,ys,zs,q1,nhtr1,px1,py1,pz1,px1l,py1l,pz1l,q2,nhtr2,px2,py2,pz2,px2l,py2l,pz2l,flgt,nprim,primx,primy,primz,x1,y1,z1,x2,y2,z2";


