
// *****************************************************************************
//
// source:    rcClassDIELEID.C
//
// type:      source code
//
// created:   10 Nov 2000
//	
// author:    Dr. Andreas Gellrich
//            HERA-B Collaboration
//            Humboldt-University Berlin
//            Physics Department
//            Invalidenstr. 110
//            10115 Berlin
//            Germany
//            E-mail: Andreas.Gellrich@desy.de
//
// symbol:    rcClassRECYPS
//
// called by: rcClassify
//
// purpose:   check invariant mass of di-lepton candidate
//
// hints:     do NOT set flagdst here!
//
// changes:
// 04 Jul 2001 (MV) created from rcClassRECYPS
// *****************************************************************************

// ARTE includes
#include "arte/arte.hh"
#include "farm/farm.hh"

// externals
extern int   FADEB;
extern float cutJPSIEE;

// globals
float massDIELEID = 0.0;

//
// function code
//
int
rcClassDIELEID()
{
  // show up
  ARTE_mark( "rcClassDIELEID 0", 0 );

  int rc = 0;

  // print
  if( FADEB ){
    cout << "DIELEID: ee-mass=" << massDIELEID << endl;
  }

  // e+ e- candidate
  if( massDIELEID > cutJPSIEE ){
    rc |= 0x1;
    cout << " DIELEID: Found e+e- candidate m=" << massDIELEID << endl;
  }
  
  // show up
  ARTE_mark( "rcClassDIELEID 1", 0 );
  
  return rc;
}
