 
// ********************************************************************
//
//  Routine:      rcPidRICH.C
//
//  Description:  rich reconstruction based on tracks
//
//  Modification:
//  -- bug fix in global alignment constant subtraction 29/10/99 T.Oest
//  -- likelihood-search-syntax changed according to the new syntax of rire 1.12.99 D. Samtleben
//  -- RISE particle ID added                           10/02/00 T.Oest
//  -- RISE particle ID changed                         13/06/00 D.Dujmic
//  -- moved to rcPidRICH()                             02/01/01 AG
//  -- clean RTRA after reconstruction                  12/01/01 DD
//  -- replace old seeded search in RISE with new function Ring() 15.05.01 D. Dujmic
//
// ********************************************************************
 
//  Modification:
//  14 July 2000 (RP) call  more than one algorithm 
//  27 Nov  2000 (Rok Pestotnik) call the RITER module is called last so that RICH  likelihoods are  consistent 

#include <iostream.h>
#include <arte/arte.hh>
#include <stdlib.h>

void ringsearchRTRA();
int RICHrec(int level=10);
extern "C" {  void Riter_evnt_();  }
int copyRTRAtoRTRI(int module);
int copyRTRItoRTRA(int module);
void rcResetRichRtra(float x=-1);
int Ring();

int
rcPidRICH( int module )
{

//-------------------------------------------------------------------
//  RIRE
//-------------------------------------------------------------------

   if (module & 2) { RICHrec(); copyRTRAtoRTRI(1);   rcResetRichRtra(0); } 

//-------------------------------------------------------------------
//  RISE
//-------------------------------------------------------------------

  if (module  & 4) { ringsearchRTRA(); Ring(); copyRTRAtoRTRI(0);  rcResetRichRtra(0); } 
 
//-------------------------------------------------------------------
//  RITER
//-------------------------------------------------------------------

  if (module & 1) { Riter_evnt_(); copyRTRAtoRTRI(1); rcResetRichRtra(0); } 

//-------------------------------------------------------------------
//  clear RICH likelihoods from RTRA bank   
//-------------------------------------------------------------------
  rcResetRichRtra(-1);
  

  return 0;      
}
