//--*-C++-*--
#ifndef _RICHSEARCHDB_H_
#define _RICHSEARCHDB_H_
#include "rich/ricutil.h"
#include "rise/RingSearchAttrib.h"

extern "C" {
#include "table.h"
#include "tablecs.h"
}

class RingSearchDB {

 public:
  
  static int distribute;

  inline RingSearchDB() { 
    // -- MC by default
    RingSearchAttrib::occupancyCut=10000; 
    RingSearchAttrib::peakThreshold=5;
    RingSearchAttrib::minSearchRadius=25*sqrt(RichRun::photon_fraction);
    if (RingSearchAttrib::minSearchRadius<20) RingSearchAttrib::minSearchRadius=20;
    RingSearchAttrib::maxSearchRadius=52.6*sqrt(RichRun::photon_fraction); 
    RingSearchAttrib::searchStep=-1; 
  }
  static void   getSearchParameters (int run_no, int rev_no=TABLEmaxrev, int verb=0);
  static void   fillSearchParameters(int run_no, float *parameters,int verb=0);

  inline float &minSearchRadius() { return RingSearchAttrib::minSearchRadius; }
  inline float &maxSearchRadius() { return RingSearchAttrib::maxSearchRadius; }
  inline float &searchStep()      { return RingSearchAttrib::searchStep; }
  inline int   &occupancyCut()    { return RingSearchAttrib::occupancyCut; }
  inline int   &threshold()       { return RingSearchAttrib::peakThreshold; }

};

extern "C"
int UpdateRadiusDatabase(int major, float *parameters,int verb=0);

#endif
