#include  <stdio.h>

#include "silarte/silarte.hh"

#include "aframelib.h"
#include "iol.h"
#include "vdsleda.h"
#include "silraw.h"
#include "marvin.h"
#include "holmes.h"
#include "cats/cats.h"
#include "svdalign.h"
#include "sileff.h"
// #include "vdsrhp.h"

#include  "grr.h"

// some arguments for aframe
extern       int    nArg;
extern const char **vArg;

//-----------------------------------------------------------------

int SvdIolInit()
{
  static int first = 1;

  char *routine = "SvdIolInit";

  // return when called more then once
  if ( !first ) {
    if ( silarte_iol.debug_mode.value )
      aframe_mess(routine,GRR_SINFO,
		  "SvdIolInit already called - skipping...");
    return GRR_OK;
  }
  first = 0;

  // Initilialize some control words
  //  aframe_store_program_name(vArg[0]);
  aframe_store_program_name("Arte");

  // initialize parameters of other packages
  aframe_param_init();
  iol_param_init();
  vdsleda_param_init();
  silraw_param_init();
  silarte_param_init();
  marvin_param_init();
  holmes_param_init();
  cats_param_init();
  svdalign_param_init();
  sileff_param_init();
  //  vdsrhp_param_init();

  // preferences are loaded here
  if ( aframe_process_args(nArg, vArg, AFRAME_CLI) != AFRAME_OK ) {
    aframe_mess(routine,GRR_SFATAL,"Error processing arguments.");
    return GRR_FISHY;
  }

  return GRR_OK;
}
