#ifndef __MUSLTMAP_H__
#define __MUSLTMAP_H__
#ifdef __cplusplus 
extern "C" 
{
#endif
  typedef struct 
  {
    char hwc[12];              /* muon hardw_identifier */ 
    char spl[5];               /* spl name (GESL like) */
    int nsl;                   /* identical to nsl in GESL */
    int lay;                   /* layer within superlayer */
    int sec;                   /* sector within superlayer */
    int mod;                   /* module within superlayer */
    unsigned char moduletype;  /* WH: for debugging */
    unsigned short fedid;      /* FEDid */
    unsigned char  chan1;      /* first channel on FED */
    unsigned char  chan2;      /* last channel on FED */
    unsigned short gedeid;     /* GEDEid */
    unsigned char wire1;       /* first wire on GEDE */
    unsigned char wire2;       /* last wire on GEDE (WH: not needed !)*/
    unsigned char vme_addr;    /* VME address */
    unsigned char sharc_pos;   /* connector on sharc*/
    unsigned char vme_num ;    /* VME number (id) */
  } musltMapEntry ;
  musltMapEntry* MuSltMap(int* nentries);
  void MuSltMapPrint(musltMapEntry* pmap, int* nel);
#ifdef __cplusplus 
}
#endif
#endif





