/*-------------------------------------------------------------------*/
/*  First, take care of the inclusions.                              */
/*  System includes                                                  */
/*-------------------------------------------------------------------*/

#include <strings.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <unistd.h>
#include <iostream.h>

/*-------------------------------------------------------------------*/
/*  Project includes                                                 */
/*-------------------------------------------------------------------*/

#include "rpm.h"
#include "cna.h"
#include "grr.h"
#include "pub.h"
#include "cif.h"
#include "arte/arte.hh"
#include "vdsMAP.h"
#include "vdsGEDE.h"
#include "farm/farm.hh"
#include "database/keytable.h"
#include "itrarte/ITR_arte.h"
#include "OtrSlt.h"
#include "sltarte/kasltsim.hh"

/*-------------------------------------------------------------------*/
/*  Function declarations                                            */
/*-------------------------------------------------------------------*/

static int l2form_PipeInit(void);
int acReadVDS(int);
int acReadITR(int);
int acReadGlobal(int);
int acReadOTR(int KTstatus);
void acGlobalAlignmentForGEDE(unsigned int);

/*-------------------------------------------------------------------*/
/*  Variable declarations                                            */
/*-------------------------------------------------------------------*/

extern int  nArg;
extern char **vArg;

/*-------------------------------------------------------------------*/
/*  And now the stuff which can't be mangled.                        */
/*-------------------------------------------------------------------*/

extern "C"{
  
/*-------------------------------------------------------------------*/
/*  System includes                                                  */
/*-------------------------------------------------------------------*/

#include <errno.h>
  extern int errno;
  extern int sys_nerr;
#ifndef	__USE_BSD
  extern char *sys_errlist[];
#endif
  
/*-------------------------------------------------------------------*/
/*  Project includes                                                 */
/*-------------------------------------------------------------------*/

#include "libr.h"
#include "l2mode.h"
#include "l2format.h"
#include "trigger_format.h"
#include "l2trigtab.h"
  
/*-------------------------------------------------------------------*/
/*  Defines                                                          */
/*-------------------------------------------------------------------*/

#define COMP_M_GLOBAL   0x00000001
#define DB_START_KEY 17105
#define N_RTABS 29
  
/*-------------------------------------------------------------------*/
/*  Function Statements                                              */
/*-------------------------------------------------------------------*/
  
  static int l2fmt_sub(const char *tab,int id,CIF_format_tab **formatter);
  static int l2fmt_hdl(const CIF_raw_tab *urt, int N_raw, 
		       CIF_formatted_tab uft[], int n_max, int *N_updated);
  
  static int tfmt_sub(const char *tab,int id,CIF_format_tab **formatter);
  static int tfmt_hdl(const CIF_raw_tab *urt, int N_raw,
		      CIF_formatted_tab uft[], int n_max, int *N_updated);
  
/*-------------------------------------------------------------------*/
/*  Variable declarations                                            */
/*-------------------------------------------------------------------*/

  extern char Kcna[20];     // global used Online 
  extern int cna_no;        // global used StandAlone
  extern int RunNoToSimu;   // global from ARTE-MC
  extern int CnAkey;        // global from ARTE-MC
  extern int acFlagReadCnA; // global from ARTE-MC
  extern int KeyBookWasCalled;
  char Key[20];
  static int StandAlone = 0;
  static int mcflag = 0;
  static int CnA_K = 0;
  static int L2FormARTE_KTstatus = -2;

  //#ifdef L2_CnA //CnA Online Mode
  static char *tablename[N_RTABS] ={ "/SETUP_ALIGN:ACGA",
				     "/VDS_CONFIG:VDS/Chip", 
				     "/VDS_CONFIG:VDS/Fed",
				     "/VDS_CONFIG:VDS/Side",
				     "/VDS_CONFIG:VDS/Bondmap",
				     "/VDS_CONFIG:VDS/Chanstat",
				     "/OTR_CONFIG:OTR_NEDE_v1",
				     "/OTR_CONFIG:OTR_Cabling_v1",
				     "/OTR_CONFIG:OTR_Sharc_v1",
				     "/OTR_ALIGN:OTR_Align_v1",
				     "/OTR_STATUS:OTR_Dq_v1",
				     "/OTR_STATUS:OTR_RtMap_v1",
				     "/OTR_STATUS:OTR_RtHeader_v1",
				     "/OTR_STATUS:OTR_RtData_v1",
				     "/OTR_STATUS:OTR_T0_v1",
				     "/ITR_Setup:ITR/Chamber",
				     "/ITR_Setup:ITR/nesl",
				     "/ITR_Setup:ITR/nede",
				     "/ITR_Setup:ITR/Fed",
				     "/ITR_Setup:ITR/Chip",
				     "/ITR_MONITOR:ITR/Chanstat",
				     "/ITR_MONITOR:ITR/Ped",
				     "/ITR_MONITOR:ITR/Noise",
				     "/ITR_Align:ITR/Align",
				     "/MUON_DB:MuonHots",
				     "/MUON_DB:MuonConfig",
				     "/MUON_DB:MuonAlignment",
				     "/SLT_SETUP:L2SYMBOL_0",
				     "/SLT_SETUP:L2TRIG_0"};
  static int l2_rawtabid[N_RTABS];
  static int t_rawtabid[N_RTABS];
  static int ftabid;
  static int ttabid;
  //#endif
}// End of extern "C" statement.


extern "C" {int acReadMuon(int KTstatus);}

