//*****************************************************************************
//
// source:    util.c
//
// type:      source code
//
// created:   14 Nov 2000
//
// author:    Brian Petersen
//            E-mail: aagaard@nbi.dk
//
// symbol:    SLT_TriggerCount
//
// called by:
//
// purpose:   Match SLT track with VDS segment
//
// hints:
//
// changes:
// 14 Nov 2000 (BP) Creation
// 29 Nov 2000 (AG) added function name to printout
//
//*****************************************************************************

#include "sltinfo.h"

int SLT_TriggerCount(SLTTRIGTYPE type) {
  SLT_STATUS stat;
  SLT_TRIGGER trig;
  int i;
  int count=0;

  if (SLTReadDSLT()!=SLT_OK) 
    return 0;
  if (SLTStatus(&stat)!=SLT_OK) 
    return 0;
  if (!(stat.status&SLTEVENT_ACCEPT))
    return 0;
  for(i=0;i<stat.ntriggers;i++) {
    if (SLTTrigInfo(i,&trig)!=SLT_OK) {
      //         cout<<"SLT_TriggerCount: Error getting info on trigger number "<<i<<endl;
      continue;
    }
    if (trig.status==SLTTRIG_REJECT) 
      continue;
    if (trig.type==type) count++;
  }
  return count;
}
