// *****************************************************************************
//
// source:    L3_Event.hh
//
// type:      include file
//
// created:   06 Dec 1999
//
// authors:   Stefan Scharein, Ullrich Schwanke
//            HERA-B Collaboration
//            DESY Zeuthen
//            Platanenallee 6
//            D-15738 Zeuthen
//            Germany
//            email: scharein@ifh.de, schwanke@ifh.de
//
// changes:
//
// *****************************************************************************
#ifndef _L3_EVENT_HH_
#define _L3_EVENT_HH_
#include "L3_Defines.hh"
#include <iostream>
#include "L3_Timer.hh"
#include "L3_Silicon.hh"
#include "L3_Origin.hh"

class L3_Event {
public:
  inline L3_Event();
  inline L3_Event(const L3_Event&);
  inline L3_Event& operator = (const L3_Event&);
  inline void reconstruct(L3_Timer&);
  inline const L3_Silicon& silicon() const;
  inline const L3_Origin&  origin()  const;
  inline void release();
  inline void fill();

  inline void print() const;
  inline void printRecoSummary() const;  
private:
  L3_Silicon the_Silicon;
  L3_Origin  the_Origin;
};

#include "L3_Event.icc"

#endif
