/****************************************************************************
*   This routine will be called only if trigger cards are given in the kumac.
*   Those  particles of the input event (from the generator) which fullfill 
*   the trigger conditions are traced first and after tracing them this 
*   subroutine is called. Here the user can make additional cuts  and decide 
*   whether to take the event or not.
*   The first argument in the subroutine call (vector<int> *ptrig) is a 
*   integer STL vector pointer which contains the track numbers in the MTRA 
*   table which fullfill the trigger conditions.
*   The MTRA tables are filled except for relations to MIMP and MCAL tables.
*   (these don't exist at that moment). The only information which can be
*   given in ustrig() is the number of MIMP's, MCAL's which exist for the 
*   given track. The second argument in the subroutine call 
*   (vector<int> *nhit) is a integer STL vector pointer which contains the
*   MIMP/NCAL numbers produced by this track (-1 means the track itself
*   has no MIMP's /MCAL's, but daughters of it have)
*   In case the user don't want to have further tracing (and writing out) 
*   the given event, he has to set a geantflag gcflag_.ieotri different from 
*   zero.
*   The following code is a demonstration:
*
*   #include <stdio.h>
*   #include <vector.h>
*   #include "arte/arte.hh"
*   #include "gean/gcflag.h"
*
*   void ustrig(vector<int> *ptrig, vector<int> *nhit) {
*
*     if(ptrig->size() == 0) { 
*        gcflag_.ieotri = 1;
*        return;
*     }
*
*     for (unsigned i=0; i<ptrig->size(); i++) {
*       vector<int>::iterator nt = ptrig->begin() + i;
*       vector<int>::iterator nh = nhit->begin() + i;
*       ArtePointer<MTRA> mt(*nt);
*       printf("ustrig: MTRA-index,pz,nhit %d %f %d \n",mt.index(),mt->pz,*nh);
*    }
*   }
*
*   For use without triggering it is sufficient to have only 
*****************************************************************************/
#include <vector.h>
void ustrig(vector<int> *ptrig, vector<int> *nhit) {}



