*CMZ :          20/05/96  12.58.00  by  Unknown
*-- Author :   T.Lohse
c
c-------------------------------------------------------------
c
c       subroutine:   VTWINI(iw)
c
c       input:    iw = wire index                       Int
c                 if 0 ===> loop over all wires
c
c       output:   none
c
c       action:   initializes wire-covariance matrix for wire iw
c                 iw=0 ===> all wires initialized
c
c-------------------------------------------------------------
c
      subroutine  VTWINI(iw)

      implicit none
      integer iw

#include "vt/vtdat.fi"
#include "vt/vtwire.fi"
#include "vt/vtpatt.fi"

      integer i, imin, imax
      double precision 
     1  cp,sp,ct,st,cp2,sp2,ct2,st2,term1,term2
      double precision 
     1  slw2,stw2
      double precision 
     1  huge 
      data huge / 100.d0 /

      if ( iw .lt. 0 .or. iw .gt. nw )   return

      if (iw.eq.0) then
        imin = 1
        imax = nw
      else
        imin = iw
        imax = iw
      endif

      do  i = imin, imax
        ntrwi(i) = 0
      enddo

      do  i = imin, imax
        cp = cos(phiw(i))
        sp = sin(phiw(i))
        ct = cos(thew(i))
        st = sin(thew(i))
        cp2 = cp**2
        sp2 = sp**2
        ct2 = ct**2
        st2 = st**2
        slw2 = siglw(i)**2
        stw2 = sigtw(i)**2
        term1 = ct2*huge + st2*slw2
        term2 = huge - slw2
        Cw(1,1,i) = cp2*term1 + sp2*stw2
        Cw(1,2,i) = sp*cp*(term1-stw2)
        Cw(2,1,i) = Cw(1,2,i)
        Cw(1,3,i) = cp*st*ct*term2
        Cw(3,1,i) = Cw(1,3,i)
        Cw(2,2,i) = sp2*term1 + cp2*stw2
        Cw(2,3,i) = sp*st*ct*term2
        Cw(3,2,i) = Cw(2,3,i)
        Cw(3,3,i) = st2*huge + ct2*slw2
      enddo

      return
      end
